:- module(iana, [iana/3]).

/** <module> IANA defined language list.
 *
 * All IANA language prefixes to be used in literal language assignment.
 *
 * * * * * * * * * * * * * COPYRIGHT NOTICE  * * * * * * * * * * * * * * *
 *                                                                       *
 *  This file is part of TerminusDB.                                     *
 *                                                                       *
 *  TerminusDB is free software: you can redistribute it and/or modify   *
 *  it under the terms of the  the Apache License, Version 2.0           *
 *  (the "License");                                                     *
 *  you may not use this file except in compliance with the License.     *
 *  You may obtain a copy of the License at:                             *
 *                                                                       *
 *  http://www.apache.org/licenses/LICENSE-2.0                           *
 *                                                                       *
 *  Unless required by applicable law or agreed to in writing, software  *
 *  distributed under the License is distributed on an "AS IS" BASIS,    *
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or      *
 *  implied.                                                             *
 *  See the License for the specific language governing permissions and  *
 *  limitations under the License.                                       *
 *                                                                       *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

iana('Afar') --> "aa" .
iana('Abkhazian') --> "ab" .
iana('Avestan') --> "ae" .
iana('Afrikaans') --> "af" .
iana('Akan') --> "ak" .
iana('Amharic') --> "am" .
iana('Aragonese') --> "an" .
iana('Arabic') --> "ar" .
iana('Assamese') --> "as" .
iana('Avaric') --> "av" .
iana('Aymara') --> "ay" .
iana('Azerbaijani') --> "az" .
iana('Bashkir') --> "ba" .
iana('Belarusian') --> "be" .
iana('Bulgarian') --> "bg" .
iana('Bihari languages') --> "bh" .
iana('Bislama') --> "bi" .
iana('Bambara') --> "bm" .
iana('Bengali') --> "bn" .
iana('Tibetan') --> "bo" .
iana('Breton') --> "br" .
iana('Bosnian') --> "bs" .
iana('Catalan') --> "ca" .
iana('Chechen') --> "ce" .
iana('Chamorro') --> "ch" .
iana('Corsican') --> "co" .
iana('Cree') --> "cr" .
iana('Czech') --> "cs" .
iana('Church Slavic') --> "cu" .
iana('Chuvash') --> "cv" .
iana('Welsh') --> "cy" .
iana('Danish') --> "da" .
iana('German') --> "de" .
iana('Dhivehi') --> "dv" .
iana('Dzongkha') --> "dz" .
iana('Ewe') --> "ee" .
iana('Modern Greek (1453-)') --> "el" .
iana('English') --> "en" .
iana('Esperanto') --> "eo" .
iana('Spanish') --> "es" .
iana('Estonian') --> "et" .
iana('Basque') --> "eu" .
iana('Persian') --> "fa" .
iana('Fulah') --> "ff" .
iana('Finnish') --> "fi" .
iana('Fijian') --> "fj" .
iana('Faroese') --> "fo" .
iana('French') --> "fr" .
iana('Western Frisian') --> "fy" .
iana('Irish') --> "ga" .
iana('Scottish Gaelic') --> "gd" .
iana('Galician') --> "gl" .
iana('Guarani') --> "gn" .
iana('Gujarati') --> "gu" .
iana('Manx') --> "gv" .
iana('Hausa') --> "ha" .
iana('Hebrew') --> "he" .
iana('Hindi') --> "hi" .
iana('Hiri Motu') --> "ho" .
iana('Croatian') --> "hr" .
iana('Haitian') --> "ht" .
iana('Hungarian') --> "hu" .
iana('Armenian') --> "hy" .
iana('Herero') --> "hz" .
iana('Interlingua (International Auxiliary Language') --> "ia" .
iana('Indonesian') --> "id" .
iana('Interlingue') --> "ie" .
iana('Igbo') --> "ig" .
iana('Sichuan Yi') --> "ii" .
iana('Inupiaq') --> "ik" .
iana('Indonesian') --> "in" .
iana('Ido') --> "io" .
iana('Icelandic') --> "is" .
iana('Italian') --> "it" .
iana('Inuktitut') --> "iu" .
iana('Hebrew') --> "iw" .
iana('Japanese') --> "ja" .
iana('Yiddish') --> "ji" .
iana('Javanese') --> "jv" .
iana('Javanese') --> "jw" .
iana('Georgian') --> "ka" .
iana('Kongo') --> "kg" .
iana('Kikuyu') --> "ki" .
iana('Kuanyama') --> "kj" .
iana('Kazakh') --> "kk" .
iana('Kalaallisut') --> "kl" .
iana('Central Khmer') --> "km" .
iana('Kannada') --> "kn" .
iana('Korean') --> "ko" .
iana('Kanuri') --> "kr" .
iana('Kashmiri') --> "ks" .
iana('Kurdish') --> "ku" .
iana('Komi') --> "kv" .
iana('Cornish') --> "kw" .
iana('Kirghiz') --> "ky" .
iana('Latin') --> "la" .
iana('Luxembourgish') --> "lb" .
iana('Ganda') --> "lg" .
iana('Limburgan') --> "li" .
iana('Lingala') --> "ln" .
iana('Lao') --> "lo" .
iana('Lithuanian') --> "lt" .
iana('Luba-Katanga') --> "lu" .
iana('Latvian') --> "lv" .
iana('Malagasy') --> "mg" .
iana('Marshallese') --> "mh" .
iana('Maori') --> "mi" .
iana('Macedonian') --> "mk" .
iana('Malayalam') --> "ml" .
iana('Mongolian') --> "mn" .
iana('Moldavian') --> "mo" .
iana('Marathi') --> "mr" .
iana('Malay (macrolanguage)') --> "ms" .
iana('Maltese') --> "mt" .
iana('Burmese') --> "my" .
iana('Nauru') --> "na" .
iana('Norwegian Bokmål') --> "nb" .
iana('North Ndebele') --> "nd" .
iana('Nepali (macrolanguage)') --> "ne" .
iana('Ndonga') --> "ng" .
iana('Dutch') --> "nl" .
iana('Norwegian Nynorsk') --> "nn" .
iana('Norwegian') --> "no" .
iana('South Ndebele') --> "nr" .
iana('Navajo') --> "nv" .
iana('Nyanja') --> "ny" .
iana('Occitan (post 1500)') --> "oc" .
iana('Ojibwa') --> "oj" .
iana('Oromo') --> "om" .
iana('Oriya (macrolanguage)') --> "or" .
iana('Ossetian') --> "os" .
iana('Panjabi') --> "pa" .
iana('Pali') --> "pi" .
iana('Polish') --> "pl" .
iana('Pushto') --> "ps" .
iana('Portuguese') --> "pt" .
iana('Quechua') --> "qu" .
iana('Romansh') --> "rm" .
iana('Rundi') --> "rn" .
iana('Romanian') --> "ro" .
iana('Russian') --> "ru" .
iana('Kinyarwanda') --> "rw" .
iana('Sanskrit') --> "sa" .
iana('Sardinian') --> "sc" .
iana('Sindhi') --> "sd" .
iana('Northern Sami') --> "se" .
iana('Sango') --> "sg" .
iana('Serbo-Croatian') --> "sh" .
iana('Sinhala') --> "si" .
iana('Slovak') --> "sk" .
iana('Slovenian') --> "sl" .
iana('Samoan') --> "sm" .
iana('Shona') --> "sn" .
iana('Somali') --> "so" .
iana('Albanian') --> "sq" .
iana('Serbian') --> "sr" .
iana('Swati') --> "ss" .
iana('Southern Sotho') --> "st" .
iana('Sundanese') --> "su" .
iana('Swedish') --> "sv" .
iana('Swahili (macrolanguage)') --> "sw" .
iana('Tamil') --> "ta" .
iana('Telugu') --> "te" .
iana('Tajik') --> "tg" .
iana('Thai') --> "th" .
iana('Tigrinya') --> "ti" .
iana('Turkmen') --> "tk" .
iana('Tagalog') --> "tl" .
iana('Tswana') --> "tn" .
iana('Tonga (Tonga Islands)') --> "to" .
iana('Turkish') --> "tr" .
iana('Tsonga') --> "ts" .
iana('Tatar') --> "tt" .
iana('Twi') --> "tw" .
iana('Tahitian') --> "ty" .
iana('Uighur') --> "ug" .
iana('Ukrainian') --> "uk" .
iana('Urdu') --> "ur" .
iana('Uzbek') --> "uz" .
iana('Venda') --> "ve" .
iana('Vietnamese') --> "vi" .
iana('Volapük') --> "vo" .
iana('Walloon') --> "wa" .
iana('Wolof') --> "wo" .
iana('Xhosa') --> "xh" .
iana('Yiddish') --> "yi" .
iana('Yoruba') --> "yo" .
iana('Zhuang') --> "za" .
iana('Chinese') --> "zh" .
iana('Zulu') --> "zu" .
iana('Ghotuo') --> "aaa" .
iana('Alumu-Tesu') --> "aab" .
iana('Ari') --> "aac" .
iana('Amal') --> "aad" .
iana('Arbëreshë Albanian') --> "aae" .
iana('Aranadan') --> "aaf" .
iana('Ambrak') --> "aag" .
iana('Abu\' Arapesh') --> "aah" .
iana('Arifama-Miniafia') --> "aai" .
iana('Ankave') --> "aak" .
iana('Afade') --> "aal" .
iana('Aramanik') --> "aam" .
iana('Anambé') --> "aan" .
iana('Algerian Saharan Arabic') --> "aao" .
iana('Pará Arára') --> "aap" .
iana('Eastern Abnaki') --> "aaq" .
iana('Aasáx') --> "aas" .
iana('Arvanitika Albanian') --> "aat" .
iana('Abau') --> "aau" .
iana('Austro-Asiatic languages') --> "aav" .
iana('Solong') --> "aaw" .
iana('Mandobo Atas') --> "aax" .
iana('Amarasi') --> "aaz" .
iana('Abé') --> "aba" .
iana('Bankon') --> "abb" .
iana('Ambala Ayta') --> "abc" .
iana('Manide') --> "abd" .
iana('Western Abnaki') --> "abe" .
iana('Abai Sungai') --> "abf" .
iana('Abaga') --> "abg" .
iana('Tajiki Arabic') --> "abh" .
iana('Abidji') --> "abi" .
iana('Aka-Bea') --> "abj" .
iana('Lampung Nyo') --> "abl" .
iana('Abanyom') --> "abm" .
iana('Abua') --> "abn" .
iana('Abon') --> "abo" .
iana('Abellen Ayta') --> "abp" .
iana('Abaza') --> "abq" .
iana('Abron') --> "abr" .
iana('Ambonese Malay') --> "abs" .
iana('Ambulas') --> "abt" .
iana('Abure') --> "abu" .
iana('Baharna Arabic') --> "abv" .
iana('Pal') --> "abw" .
iana('Inabaknon') --> "abx" .
iana('Aneme Wake') --> "aby" .
iana('Abui') --> "abz" .
iana('Achagua') --> "aca" .
iana('Áncá') --> "acb" .
iana('Gikyode') --> "acd" .
iana('Achinese') --> "ace" .
iana('Saint Lucian Creole French') --> "acf" .
iana('Acoli') --> "ach" .
iana('Aka-Cari') --> "aci" .
iana('Aka-Kora') --> "ack" .
iana('Akar-Bale') --> "acl" .
iana('Mesopotamian Arabic') --> "acm" .
iana('Achang') --> "acn" .
iana('Eastern Acipa') --> "acp" .
iana('Ta\'izzi-Adeni Arabic') --> "acq" .
iana('Achi') --> "acr" .
iana('Acroá') --> "acs" .
iana('Achterhoeks') --> "act" .
iana('Achuar-Shiwiar') --> "acu" .
iana('Achumawi') --> "acv" .
iana('Hijazi Arabic') --> "acw" .
iana('Omani Arabic') --> "acx" .
iana('Cypriot Arabic') --> "acy" .
iana('Acheron') --> "acz" .
iana('Adangme') --> "ada" .
iana('Adabe') --> "adb" .
iana('Dzodinka') --> "add" .
iana('Adele') --> "ade" .
iana('Dhofari Arabic') --> "adf" .
iana('Andegerebinha') --> "adg" .
iana('Adhola') --> "adh" .
iana('Adi') --> "adi" .
iana('Adioukrou') --> "adj" .
iana('Galo') --> "adl" .
iana('Adang') --> "adn" .
iana('Abu') --> "ado" .
iana('Adap') --> "adp" .
iana('Adangbe') --> "adq" .
iana('Adonara') --> "adr" .
iana('Adamorobe Sign Language') --> "ads" .
iana('Adnyamathanha') --> "adt" .
iana('Aduge') --> "adu" .
iana('Amundava') --> "adw" .
iana('Amdo Tibetan') --> "adx" .
iana('Adyghe') --> "ady" .
iana('Adzera') --> "adz" .
iana('Areba') --> "aea" .
iana('Tunisian Arabic') --> "aeb" .
iana('Saidi Arabic') --> "aec" .
iana('Argentine Sign Language') --> "aed" .
iana('Northeast Pashai') --> "aee" .
iana('Haeke') --> "aek" .
iana('Ambele') --> "ael" .
iana('Arem') --> "aem" .
iana('Armenian Sign Language') --> "aen" .
iana('Aer') --> "aeq" .
iana('Eastern Arrernte') --> "aer" .
iana('Alsea') --> "aes" .
iana('Akeu') --> "aeu" .
iana('Ambakich') --> "aew" .
iana('Amele') --> "aey" .
iana('Aeka') --> "aez" .
iana('Afro-Asiatic languages') --> "afa" .
iana('Gulf Arabic') --> "afb" .
iana('Andai') --> "afd" .
iana('Putukwam') --> "afe" .
iana('Afghan Sign Language') --> "afg" .
iana('Afrihili') --> "afh" .
iana('Akrukay') --> "afi" .
iana('Nanubae') --> "afk" .
iana('Defaka') --> "afn" .
iana('Eloyi') --> "afo" .
iana('Tapei') --> "afp" .
iana('Afro-Seminole Creole') --> "afs" .
iana('Afitti') --> "aft" .
iana('Awutu') --> "afu" .
iana('Obokuitai') --> "afz" .
iana('Aguano') --> "aga" .
iana('Legbo') --> "agb" .
iana('Agatu') --> "agc" .
iana('Agarabi') --> "agd" .
iana('Angal') --> "age" .
iana('Arguni') --> "agf" .
iana('Angor') --> "agg" .
iana('Ngelima') --> "agh" .
iana('Agariya') --> "agi" .
iana('Argobba') --> "agj" .
iana('Isarog Agta') --> "agk" .
iana('Fembe') --> "agl" .
iana('Angaataha') --> "agm" .
iana('Agutaynen') --> "agn" .
iana('Tainae') --> "ago" .
iana('Paranan') --> "agp" .
iana('Aghem') --> "agq" .
iana('Aguaruna') --> "agr" .
iana('Esimbi') --> "ags" .
iana('Central Cagayan Agta') --> "agt" .
iana('Aguacateco') --> "agu" .
iana('Remontado Dumagat') --> "agv" .
iana('Kahua') --> "agw" .
iana('Aghul') --> "agx" .
iana('Southern Alta') --> "agy" .
iana('Mt. Iriga Agta') --> "agz" .
iana('Ahanta') --> "aha" .
iana('Axamb') --> "ahb" .
iana('Qimant') --> "ahg" .
iana('Aghu') --> "ahh" .
iana('Tiagbamrin Aizi') --> "ahi" .
iana('Akha') --> "ahk" .
iana('Igo') --> "ahl" .
iana('Mobumrin Aizi') --> "ahm" .
iana('Àhàn') --> "ahn" .
iana('Ahom') --> "aho" .
iana('Aproumu Aizi') --> "ahp" .
iana('Ahirani') --> "ahr" .
iana('Ashe') --> "ahs" .
iana('Ahtena') --> "aht" .
iana('Arosi') --> "aia" .
iana('Ainu (China)') --> "aib" .
iana('Ainbai') --> "aic" .
iana('Alngith') --> "aid" .
iana('Amara') --> "aie" .
iana('Agi') --> "aif" .
iana('Antigua and Barbuda Creole English') --> "aig" .
iana('Ai-Cham') --> "aih" .
iana('Assyrian Neo-Aramaic') --> "aii" .
iana('Lishanid Noshan') --> "aij" .
iana('Ake') --> "aik" .
iana('Aimele') --> "ail" .
iana('Aimol') --> "aim" .
iana('Ainu (Japan)') --> "ain" .
iana('Aiton') --> "aio" .
iana('Burumakok') --> "aip" .
iana('Aimaq') --> "aiq" .
iana('Airoran') --> "air" .
iana('Nataoran Amis') --> "ais" .
iana('Arikem') --> "ait" .
iana('Aari') --> "aiw" .
iana('Aighon') --> "aix" .
iana('Ali') --> "aiy" .
iana('Aja (Sudan)') --> "aja" .
iana('Aja (Benin)') --> "ajg" .
iana('Ajië') --> "aji" .
iana('Andajin') --> "ajn" .
iana('South Levantine Arabic') --> "ajp" .
iana('Judeo-Tunisian Arabic') --> "ajt" .
iana('Judeo-Moroccan Arabic') --> "aju" .
iana('Ajawa') --> "ajw" .
iana('Amri Karbi') --> "ajz" .
iana('Batak Angkola') --> "akb" .
iana('Mpur') --> "akc" .
iana('Ukpet-Ehom') --> "akd" .
iana('Akawaio') --> "ake" .
iana('Akpa') --> "akf" .
iana('Anakalangu') --> "akg" .
iana('Angal Heneng') --> "akh" .
iana('Aiome') --> "aki" .
iana('Aka-Jeru') --> "akj" .
iana('Akkadian') --> "akk" .
iana('Aklanon') --> "akl" .
iana('Aka-Bo') --> "akm" .
iana('Akurio') --> "ako" .
iana('Siwu') --> "akp" .
iana('Ak') --> "akq" .
iana('Araki') --> "akr" .
iana('Akaselem') --> "aks" .
iana('Akolet') --> "akt" .
iana('Akum') --> "aku" .
iana('Akhvakh') --> "akv" .
iana('Akwa') --> "akw" .
iana('Aka-Kede') --> "akx" .
iana('Aka-Kol') --> "aky" .
iana('Alabama') --> "akz" .
iana('Alago') --> "ala" .
iana('Qawasqar') --> "alc" .
iana('Alladian') --> "ald" .
iana('Aleut') --> "ale" .
iana('Alege') --> "alf" .
iana('Algonquian languages') --> "alg" .
iana('Alawa') --> "alh" .
iana('Amaimon') --> "ali" .
iana('Alangan') --> "alj" .
iana('Alak') --> "alk" .
iana('Allar') --> "all" .
iana('Amblong') --> "alm" .
iana('Gheg Albanian') --> "aln" .
iana('Larike-Wakasihu') --> "alo" .
iana('Alune') --> "alp" .
iana('Algonquin') --> "alq" .
iana('Alutor') --> "alr" .
iana('Tosk Albanian') --> "als" .
iana('Southern Altai') --> "alt" .
iana('\'Are\'are') --> "alu" .
iana('Atlantic-Congo languages') --> "alv" .
iana('Alaba-K’abeena') --> "alw" .
iana('Amol') --> "alx" .
iana('Alyawarr') --> "aly" .
iana('Alur') --> "alz" .
iana('Amanayé') --> "ama" .
iana('Ambo') --> "amb" .
iana('Amahuaca') --> "amc" .
iana('Yanesha\'') --> "ame" .
iana('Hamer-Banna') --> "amf" .
iana('Amurdak') --> "amg" .
iana('Amis') --> "ami" .
iana('Amdang') --> "amj" .
iana('Ambai') --> "amk" .
iana('War-Jaintia') --> "aml" .
iana('Ama (Papua New Guinea)') --> "amm" .
iana('Amanab') --> "amn" .
iana('Amo') --> "amo" .
iana('Alamblak') --> "amp" .
iana('Amahai') --> "amq" .
iana('Amarakaeri') --> "amr" .
iana('Southern Amami-Oshima') --> "ams" .
iana('Amto') --> "amt" .
iana('Guerrero Amuzgo') --> "amu" .
iana('Ambelau') --> "amv" .
iana('Western Neo-Aramaic') --> "amw" .
iana('Anmatyerre') --> "amx" .
iana('Ami') --> "amy" .
iana('Atampaya') --> "amz" .
iana('Andaqui') --> "ana" .
iana('Andoa') --> "anb" .
iana('Ngas') --> "anc" .
iana('Ansus') --> "and" .
iana('Xârâcùù') --> "ane" .
iana('Animere') --> "anf" .
iana('Old English (ca. 450-1100)') --> "ang" .
iana('Nend') --> "anh" .
iana('Andi') --> "ani" .
iana('Anor') --> "anj" .
iana('Goemai') --> "ank" .
iana('Anu-Hkongso Chin') --> "anl" .
iana('Anal') --> "anm" .
iana('Obolo') --> "ann" .
iana('Andoque') --> "ano" .
iana('Angika') --> "anp" .
iana('Jarawa (India)') --> "anq" .
iana('Andh') --> "anr" .
iana('Anserma') --> "ans" .
iana('Antakarinya') --> "ant" .
iana('Anuak') --> "anu" .
iana('Denya') --> "anv" .
iana('Anaang') --> "anw" .
iana('Andra-Hus') --> "anx" .
iana('Anyin') --> "any" .
iana('Anem') --> "anz" .
iana('Angolar') --> "aoa" .
iana('Abom') --> "aob" .
iana('Pemon') --> "aoc" .
iana('Andarum') --> "aod" .
iana('Angal Enen') --> "aoe" .
iana('Bragat') --> "aof" .
iana('Angoram') --> "aog" .
iana('Arma') --> "aoh" .
iana('Anindilyakwa') --> "aoi" .
iana('Mufian') --> "aoj" .
iana('Arhö') --> "aok" .
iana('Alor') --> "aol" .
iana('Ömie') --> "aom" .
iana('Bumbita Arapesh') --> "aon" .
iana('Aore') --> "aor" .
iana('Taikat') --> "aos" .
iana('Atong (India)') --> "aot" .
iana('A\'ou') --> "aou" .
iana('Atorada') --> "aox" .
iana('Uab Meto') --> "aoz" .
iana('Apache languages') --> "apa" .
iana('Sa\'a') --> "apb" .
iana('North Levantine Arabic') --> "apc" .
iana('Sudanese Arabic') --> "apd" .
iana('Bukiyip') --> "ape" .
iana('Pahanan Agta') --> "apf" .
iana('Ampanang') --> "apg" .
iana('Athpariya') --> "aph" .
iana('Apiaká') --> "api" .
iana('Jicarilla Apache') --> "apj" .
iana('Kiowa Apache') --> "apk" .
iana('Lipan Apache') --> "apl" .
iana('Mescalero-Chiricahua Apache') --> "apm" .
iana('Apinayé') --> "apn" .
iana('Ambul') --> "apo" .
iana('Apma') --> "app" .
iana('A-Pucikwar') --> "apq" .
iana('Arop-Lokep') --> "apr" .
iana('Arop-Sissano') --> "aps" .
iana('Apatani') --> "apt" .
iana('Apurinã') --> "apu" .
iana('Alapmunte') --> "apv" .
iana('Western Apache') --> "apw" .
iana('Aputai') --> "apx" .
iana('Apalaí') --> "apy" .
iana('Safeyoka') --> "apz" .
iana('Alacalufan languages') --> "aqa" .
iana('Archi') --> "aqc" .
iana('Ampari Dogon') --> "aqd" .
iana('Arigidi') --> "aqg" .
iana('Algic languages') --> "aql" .
iana('Atohwaim') --> "aqm" .
iana('Northern Alta') --> "aqn" .
iana('Atakapa') --> "aqp" .
iana('Arhâ') --> "aqr" .
iana('Angaité') --> "aqt" .
iana('Akuntsu') --> "aqz" .
iana('Standard Arabic') --> "arb" .
iana('Official Aramaic (700-300 BCE)') --> "arc" .
iana('Arabana') --> "ard" .
iana('Western Arrarnta') --> "are" .
iana('Arhuaco') --> "arh" .
iana('Arikara') --> "ari" .
iana('Arapaso') --> "arj" .
iana('Arikapú') --> "ark" .
iana('Arabela') --> "arl" .
iana('Mapudungun') --> "arn" .
iana('Araona') --> "aro" .
iana('Arapaho') --> "arp" .
iana('Algerian Arabic') --> "arq" .
iana('Karo (Brazil)') --> "arr" .
iana('Najdi Arabic') --> "ars" .
iana('Artificial languages') --> "art" .
iana('Aruá (Amazonas State)') --> "aru" .
iana('Arbore') --> "arv" .
iana('Arawak') --> "arw" .
iana('Aruá (Rodonia State)') --> "arx" .
iana('Moroccan Arabic') --> "ary" .
iana('Egyptian Arabic') --> "arz" .
iana('Asu (Tanzania)') --> "asa" .
iana('Assiniboine') --> "asb" .
iana('Casuarina Coast Asmat') --> "asc" .
iana('Asas') --> "asd" .
iana('American Sign Language') --> "ase" .
iana('Australian Sign Language') --> "asf" .
iana('Cishingini') --> "asg" .
iana('Abishira') --> "ash" .
iana('Buruwai') --> "asi" .
iana('Sari') --> "asj" .
iana('Ashkun') --> "ask" .
iana('Asilulu') --> "asl" .
iana('Xingú Asuriní') --> "asn" .
iana('Dano') --> "aso" .
iana('Algerian Sign Language') --> "asp" .
iana('Austrian Sign Language') --> "asq" .
iana('Asuri') --> "asr" .
iana('Ipulo') --> "ass" .
iana('Asturian') --> "ast" .
iana('Tocantins Asurini') --> "asu" .
iana('Asoa') --> "asv" .
iana('Australian Aborigines Sign Language') --> "asw" .
iana('Muratayak') --> "asx" .
iana('Yaosakor Asmat') --> "asy" .
iana('As') --> "asz" .
iana('Pele-Ata') --> "ata" .
iana('Zaiwa') --> "atb" .
iana('Atsahuaca') --> "atc" .
iana('Ata Manobo') --> "atd" .
iana('Atemble') --> "ate" .
iana('Ivbie North-Okpela-Arhe') --> "atg" .
iana('Athapascan languages') --> "ath" .
iana('Attié') --> "ati" .
iana('Atikamekw') --> "atj" .
iana('Ati') --> "atk" .
iana('Mt. Iraya Agta') --> "atl" .
iana('Ata') --> "atm" .
iana('Ashtiani') --> "atn" .
iana('Atong (Cameroon)') --> "ato" .
iana('Pudtol Atta') --> "atp" .
iana('Aralle-Tabulahan') --> "atq" .
iana('Waimiri-Atroari') --> "atr" .
iana('Gros Ventre') --> "ats" .
iana('Pamplona Atta') --> "att" .
iana('Reel') --> "atu" .
iana('Northern Altai') --> "atv" .
iana('Atsugewi') --> "atw" .
iana('Arutani') --> "atx" .
iana('Aneityum') --> "aty" .
iana('Arta') --> "atz" .
iana('Asumboa') --> "aua" .
iana('Alugu') --> "aub" .
iana('Waorani') --> "auc" .
iana('Anuta') --> "aud" .
iana('=/Kx\'au//\'ein') --> "aue" .
iana('Arauan languages') --> "auf" .
iana('Aguna') --> "aug" .
iana('Aushi') --> "auh" .
iana('Anuki') --> "aui" .
iana('Awjilah') --> "auj" .
iana('Heyo') --> "auk" .
iana('Aulua') --> "aul" .
iana('Asu (Nigeria)') --> "aum" .
iana('Molmo One') --> "aun" .
iana('Auyokawa') --> "auo" .
iana('Makayam') --> "aup" .
iana('Anus') --> "auq" .
iana('Aruek') --> "aur" .
iana('Australian languages') --> "aus" .
iana('Austral') --> "aut" .
iana('Auye') --> "auu" .
iana('Awyi') --> "auw" .
iana('Aurá') --> "aux" .
iana('Awiyaana') --> "auy" .
iana('Uzbeki Arabic') --> "auz" .
iana('Avau') --> "avb" .
iana('Alviri-Vidari') --> "avd" .
iana('Avikam') --> "avi" .
iana('Kotava') --> "avk" .
iana('Eastern Egyptian Bedawi Arabic') --> "avl" .
iana('Angkamuthi') --> "avm" .
iana('Avatime') --> "avn" .
iana('Agavotaguerra') --> "avo" .
iana('Aushiri') --> "avs" .
iana('Au') --> "avt" .
iana('Avokaya') --> "avu" .
iana('Avá-Canoeiro') --> "avv" .
iana('Awadhi') --> "awa" .
iana('Awa (Papua New Guinea)') --> "awb" .
iana('Cicipu') --> "awc" .
iana('Arawakan languages') --> "awd" .
iana('Awetí') --> "awe" .
iana('Anguthimri') --> "awg" .
iana('Awbono') --> "awh" .
iana('Aekyom') --> "awi" .
iana('Awabakal') --> "awk" .
iana('Arawum') --> "awm" .
iana('Awngi') --> "awn" .
iana('Awak') --> "awo" .
iana('Awera') --> "awr" .
iana('South Awyu') --> "aws" .
iana('Araweté') --> "awt" .
iana('Central Awyu') --> "awu" .
iana('Jair Awyu') --> "awv" .
iana('Awun') --> "aww" .
iana('Awara') --> "awx" .
iana('Edera Awyu') --> "awy" .
iana('Abipon') --> "axb" .
iana('Ayerrerenge') --> "axe" .
iana('Mato Grosso Arára') --> "axg" .
iana('Yaka (Central African Republic)') --> "axk" .
iana('Lower Southern Aranda') --> "axl" .
iana('Middle Armenian') --> "axm" .
iana('Xârâgurè') --> "axx" .
iana('Awar') --> "aya" .
iana('Ayizo Gbe') --> "ayb" .
iana('Southern Aymara') --> "ayc" .
iana('Ayabadhu') --> "ayd" .
iana('Ayere') --> "aye" .
iana('Ginyanga') --> "ayg" .
iana('Hadrami Arabic') --> "ayh" .
iana('Leyigha') --> "ayi" .
iana('Akuku') --> "ayk" .
iana('Libyan Arabic') --> "ayl" .
iana('Sanaani Arabic') --> "ayn" .
iana('Ayoreo') --> "ayo" .
iana('North Mesopotamian Arabic') --> "ayp" .
iana('Ayi (Papua New Guinea)') --> "ayq" .
iana('Central Aymara') --> "ayr" .
iana('Sorsogon Ayta') --> "ays" .
iana('Magbukun Ayta') --> "ayt" .
iana('Ayu') --> "ayu" .
iana('Ayi (China)') --> "ayx" .
iana('Tayabas Ayta') --> "ayy" .
iana('Mai Brat') --> "ayz" .
iana('Azha') --> "aza" .
iana('South Azerbaijani') --> "azb" .
iana('Uto-Aztecan languages') --> "azc" .
iana('Eastern Durango Nahuatl') --> "azd" .
iana('San Pedro Amuzgos Amuzgo') --> "azg" .
iana('North Azerbaijani') --> "azj" .
iana('Ipalapa Amuzgo') --> "azm" .
iana('Western Durango Nahuatl') --> "azn" .
iana('Awing') --> "azo" .
iana('Faire Atta') --> "azt" .
iana('Highland Puebla Nahuatl') --> "azz" .
iana('Babatana') --> "baa" .
iana('Bainouk-Gunyuño') --> "bab" .
iana('Badui') --> "bac" .
iana('Banda languages') --> "bad" .
iana('Baré') --> "bae" .
iana('Nubaca') --> "baf" .
iana('Tuki') --> "bag" .
iana('Bahamas Creole English') --> "bah" .
iana('Bamileke languages') --> "bai" .
iana('Barakai') --> "baj" .
iana('Baluchi') --> "bal" .
iana('Balinese') --> "ban" .
iana('Waimaha') --> "bao" .
iana('Bantawa') --> "bap" .
iana('Bavarian') --> "bar" .
iana('Basa (Cameroon)') --> "bas" .
iana('Baltic languages') --> "bat" .
iana('Bada (Nigeria)') --> "bau" .
iana('Vengo') --> "bav" .
iana('Bambili-Bambui') --> "baw" .
iana('Bamun') --> "bax" .
iana('Batuley') --> "bay" .
iana('Tunen') --> "baz" .
iana('Baatonum') --> "bba" .
iana('Barai') --> "bbb" .
iana('Batak Toba') --> "bbc" .
iana('Bau') --> "bbd" .
iana('Bangba') --> "bbe" .
iana('Baibai') --> "bbf" .
iana('Barama') --> "bbg" .
iana('Bugan') --> "bbh" .
iana('Barombi') --> "bbi" .
iana('Ghomálá\'') --> "bbj" .
iana('Babanki') --> "bbk" .
iana('Bats') --> "bbl" .
iana('Babango') --> "bbm" .
iana('Uneapa') --> "bbn" .
iana('Northern Bobo Madaré') --> "bbo" .
iana('West Central Banda') --> "bbp" .
iana('Bamali') --> "bbq" .
iana('Girawa') --> "bbr" .
iana('Bakpinka') --> "bbs" .
iana('Mburku') --> "bbt" .
iana('Kulung (Nigeria)') --> "bbu" .
iana('Karnai') --> "bbv" .
iana('Baba') --> "bbw" .
iana('Bubia') --> "bbx" .
iana('Befang') --> "bby" .
iana('Babalia Creole Arabic') --> "bbz" .
iana('Central Bai') --> "bca" .
iana('Bainouk-Samik') --> "bcb" .
iana('Southern Balochi') --> "bcc" .
iana('North Babar') --> "bcd" .
iana('Bamenyam') --> "bce" .
iana('Bamu') --> "bcf" .
iana('Baga Binari') --> "bcg" .
iana('Bariai') --> "bch" .
iana('Baoulé') --> "bci" .
iana('Bardi') --> "bcj" .
iana('Bunaba') --> "bck" .
iana('Central Bikol') --> "bcl" .
iana('Bannoni') --> "bcm" .
iana('Bali (Nigeria)') --> "bcn" .
iana('Kaluli') --> "bco" .
iana('Bali (Democratic Republic of Congo)') --> "bcp" .
iana('Bench') --> "bcq" .
iana('Babine') --> "bcr" .
iana('Kohumono') --> "bcs" .
iana('Bendi') --> "bct" .
iana('Awad Bing') --> "bcu" .
iana('Shoo-Minda-Nye') --> "bcv" .
iana('Bana') --> "bcw" .
iana('Bacama') --> "bcy" .
iana('Bainouk-Gunyaamolo') --> "bcz" .
iana('Bayot') --> "bda" .
iana('Basap') --> "bdb" .
iana('Emberá-Baudó') --> "bdc" .
iana('Bunama') --> "bdd" .
iana('Bade') --> "bde" .
iana('Biage') --> "bdf" .
iana('Bonggi') --> "bdg" .
iana('Baka (Sudan)') --> "bdh" .
iana('Burun') --> "bdi" .
iana('Bai') --> "bdj" .
iana('Budukh') --> "bdk" .
iana('Indonesian Bajau') --> "bdl" .
iana('Buduma') --> "bdm" .
iana('Baldemu') --> "bdn" .
iana('Morom') --> "bdo" .
iana('Bende') --> "bdp" .
iana('Bahnar') --> "bdq" .
iana('West Coast Bajau') --> "bdr" .
iana('Burunge') --> "bds" .
iana('Bokoto') --> "bdt" .
iana('Oroko') --> "bdu" .
iana('Bodo Parja') --> "bdv" .
iana('Baham') --> "bdw" .
iana('Budong-Budong') --> "bdx" .
iana('Bandjalang') --> "bdy" .
iana('Badeshi') --> "bdz" .
iana('Beaver') --> "bea" .
iana('Bebele') --> "beb" .
iana('Iceve-Maci') --> "bec" .
iana('Bedoanas') --> "bed" .
iana('Byangsi') --> "bee" .
iana('Benabena') --> "bef" .
iana('Belait') --> "beg" .
iana('Biali') --> "beh" .
iana('Bekati\'') --> "bei" .
iana('Beja') --> "bej" .
iana('Bebeli') --> "bek" .
iana('Bemba (Zambia)') --> "bem" .
iana('Beami') --> "beo" .
iana('Besoa') --> "bep" .
iana('Beembe') --> "beq" .
iana('Berber languages') --> "ber" .
iana('Besme') --> "bes" .
iana('Guiberoua Béte') --> "bet" .
iana('Blagar') --> "beu" .
iana('Daloa Bété') --> "bev" .
iana('Betawi') --> "bew" .
iana('Jur Modo') --> "bex" .
iana('Beli (Papua New Guinea)') --> "bey" .
iana('Bena (Tanzania)') --> "bez" .
iana('Bari') --> "bfa" .
iana('Pauri Bareli') --> "bfb" .
iana('Panyi Bai') --> "bfc" .
iana('Bafut') --> "bfd" .
iana('Betaf') --> "bfe" .
iana('Bofi') --> "bff" .
iana('Busang Kayan') --> "bfg" .
iana('Blafe') --> "bfh" .
iana('British Sign Language') --> "bfi" .
iana('Bafanji') --> "bfj" .
iana('Ban Khor Sign Language') --> "bfk" .
iana('Banda-Ndélé') --> "bfl" .
iana('Mmen') --> "bfm" .
iana('Bunak') --> "bfn" .
iana('Malba Birifor') --> "bfo" .
iana('Beba') --> "bfp" .
iana('Badaga') --> "bfq" .
iana('Bazigar') --> "bfr" .
iana('Southern Bai') --> "bfs" .
iana('Balti') --> "bft" .
iana('Gahri') --> "bfu" .
iana('Bondo') --> "bfw" .
iana('Bantayanon') --> "bfx" .
iana('Bagheli') --> "bfy" .
iana('Mahasu Pahari') --> "bfz" .
iana('Gwamhi-Wuri') --> "bga" .
iana('Bobongko') --> "bgb" .
iana('Haryanvi') --> "bgc" .
iana('Rathwi Bareli') --> "bgd" .
iana('Bauria') --> "bge" .
iana('Bangandu') --> "bgf" .
iana('Bugun') --> "bgg" .
iana('Giangan') --> "bgi" .
iana('Bangolan') --> "bgj" .
iana('Bit') --> "bgk" .
iana('Bo (Laos)') --> "bgl" .
iana('Baga Mboteni') --> "bgm" .
iana('Western Balochi') --> "bgn" .
iana('Baga Koga') --> "bgo" .
iana('Eastern Balochi') --> "bgp" .
iana('Bagri') --> "bgq" .
iana('Bawm Chin') --> "bgr" .
iana('Tagabawa') --> "bgs" .
iana('Bughotu') --> "bgt" .
iana('Mbongno') --> "bgu" .
iana('Warkay-Bipim') --> "bgv" .
iana('Bhatri') --> "bgw" .
iana('Balkan Gagauz Turkish') --> "bgx" .
iana('Benggoi') --> "bgy" .
iana('Banggai') --> "bgz" .
iana('Bharia') --> "bha" .
iana('Bhili') --> "bhb" .
iana('Biga') --> "bhc" .
iana('Bhadrawahi') --> "bhd" .
iana('Bhaya') --> "bhe" .
iana('Odiai') --> "bhf" .
iana('Binandere') --> "bhg" .
iana('Bukharic') --> "bhh" .
iana('Bhilali') --> "bhi" .
iana('Bahing') --> "bhj" .
iana('Albay Bicolano') --> "bhk" .
iana('Bimin') --> "bhl" .
iana('Bathari') --> "bhm" .
iana('Bohtan Neo-Aramaic') --> "bhn" .
iana('Bhojpuri') --> "bho" .
iana('Bima') --> "bhp" .
iana('Tukang Besi South') --> "bhq" .
iana('Bara Malagasy') --> "bhr" .
iana('Buwal') --> "bhs" .
iana('Bhattiyali') --> "bht" .
iana('Bhunjia') --> "bhu" .
iana('Bahau') --> "bhv" .
iana('Biak') --> "bhw" .
iana('Bhalay') --> "bhx" .
iana('Bhele') --> "bhy" .
iana('Bada (Indonesia)') --> "bhz" .
iana('Badimaya') --> "bia" .
iana('Bissa') --> "bib" .
iana('Bikaru') --> "bic" .
iana('Bidiyo') --> "bid" .
iana('Bepour') --> "bie" .
iana('Biafada') --> "bif" .
iana('Biangai') --> "big" .
iana('Vaghat-Ya-Bijim-Legeri') --> "bij" .
iana('Bikol') --> "bik" .
iana('Bile') --> "bil" .
iana('Bimoba') --> "bim" .
iana('Bini') --> "bin" .
iana('Nai') --> "bio" .
iana('Bila') --> "bip" .
iana('Bipi') --> "biq" .
iana('Bisorio') --> "bir" .
iana('Berinomo') --> "bit" .
iana('Biete') --> "biu" .
iana('Southern Birifor') --> "biv" .
iana('Kol (Cameroon)') --> "biw" .
iana('Bijori') --> "bix" .
iana('Birhor') --> "biy" .
iana('Baloi') --> "biz" .
iana('Budza') --> "bja" .
iana('Banggarla') --> "bjb" .
iana('Bariji') --> "bjc" .
iana('Bandjigali') --> "bjd" .
iana('Biao-Jiao Mien') --> "bje" .
iana('Barzani Jewish Neo-Aramaic') --> "bjf" .
iana('Bidyogo') --> "bjg" .
iana('Bahinemo') --> "bjh" .
iana('Burji') --> "bji" .
iana('Kanauji') --> "bjj" .
iana('Barok') --> "bjk" .
iana('Bulu (Papua New Guinea)') --> "bjl" .
iana('Bajelani') --> "bjm" .
iana('Banjar') --> "bjn" .
iana('Mid-Southern Banda') --> "bjo" .
iana('Fanamaket') --> "bjp" .
iana('Southern Betsimisaraka Malagasy') --> "bjq" .
iana('Binumarien') --> "bjr" .
iana('Bajan') --> "bjs" .
iana('Balanta-Ganja') --> "bjt" .
iana('Busuu') --> "bju" .
iana('Bedjond') --> "bjv" .
iana('Bakwé') --> "bjw" .
iana('Banao Itneg') --> "bjx" .
iana('Bayali') --> "bjy" .
iana('Baruga') --> "bjz" .
iana('Kyak') --> "bka" .
iana('Finallig') --> "bkb" .
iana('Baka (Cameroon)') --> "bkc" .
iana('Binukid') --> "bkd" .
iana('Beeke') --> "bkf" .
iana('Buraka') --> "bkg" .
iana('Bakoko') --> "bkh" .
iana('Baki') --> "bki" .
iana('Pande') --> "bkj" .
iana('Brokskat') --> "bkk" .
iana('Berik') --> "bkl" .
iana('Kom (Cameroon)') --> "bkm" .
iana('Bukitan') --> "bkn" .
iana('Kwa\'') --> "bko" .
iana('Boko (Democratic Republic of Congo)') --> "bkp" .
iana('Bakairí') --> "bkq" .
iana('Bakumpai') --> "bkr" .
iana('Northern Sorsoganon') --> "bks" .
iana('Boloki') --> "bkt" .
iana('Buhid') --> "bku" .
iana('Bekwarra') --> "bkv" .
iana('Bekwel') --> "bkw" .
iana('Baikeno') --> "bkx" .
iana('Bokyi') --> "bky" .
iana('Bungku') --> "bkz" .
iana('Siksika') --> "bla" .
iana('Bilua') --> "blb" .
iana('Bella Coola') --> "blc" .
iana('Bolango') --> "bld" .
iana('Balanta-Kentohe') --> "ble" .
iana('Buol') --> "blf" .
iana('Balau') --> "blg" .
iana('Kuwaa') --> "blh" .
iana('Bolia') --> "bli" .
iana('Bolongan') --> "blj" .
iana('Pa\'o Karen') --> "blk" .
iana('Biloxi') --> "bll" .
iana('Beli (Sudan)') --> "blm" .
iana('Southern Catanduanes Bikol') --> "bln" .
iana('Anii') --> "blo" .
iana('Blablanga') --> "blp" .
iana('Baluan-Pam') --> "blq" .
iana('Blang') --> "blr" .
iana('Balaesang') --> "bls" .
iana('Tai Dam') --> "blt" .
iana('Bolo') --> "blv" .
iana('Balangao') --> "blw" .
iana('Mag-Indi Ayta') --> "blx" .
iana('Notre') --> "bly" .
iana('Balantak') --> "blz" .
iana('Lame') --> "bma" .
iana('Bembe') --> "bmb" .
iana('Biem') --> "bmc" .
iana('Baga Manduri') --> "bmd" .
iana('Limassa') --> "bme" .
iana('Bom') --> "bmf" .
iana('Bamwe') --> "bmg" .
iana('Kein') --> "bmh" .
iana('Bagirmi') --> "bmi" .
iana('Bote-Majhi') --> "bmj" .
iana('Ghayavi') --> "bmk" .
iana('Bomboli') --> "bml" .
iana('Northern Betsimisaraka Malagasy') --> "bmm" .
iana('Bina (Papua New Guinea)') --> "bmn" .
iana('Bambalang') --> "bmo" .
iana('Bulgebi') --> "bmp" .
iana('Bomu') --> "bmq" .
iana('Muinane') --> "bmr" .
iana('Bilma Kanuri') --> "bms" .
iana('Biao Mon') --> "bmt" .
iana('Somba-Siawari') --> "bmu" .
iana('Bum') --> "bmv" .
iana('Bomwali') --> "bmw" .
iana('Baimak') --> "bmx" .
iana('Bemba (Democratic Republic of Congo)') --> "bmy" .
iana('Baramu') --> "bmz" .
iana('Bonerate') --> "bna" .
iana('Bookan') --> "bnb" .
iana('Bontok') --> "bnc" .
iana('Banda (Indonesia)') --> "bnd" .
iana('Bintauna') --> "bne" .
iana('Masiwang') --> "bnf" .
iana('Benga') --> "bng" .
iana('Bangi') --> "bni" .
iana('Eastern Tawbuid') --> "bnj" .
iana('Bierebo') --> "bnk" .
iana('Boon') --> "bnl" .
iana('Batanga') --> "bnm" .
iana('Bunun') --> "bnn" .
iana('Bantoanon') --> "bno" .
iana('Bola') --> "bnp" .
iana('Bantik') --> "bnq" .
iana('Butmas-Tur') --> "bnr" .
iana('Bundeli') --> "bns" .
iana('Bantu languages') --> "bnt" .
iana('Bentong') --> "bnu" .
iana('Bonerif') --> "bnv" .
iana('Bisis') --> "bnw" .
iana('Bangubangu') --> "bnx" .
iana('Bintulu') --> "bny" .
iana('Beezen') --> "bnz" .
iana('Bora') --> "boa" .
iana('Aweer') --> "bob" .
iana('Mundabli') --> "boe" .
iana('Bolon') --> "bof" .
iana('Bamako Sign Language') --> "bog" .
iana('Boma') --> "boh" .
iana('Barbareño') --> "boi" .
iana('Anjam') --> "boj" .
iana('Bonjo') --> "bok" .
iana('Bole') --> "bol" .
iana('Berom') --> "bom" .
iana('Bine') --> "bon" .
iana('Tiemacèwè Bozo') --> "boo" .
iana('Bonkiman') --> "bop" .
iana('Bogaya') --> "boq" .
iana('Borôro') --> "bor" .
iana('Bongo') --> "bot" .
iana('Bondei') --> "bou" .
iana('Tuwuli') --> "bov" .
iana('Rema') --> "bow" .
iana('Buamu') --> "box" .
iana('Bodo (Central African Republic)') --> "boy" .
iana('Tiéyaxo Bozo') --> "boz" .
iana('Daakaka') --> "bpa" .
iana('Barbacoas') --> "bpb" .
iana('Banda-Banda') --> "bpd" .
iana('Bonggo') --> "bpg" .
iana('Botlikh') --> "bph" .
iana('Bagupi') --> "bpi" .
iana('Binji') --> "bpj" .
iana('Orowe') --> "bpk" .
iana('Broome Pearling Lugger Pidgin') --> "bpl" .
iana('Biyom') --> "bpm" .
iana('Dzao Min') --> "bpn" .
iana('Anasi') --> "bpo" .
iana('Kaure') --> "bpp" .
iana('Banda Malay') --> "bpq" .
iana('Koronadal Blaan') --> "bpr" .
iana('Sarangani Blaan') --> "bps" .
iana('Barrow Point') --> "bpt" .
iana('Bongu') --> "bpu" .
iana('Bian Marind') --> "bpv" .
iana('Bo (Papua New Guinea)') --> "bpw" .
iana('Palya Bareli') --> "bpx" .
iana('Bishnupriya') --> "bpy" .
iana('Bilba') --> "bpz" .
iana('Tchumbuli') --> "bqa" .
iana('Bagusa') --> "bqb" .
iana('Boko (Benin)') --> "bqc" .
iana('Bung') --> "bqd" .
iana('Baga Kaloum') --> "bqf" .
iana('Bago-Kusuntu') --> "bqg" .
iana('Baima') --> "bqh" .
iana('Bakhtiari') --> "bqi" .
iana('Bandial') --> "bqj" .
iana('Banda-Mbrès') --> "bqk" .
iana('Bilakura') --> "bql" .
iana('Wumboko') --> "bqm" .
iana('Bulgarian Sign Language') --> "bqn" .
iana('Balo') --> "bqo" .
iana('Busa') --> "bqp" .
iana('Biritai') --> "bqq" .
iana('Burusu') --> "bqr" .
iana('Bosngun') --> "bqs" .
iana('Bamukumbit') --> "bqt" .
iana('Boguru') --> "bqu" .
iana('Koro Wachi') --> "bqv" .
iana('Buru (Nigeria)') --> "bqw" .
iana('Baangi') --> "bqx" .
iana('Bengkala Sign Language') --> "bqy" .
iana('Bakaka') --> "bqz" .
iana('Braj') --> "bra" .
iana('Lave') --> "brb" .
iana('Berbice Creole Dutch') --> "brc" .
iana('Baraamu') --> "brd" .
iana('Bera') --> "brf" .
iana('Baure') --> "brg" .
iana('Brahui') --> "brh" .
iana('Mokpwe') --> "bri" .
iana('Bieria') --> "brj" .
iana('Birked') --> "brk" .
iana('Birwa') --> "brl" .
iana('Barambu') --> "brm" .
iana('Boruca') --> "brn" .
iana('Brokkat') --> "bro" .
iana('Barapasi') --> "brp" .
iana('Breri') --> "brq" .
iana('Birao') --> "brr" .
iana('Baras') --> "brs" .
iana('Bitare') --> "brt" .
iana('Eastern Bru') --> "bru" .
iana('Western Bru') --> "brv" .
iana('Bellari') --> "brw" .
iana('Bodo (India)') --> "brx" .
iana('Burui') --> "bry" .
iana('Bilbil') --> "brz" .
iana('Abinomn') --> "bsa" .
iana('Brunei Bisaya') --> "bsb" .
iana('Bassari') --> "bsc" .
iana('Wushi') --> "bse" .
iana('Bauchi') --> "bsf" .
iana('Bashkardi') --> "bsg" .
iana('Kati') --> "bsh" .
iana('Bassossi') --> "bsi" .
iana('Bangwinji') --> "bsj" .
iana('Burushaski') --> "bsk" .
iana('Basa-Gumna') --> "bsl" .
iana('Busami') --> "bsm" .
iana('Barasana-Eduria') --> "bsn" .
iana('Buso') --> "bso" .
iana('Baga Sitemu') --> "bsp" .
iana('Bassa') --> "bsq" .
iana('Bassa-Kontagora') --> "bsr" .
iana('Akoose') --> "bss" .
iana('Basketo') --> "bst" .
iana('Bahonsuai') --> "bsu" .
iana('Baga Sobané') --> "bsv" .
iana('Baiso') --> "bsw" .
iana('Yangkam') --> "bsx" .
iana('Sabah Bisaya') --> "bsy" .
iana('Bata') --> "bta" .
iana('Beti (Cameroon)') --> "btb" .
iana('Bati (Cameroon)') --> "btc" .
iana('Batak Dairi') --> "btd" .
iana('Gamo-Ningi') --> "bte" .
iana('Birgit') --> "btf" .
iana('Gagnoa Bété') --> "btg" .
iana('Biatah Bidayuh') --> "bth" .
iana('Burate') --> "bti" .
iana('Bacanese Malay') --> "btj" .
iana('Batak languages') --> "btk" .
iana('Bhatola') --> "btl" .
iana('Batak Mandailing') --> "btm" .
iana('Ratagnon') --> "btn" .
iana('Rinconada Bikol') --> "bto" .
iana('Budibud') --> "btp" .
iana('Batek') --> "btq" .
iana('Baetora') --> "btr" .
iana('Batak Simalungun') --> "bts" .
iana('Bete-Bendi') --> "btt" .
iana('Batu') --> "btu" .
iana('Bateri') --> "btv" .
iana('Butuanon') --> "btw" .
iana('Batak Karo') --> "btx" .
iana('Bobot') --> "bty" .
iana('Batak Alas-Kluet') --> "btz" .
iana('Buriat') --> "bua" .
iana('Bua') --> "bub" .
iana('Bushi') --> "buc" .
iana('Ntcham') --> "bud" .
iana('Beothuk') --> "bue" .
iana('Bushoong') --> "buf" .
iana('Buginese') --> "bug" .
iana('Younuo Bunu') --> "buh" .
iana('Bongili') --> "bui" .
iana('Basa-Gurmana') --> "buj" .
iana('Bugawac') --> "buk" .
iana('Bulu (Cameroon)') --> "bum" .
iana('Sherbro') --> "bun" .
iana('Terei') --> "buo" .
iana('Busoa') --> "bup" .
iana('Brem') --> "buq" .
iana('Bokobaru') --> "bus" .
iana('Bungain') --> "but" .
iana('Budu') --> "buu" .
iana('Bun') --> "buv" .
iana('Bubi') --> "buw" .
iana('Boghom') --> "bux" .
iana('Bullom So') --> "buy" .
iana('Bukwen') --> "buz" .
iana('Barein') --> "bva" .
iana('Bube') --> "bvb" .
iana('Baelelea') --> "bvc" .
iana('Baeggu') --> "bvd" .
iana('Berau Malay') --> "bve" .
iana('Boor') --> "bvf" .
iana('Bonkeng') --> "bvg" .
iana('Bure') --> "bvh" .
iana('Belanda Viri') --> "bvi" .
iana('Baan') --> "bvj" .
iana('Bukat') --> "bvk" .
iana('Bolivian Sign Language') --> "bvl" .
iana('Bamunka') --> "bvm" .
iana('Buna') --> "bvn" .
iana('Bolgo') --> "bvo" .
iana('Bumang') --> "bvp" .
iana('Birri') --> "bvq" .
iana('Burarra') --> "bvr" .
iana('Bati (Indonesia)') --> "bvt" .
iana('Bukit Malay') --> "bvu" .
iana('Baniva') --> "bvv" .
iana('Boga') --> "bvw" .
iana('Dibole') --> "bvx" .
iana('Baybayanon') --> "bvy" .
iana('Bauzi') --> "bvz" .
iana('Bwatoo') --> "bwa" .
iana('Namosi-Naitasiri-Serua') --> "bwb" .
iana('Bwile') --> "bwc" .
iana('Bwaidoka') --> "bwd" .
iana('Bwe Karen') --> "bwe" .
iana('Boselewa') --> "bwf" .
iana('Barwe') --> "bwg" .
iana('Bishuo') --> "bwh" .
iana('Baniwa') --> "bwi" .
iana('Láá Láá Bwamu') --> "bwj" .
iana('Bauwaki') --> "bwk" .
iana('Bwela') --> "bwl" .
iana('Biwat') --> "bwm" .
iana('Wunai Bunu') --> "bwn" .
iana('Boro (Ethiopia)') --> "bwo" .
iana('Mandobo Bawah') --> "bwp" .
iana('Southern Bobo Madaré') --> "bwq" .
iana('Bura-Pabir') --> "bwr" .
iana('Bomboma') --> "bws" .
iana('Bafaw-Balong') --> "bwt" .
iana('Buli (Ghana)') --> "bwu" .
iana('Bwa') --> "bww" .
iana('Bu-Nao Bunu') --> "bwx" .
iana('Cwi Bwamu') --> "bwy" .
iana('Bwisi') --> "bwz" .
iana('Tairaha') --> "bxa" .
iana('Belanda Bor') --> "bxb" .
iana('Molengue') --> "bxc" .
iana('Pela') --> "bxd" .
iana('Birale') --> "bxe" .
iana('Bilur') --> "bxf" .
iana('Bangala') --> "bxg" .
iana('Buhutu') --> "bxh" .
iana('Pirlatapa') --> "bxi" .
iana('Bayungu') --> "bxj" .
iana('Bukusu') --> "bxk" .
iana('Jalkunan') --> "bxl" .
iana('Mongolia Buriat') --> "bxm" .
iana('Burduna') --> "bxn" .
iana('Barikanchi') --> "bxo" .
iana('Bebil') --> "bxp" .
iana('Beele') --> "bxq" .
iana('Russia Buriat') --> "bxr" .
iana('Busam') --> "bxs" .
iana('China Buriat') --> "bxu" .
iana('Berakou') --> "bxv" .
iana('Bankagooma') --> "bxw" .
iana('Borna (Democratic Republic of Congo)') --> "bxx" .
iana('Binahari') --> "bxz" .
iana('Batak') --> "bya" .
iana('Bikya') --> "byb" .
iana('Ubaghara') --> "byc" .
iana('Benyadu\'') --> "byd" .
iana('Pouye') --> "bye" .
iana('Bete') --> "byf" .
iana('Baygo') --> "byg" .
iana('Bhujel') --> "byh" .
iana('Buyu') --> "byi" .
iana('Bina (Nigeria)') --> "byj" .
iana('Biao') --> "byk" .
iana('Bayono') --> "byl" .
iana('Bidyara') --> "bym" .
iana('Bilin') --> "byn" .
iana('Biyo') --> "byo" .
iana('Bumaji') --> "byp" .
iana('Basay') --> "byq" .
iana('Baruya') --> "byr" .
iana('Burak') --> "bys" .
iana('Berti') --> "byt" .
iana('Medumba') --> "byv" .
iana('Belhariya') --> "byw" .
iana('Qaqet') --> "byx" .
iana('Buya') --> "byy" .
iana('Banaro') --> "byz" .
iana('Bandi') --> "bza" .
iana('Andio') --> "bzb" .
iana('Southern Betsimisaraka Malagasy') --> "bzc" .
iana('Bribri') --> "bzd" .
iana('Jenaama Bozo') --> "bze" .
iana('Boikin') --> "bzf" .
iana('Babuza') --> "bzg" .
iana('Mapos Buang') --> "bzh" .
iana('Bisu') --> "bzi" .
iana('Belize Kriol English') --> "bzj" .
iana('Nicaragua Creole English') --> "bzk" .
iana('Boano (Sulawesi)') --> "bzl" .
iana('Bolondo') --> "bzm" .
iana('Boano (Maluku)') --> "bzn" .
iana('Bozaba') --> "bzo" .
iana('Kemberano') --> "bzp" .
iana('Buli (Indonesia)') --> "bzq" .
iana('Biri') --> "bzr" .
iana('Brazilian Sign Language') --> "bzs" .
iana('Brithenig') --> "bzt" .
iana('Burmeso') --> "bzu" .
iana('Naami') --> "bzv" .
iana('Basa (Nigeria)') --> "bzw" .
iana('Kɛlɛngaxo Bozo') --> "bzx" .
iana('Obanliku') --> "bzy" .
iana('Evant') --> "bzz" .
iana('Chortí') --> "caa" .
iana('Garifuna') --> "cab" .
iana('Chuj') --> "cac" .
iana('Caddo') --> "cad" .
iana('Lehar') --> "cae" .
iana('Southern Carrier') --> "caf" .
iana('Nivaclé') --> "cag" .
iana('Cahuarano') --> "cah" .
iana('Central American Indian languages') --> "cai" .
iana('Chané') --> "caj" .
iana('Kaqchikel') --> "cak" .
iana('Carolinian') --> "cal" .
iana('Cemuhî') --> "cam" .
iana('Chambri') --> "can" .
iana('Chácobo') --> "cao" .
iana('Chipaya') --> "cap" .
iana('Car Nicobarese') --> "caq" .
iana('Galibi Carib') --> "car" .
iana('Tsimané') --> "cas" .
iana('Caucasian languages') --> "cau" .
iana('Cavineña') --> "cav" .
iana('Callawalla') --> "caw" .
iana('Chiquitano') --> "cax" .
iana('Cayuga') --> "cay" .
iana('Canichana') --> "caz" .
iana('Chibchan languages') --> "cba" .
iana('Cabiyarí') --> "cbb" .
iana('Carapana') --> "cbc" .
iana('Carijona') --> "cbd" .
iana('Chipiajes') --> "cbe" .
iana('Chimila') --> "cbg" .
iana('Cagua') --> "cbh" .
iana('Chachi') --> "cbi" .
iana('Ede Cabe') --> "cbj" .
iana('Chavacano') --> "cbk" .
iana('Bualkhaw Chin') --> "cbl" .
iana('Nyahkur') --> "cbn" .
iana('Izora') --> "cbo" .
iana('Tsucuba') --> "cbq" .
iana('Cashibo-Cacataibo') --> "cbr" .
iana('Cashinahua') --> "cbs" .
iana('Chayahuita') --> "cbt" .
iana('Candoshi-Shapra') --> "cbu" .
iana('Cacua') --> "cbv" .
iana('Kinabalian') --> "cbw" .
iana('Carabayo') --> "cby" .
iana('Cauca') --> "cca" .
iana('Chamicuro') --> "ccc" .
iana('Cafundo Creole') --> "ccd" .
iana('Chopi') --> "cce" .
iana('Samba Daka') --> "ccg" .
iana('Atsam') --> "cch" .
iana('Kasanga') --> "ccj" .
iana('Cutchi-Swahili') --> "ccl" .
iana('Malaccan Creole Malay') --> "ccm" .
iana('North Caucasian languages') --> "ccn" .
iana('Comaltepec Chinantec') --> "cco" .
iana('Chakma') --> "ccp" .
iana('Chaungtha') --> "ccq" .
iana('Cacaopera') --> "ccr" .
iana('South Caucasian languages') --> "ccs" .
iana('Choni') --> "cda" .
iana('Chadic languages') --> "cdc" .
iana('Caddoan languages') --> "cdd" .
iana('Chenchu') --> "cde" .
iana('Chiru') --> "cdf" .
iana('Chamari') --> "cdg" .
iana('Chambeali') --> "cdh" .
iana('Chodri') --> "cdi" .
iana('Churahi') --> "cdj" .
iana('Chepang') --> "cdm" .
iana('Chaudangsi') --> "cdn" .
iana('Min Dong Chinese') --> "cdo" .
iana('Cinda-Regi-Tiyal') --> "cdr" .
iana('Chadian Sign Language') --> "cds" .
iana('Chadong') --> "cdy" .
iana('Koda') --> "cdz" .
iana('Lower Chehalis') --> "cea" .
iana('Cebuano') --> "ceb" .
iana('Chamacoco') --> "ceg" .
iana('Eastern Khumi Chin') --> "cek" .
iana('Celtic languages') --> "cel" .
iana('Cen') --> "cen" .
iana('Centúúm') --> "cet" .
iana('Dijim-Bwilim') --> "cfa" .
iana('Cara') --> "cfd" .
iana('Como Karim') --> "cfg" .
iana('Falam Chin') --> "cfm" .
iana('Changriwa') --> "cga" .
iana('Kagayanen') --> "cgc" .
iana('Chiga') --> "cgg" .
iana('Chocangacakha') --> "cgk" .
iana('Chibcha') --> "chb" .
iana('Catawba') --> "chc" .
iana('Highland Oaxaca Chontal') --> "chd" .
iana('Tabasco Chontal') --> "chf" .
iana('Chagatai') --> "chg" .
iana('Chinook') --> "chh" .
iana('Ojitlán Chinantec') --> "chj" .
iana('Chuukese') --> "chk" .
iana('Cahuilla') --> "chl" .
iana('Mari (Russia)') --> "chm" .
iana('Chinook jargon') --> "chn" .
iana('Choctaw') --> "cho" .
iana('Chipewyan') --> "chp" .
iana('Quiotepec Chinantec') --> "chq" .
iana('Cherokee') --> "chr" .
iana('Cholón') --> "cht" .
iana('Chuwabu') --> "chw" .
iana('Chantyal') --> "chx" .
iana('Cheyenne') --> "chy" .
iana('Ozumacín Chinantec') --> "chz" .
iana('Cia-Cia') --> "cia" .
iana('Ci Gbe') --> "cib" .
iana('Chickasaw') --> "cic" .
iana('Chimariko') --> "cid" .
iana('Cineni') --> "cie" .
iana('Chinali') --> "cih" .
iana('Chitkuli Kinnauri') --> "cik" .
iana('Cimbrian') --> "cim" .
iana('Cinta Larga') --> "cin" .
iana('Chiapanec') --> "cip" .
iana('Tiri') --> "cir" .
iana('Chippewa') --> "ciw" .
iana('Chaima') --> "ciy" .
iana('Western Cham') --> "cja" .
iana('Chru') --> "cje" .
iana('Upper Chehalis') --> "cjh" .
iana('Chamalal') --> "cji" .
iana('Chokwe') --> "cjk" .
iana('Eastern Cham') --> "cjm" .
iana('Chenapian') --> "cjn" .
iana('Ashéninka Pajonal') --> "cjo" .
iana('Cabécar') --> "cjp" .
iana('Chorotega') --> "cjr" .
iana('Shor') --> "cjs" .
iana('Chuave') --> "cjv" .
iana('Jinyu Chinese') --> "cjy" .
iana('Khumi Awa Chin') --> "cka" .
iana('Central Kurdish') --> "ckb" .
iana('Chak') --> "ckh" .
iana('Cibak') --> "ckl" .
iana('Kaang Chin') --> "ckn" .
iana('Anufo') --> "cko" .
iana('Kajakse') --> "ckq" .
iana('Kairak') --> "ckr" .
iana('Tayo') --> "cks" .
iana('Chukot') --> "ckt" .
iana('Koasati') --> "cku" .
iana('Kavalan') --> "ckv" .
iana('Caka') --> "ckx" .
iana('Cakfem-Mushere') --> "cky" .
iana('Cakchiquel-Quiché Mixed Language') --> "ckz" .
iana('Ron') --> "cla" .
iana('Chilcotin') --> "clc" .
iana('Chaldean Neo-Aramaic') --> "cld" .
iana('Lealao Chinantec') --> "cle" .
iana('Chilisso') --> "clh" .
iana('Chakali') --> "cli" .
iana('Laitu Chin') --> "clj" .
iana('Idu-Mishmi') --> "clk" .
iana('Chala') --> "cll" .
iana('Clallam') --> "clm" .
iana('Lowland Oaxaca Chontal') --> "clo" .
iana('Lautu Chin') --> "clt" .
iana('Caluyanun') --> "clu" .
iana('Chulym') --> "clw" .
iana('Eastern Highland Chatino') --> "cly" .
iana('Maa') --> "cma" .
iana('Chamic languages') --> "cmc" .
iana('Cerma') --> "cme" .
iana('Classical Mongolian') --> "cmg" .
iana('Emberá-Chamí') --> "cmi" .
iana('Chimakum') --> "cmk" .
iana('Campalagian') --> "cml" .
iana('Michigamea') --> "cmm" .
iana('Mandarin Chinese') --> "cmn" .
iana('Central Mnong') --> "cmo" .
iana('Mro-Khimi Chin') --> "cmr" .
iana('Messapic') --> "cms" .
iana('Camtho') --> "cmt" .
iana('Changthang') --> "cna" .
iana('Chinbon Chin') --> "cnb" .
iana('Côông') --> "cnc" .
iana('Northern Qiang') --> "cng" .
iana('Haka Chin') --> "cnh" .
iana('Asháninka') --> "cni" .
iana('Khumi Chin') --> "cnk" .
iana('Lalana Chinantec') --> "cnl" .
iana('Con') --> "cno" .
iana('Central Asmat') --> "cns" .
iana('Tepetotutla Chinantec') --> "cnt" .
iana('Chenoua') --> "cnu" .
iana('Ngawn Chin') --> "cnw" .
iana('Middle Cornish') --> "cnx" .
iana('Cocos Islands Malay') --> "coa" .
iana('Chicomuceltec') --> "cob" .
iana('Cocopa') --> "coc" .
iana('Cocama-Cocamilla') --> "cod" .
iana('Koreguaje') --> "coe" .
iana('Colorado') --> "cof" .
iana('Chong') --> "cog" .
iana('Chonyi-Dzihana-Kauma') --> "coh" .
iana('Cochimi') --> "coj" .
iana('Santa Teresa Cora') --> "cok" .
iana('Columbia-Wenatchi') --> "col" .
iana('Comanche') --> "com" .
iana('Cofán') --> "con" .
iana('Comox') --> "coo" .
iana('Coptic') --> "cop" .
iana('Coquille') --> "coq" .
iana('Caquinte') --> "cot" .
iana('Wamey') --> "cou" .
iana('Cao Miao') --> "cov" .
iana('Cowlitz') --> "cow" .
iana('Nanti') --> "cox" .
iana('Coyaima') --> "coy" .
iana('Chochotec') --> "coz" .
iana('Palantla Chinantec') --> "cpa" .
iana('Ucayali-Yurúa Ashéninka') --> "cpb" .
iana('Ajyíninka Apurucayali') --> "cpc" .
iana('English-based creoles and pidgins') --> "cpe" .
iana('French-based creoles and pidgins') --> "cpf" .
iana('Cappadocian Greek') --> "cpg" .
iana('Chinese Pidgin English') --> "cpi" .
iana('Cherepon') --> "cpn" .
iana('Kpeego') --> "cpo" .
iana('Portuguese-based creoles and pidgins') --> "cpp" .
iana('Capiznon') --> "cps" .
iana('Pichis Ashéninka') --> "cpu" .
iana('Pu-Xian Chinese') --> "cpx" .
iana('South Ucayali Ashéninka') --> "cpy" .
iana('Chuanqiandian Cluster Miao') --> "cqd" .
iana('Chilean Quechua') --> "cqu" .
iana('Chara') --> "cra" .
iana('Island Carib') --> "crb" .
iana('Lonwolwol') --> "crc" .
iana('Coeur d\'Alene') --> "crd" .
iana('Caramanta') --> "crf" .
iana('Michif') --> "crg" .
iana('Crimean Tatar') --> "crh" .
iana('Sãotomense') --> "cri" .
iana('Southern East Cree') --> "crj" .
iana('Plains Cree') --> "crk" .
iana('Northern East Cree') --> "crl" .
iana('Moose Cree') --> "crm" .
iana('El Nayar Cora') --> "crn" .
iana('Crow') --> "cro" .
iana('Creoles and pidgins') --> "crp" .
iana('Iyo\'wujwa Chorote') --> "crq" .
iana('Carolina Algonquian') --> "crr" .
iana('Seselwa Creole French') --> "crs" .
iana('Iyojwa\'ja Chorote') --> "crt" .
iana('Chaura') --> "crv" .
iana('Chrau') --> "crw" .
iana('Carrier') --> "crx" .
iana('Cori') --> "cry" .
iana('Cruzeño') --> "crz" .
iana('Chiltepec Chinantec') --> "csa" .
iana('Kashubian') --> "csb" .
iana('Catalan Sign Language') --> "csc" .
iana('Chiangmai Sign Language') --> "csd" .
iana('Czech Sign Language') --> "cse" .
iana('Cuba Sign Language') --> "csf" .
iana('Chilean Sign Language') --> "csg" .
iana('Asho Chin') --> "csh" .
iana('Coast Miwok') --> "csi" .
iana('Songlai Chin') --> "csj" .
iana('Jola-Kasa') --> "csk" .
iana('Chinese Sign Language') --> "csl" .
iana('Central Sierra Miwok') --> "csm" .
iana('Colombian Sign Language') --> "csn" .
iana('Sochiapam Chinantec') --> "cso" .
iana('Croatia Sign Language') --> "csq" .
iana('Costa Rican Sign Language') --> "csr" .
iana('Southern Ohlone') --> "css" .
iana('Northern Ohlone') --> "cst" .
iana('Central Sudanic languages') --> "csu" .
iana('Sumtu Chin') --> "csv" .
iana('Swampy Cree') --> "csw" .
iana('Siyin Chin') --> "csy" .
iana('Coos') --> "csz" .
iana('Tataltepec Chatino') --> "cta" .
iana('Chetco') --> "ctc" .
iana('Tedim Chin') --> "ctd" .
iana('Tepinapa Chinantec') --> "cte" .
iana('Chittagonian') --> "ctg" .
iana('Thaiphum Chin') --> "cth" .
iana('Tlacoatzintepec Chinantec') --> "ctl" .
iana('Chitimacha') --> "ctm" .
iana('Chhintange') --> "ctn" .
iana('Emberá-Catío') --> "cto" .
iana('Western Highland Chatino') --> "ctp" .
iana('Northern Catanduanes Bikol') --> "cts" .
iana('Wayanad Chetti') --> "ctt" .
iana('Chol') --> "ctu" .
iana('Zacatepec Chatino') --> "ctz" .
iana('Cua') --> "cua" .
iana('Cubeo') --> "cub" .
iana('Usila Chinantec') --> "cuc" .
iana('Cung') --> "cug" .
iana('Chuka') --> "cuh" .
iana('Cuiba') --> "cui" .
iana('Mashco Piro') --> "cuj" .
iana('San Blas Kuna') --> "cuk" .
iana('Culina') --> "cul" .
iana('Cumeral') --> "cum" .
iana('Cumanagoto') --> "cuo" .
iana('Cupeño') --> "cup" .
iana('Cun') --> "cuq" .
iana('Chhulung') --> "cur" .
iana('Cushitic languages') --> "cus" .
iana('Teutila Cuicatec') --> "cut" .
iana('Tai Ya') --> "cuu" .
iana('Cuvok') --> "cuv" .
iana('Chukwa') --> "cuw" .
iana('Tepeuxila Cuicatec') --> "cux" .
iana('Chug') --> "cvg" .
iana('Valle Nacional Chinantec') --> "cvn" .
iana('Kabwa') --> "cwa" .
iana('Maindo') --> "cwb" .
iana('Woods Cree') --> "cwd" .
iana('Kwere') --> "cwe" .
iana('Chewong') --> "cwg" .
iana('Kuwaataay') --> "cwt" .
iana('Nopala Chatino') --> "cya" .
iana('Cayubaba') --> "cyb" .
iana('Cuyonon') --> "cyo" .
iana('Huizhou Chinese') --> "czh" .
iana('Knaanic') --> "czk" .
iana('Zenzontepec Chatino') --> "czn" .
iana('Min Zhong Chinese') --> "czo" .
iana('Zotung Chin') --> "czt" .
iana('Dangaléat') --> "daa" .
iana('Dambi') --> "dac" .
iana('Marik') --> "dad" .
iana('Duupa') --> "dae" .
iana('Dan') --> "daf" .
iana('Dagbani') --> "dag" .
iana('Gwahatike') --> "dah" .
iana('Day') --> "dai" .
iana('Dar Fur Daju') --> "daj" .
iana('Dakota') --> "dak" .
iana('Dahalo') --> "dal" .
iana('Damakawa') --> "dam" .
iana('Daai Chin') --> "dao" .
iana('Nisi (India)') --> "dap" .
iana('Dandami Maria') --> "daq" .
iana('Dargwa') --> "dar" .
iana('Daho-Doo') --> "das" .
iana('Dar Sila Daju') --> "dau" .
iana('Taita') --> "dav" .
iana('Davawenyo') --> "daw" .
iana('Dayi') --> "dax" .
iana('Land Dayak languages') --> "day" .
iana('Dao') --> "daz" .
iana('Bangime') --> "dba" .
iana('Deno') --> "dbb" .
iana('Dadiya') --> "dbd" .
iana('Dabe') --> "dbe" .
iana('Edopi') --> "dbf" .
iana('Dogul Dom Dogon') --> "dbg" .
iana('Doka') --> "dbi" .
iana('Ida\'an') --> "dbj" .
iana('Dyirbal') --> "dbl" .
iana('Duguri') --> "dbm" .
iana('Duriankere') --> "dbn" .
iana('Dulbu') --> "dbo" .
iana('Duwai') --> "dbp" .
iana('Daba') --> "dbq" .
iana('Dabarre') --> "dbr" .
iana('Ben Tey Dogon') --> "dbt" .
iana('Bondum Dom Dogon') --> "dbu" .
iana('Dungu') --> "dbv" .
iana('Bankan Tey Dogon') --> "dbw" .
iana('Dibiyaso') --> "dby" .
iana('Deccan') --> "dcc" .
iana('Negerhollands') --> "dcr" .
iana('Dadi Dadi') --> "dda" .
iana('Dongotono') --> "ddd" .
iana('Doondo') --> "dde" .
iana('Fataluku') --> "ddg" .
iana('West Goodenough') --> "ddi" .
iana('Jaru') --> "ddj" .
iana('Dendi (Benin)') --> "ddn" .
iana('Dido') --> "ddo" .
iana('Dhudhuroa') --> "ddr" .
iana('Donno So Dogon') --> "dds" .
iana('Dawera-Daweloor') --> "ddw" .
iana('Dagik') --> "dec" .
iana('Dedua') --> "ded" .
iana('Dewoin') --> "dee" .
iana('Dezfuli') --> "def" .
iana('Degema') --> "deg" .
iana('Dehwari') --> "deh" .
iana('Demisa') --> "dei" .
iana('Dek') --> "dek" .
iana('Delaware') --> "del" .
iana('Dem') --> "dem" .
iana('Slave (Athapascan)') --> "den" .
iana('Pidgin Delaware') --> "dep" .
iana('Dendi (Central African Republic)') --> "deq" .
iana('Deori') --> "der" .
iana('Desano') --> "des" .
iana('Domung') --> "dev" .
iana('Dengese') --> "dez" .
iana('Southern Dagaare') --> "dga" .
iana('Bunoge Dogon') --> "dgb" .
iana('Casiguran Dumagat Agta') --> "dgc" .
iana('Dagaari Dioula') --> "dgd" .
iana('Degenan') --> "dge" .
iana('Doga') --> "dgg" .
iana('Dghwede') --> "dgh" .
iana('Northern Dagara') --> "dgi" .
iana('Dagba') --> "dgk" .
iana('Andaandi') --> "dgl" .
iana('Dagoman') --> "dgn" .
iana('Dogri (individual language)') --> "dgo" .
iana('Dogrib') --> "dgr" .
iana('Dogoso') --> "dgs" .
iana('Ndra\'ngith') --> "dgt" .
iana('Degaru') --> "dgu" .
iana('Daungwurrung') --> "dgw" .
iana('Doghoro') --> "dgx" .
iana('Daga') --> "dgz" .
iana('Dhanwar (India)') --> "dha" .
iana('Dhundari') --> "dhd" .
iana('Dhangu') --> "dhg" .
iana('Dhimal') --> "dhi" .
iana('Dhalandji') --> "dhl" .
iana('Zemba') --> "dhm" .
iana('Dhanki') --> "dhn" .
iana('Dhodia') --> "dho" .
iana('Dhargari') --> "dhr" .
iana('Dhaiso') --> "dhs" .
iana('Dhurga') --> "dhu" .
iana('Dehu') --> "dhv" .
iana('Dhanwar (Nepal)') --> "dhw" .
iana('Dhungaloo') --> "dhx" .
iana('Dia') --> "dia" .
iana('South Central Dinka') --> "dib" .
iana('Lakota Dida') --> "dic" .
iana('Didinga') --> "did" .
iana('Dieri') --> "dif" .
iana('Digo') --> "dig" .
iana('Kumiai') --> "dih" .
iana('Dimbong') --> "dii" .
iana('Dai') --> "dij" .
iana('Southwestern Dinka') --> "dik" .
iana('Dilling') --> "dil" .
iana('Dime') --> "dim" .
iana('Dinka') --> "din" .
iana('Dibo') --> "dio" .
iana('Northeastern Dinka') --> "dip" .
iana('Dimli (individual language)') --> "diq" .
iana('Dirim') --> "dir" .
iana('Dimasa') --> "dis" .
iana('Dirari') --> "dit" .
iana('Diriku') --> "diu" .
iana('Northwestern Dinka') --> "diw" .
iana('Dixon Reef') --> "dix" .
iana('Diuwe') --> "diy" .
iana('Ding') --> "diz" .
iana('Djadjawurrung') --> "dja" .
iana('Djinba') --> "djb" .
iana('Dar Daju Daju') --> "djc" .
iana('Djamindjung') --> "djd" .
iana('Zarma') --> "dje" .
iana('Djangun') --> "djf" .
iana('Djinang') --> "dji" .
iana('Djeebbana') --> "djj" .
iana('Eastern Maroon Creole') --> "djk" .
iana('Djiwarli') --> "djl" .
iana('Jamsay Dogon') --> "djm" .
iana('Djauan') --> "djn" .
iana('Jangkang') --> "djo" .
iana('Djambarrpuyngu') --> "djr" .
iana('Kapriman') --> "dju" .
iana('Djawi') --> "djw" .
iana('Dakpakha') --> "dka" .
iana('Dakka') --> "dkk" .
iana('Kolum So Dogon') --> "dkl" .
iana('Kuijau') --> "dkr" .
iana('Southeastern Dinka') --> "dks" .
iana('Mazagway') --> "dkx" .
iana('Dolgan') --> "dlg" .
iana('Dahalik') --> "dlk" .
iana('Dalmatian') --> "dlm" .
iana('Darlong') --> "dln" .
iana('Duma') --> "dma" .
iana('Mombo Dogon') --> "dmb" .
iana('Gavak') --> "dmc" .
iana('Madhi Madhi') --> "dmd" .
iana('Dugwor') --> "dme" .
iana('Upper Kinabatangan') --> "dmg" .
iana('Domaaki') --> "dmk" .
iana('Dameli') --> "dml" .
iana('Dama') --> "dmm" .
iana('Mande languages') --> "dmn" .
iana('Kemedzung') --> "dmo" .
iana('East Damar') --> "dmr" .
iana('Dampelas') --> "dms" .
iana('Dubu') --> "dmu" .
iana('Dumpas') --> "dmv" .
iana('Mudburra') --> "dmw" .
iana('Dema') --> "dmx" .
iana('Demta') --> "dmy" .
iana('Upper Grand Valley Dani') --> "dna" .
iana('Daonda') --> "dnd" .
iana('Ndendeule') --> "dne" .
iana('Dungan') --> "dng" .
iana('Lower Grand Valley Dani') --> "dni" .
iana('Dan') --> "dnj" .
iana('Dengka') --> "dnk" .
iana('Dzùùngoo') --> "dnn" .
iana('Danaru') --> "dnr" .
iana('Mid Grand Valley Dani') --> "dnt" .
iana('Danau') --> "dnu" .
iana('Danu') --> "dnv" .
iana('Western Dani') --> "dnw" .
iana('Dení') --> "dny" .
iana('Dom') --> "doa" .
iana('Dobu') --> "dob" .
iana('Northern Dong') --> "doc" .
iana('Doe') --> "doe" .
iana('Domu') --> "dof" .
iana('Dong') --> "doh" .
iana('Dogri (macrolanguage)') --> "doi" .
iana('Dondo') --> "dok" .
iana('Doso') --> "dol" .
iana('Toura (Papua New Guinea)') --> "don" .
iana('Dongo') --> "doo" .
iana('Lukpa') --> "dop" .
iana('Dominican Sign Language') --> "doq" .
iana('Dori\'o') --> "dor" .
iana('Dogosé') --> "dos" .
iana('Dass') --> "dot" .
iana('Dombe') --> "dov" .
iana('Doyayo') --> "dow" .
iana('Bussa') --> "dox" .
iana('Dompo') --> "doy" .
iana('Dorze') --> "doz" .
iana('Papar') --> "dpp" .
iana('Dravidian languages') --> "dra" .
iana('Dair') --> "drb" .
iana('Minderico') --> "drc" .
iana('Darmiya') --> "drd" .
iana('Dolpo') --> "dre" .
iana('Rungus') --> "drg" .
iana('Darkhat') --> "drh" .
iana('C\'lela') --> "dri" .
iana('Paakantyi') --> "drl" .
iana('West Damar') --> "drn" .
iana('Daro-Matu Melanau') --> "dro" .
iana('Dura') --> "drq" .
iana('Dororo') --> "drr" .
iana('Gedeo') --> "drs" .
iana('Drents') --> "drt" .
iana('Rukai') --> "dru" .
iana('Darwazi') --> "drw" .
iana('Darai') --> "dry" .
iana('Lower Sorbian') --> "dsb" .
iana('Dutch Sign Language') --> "dse" .
iana('Daasanach') --> "dsh" .
iana('Disa') --> "dsi" .
iana('Danish Sign Language') --> "dsl" .
iana('Dusner') --> "dsn" .
iana('Desiya') --> "dso" .
iana('Tadaksahak') --> "dsq" .
iana('Daur') --> "dta" .
iana('Labuk-Kinabatangan Kadazan') --> "dtb" .
iana('Ditidaht') --> "dtd" .
iana('Adithinngithigh') --> "dth" .
iana('Ana Tinga Dogon') --> "dti" .
iana('Tene Kan Dogon') --> "dtk" .
iana('Tomo Kan Dogon') --> "dtm" .
iana('Tommo So Dogon') --> "dto" .
iana('Central Dusun') --> "dtp" .
iana('Lotud') --> "dtr" .
iana('Toro So Dogon') --> "dts" .
iana('Toro Tegu Dogon') --> "dtt" .
iana('Tebul Ure Dogon') --> "dtu" .
iana('Dotyali') --> "dty" .
iana('Duala') --> "dua" .
iana('Dubli') --> "dub" .
iana('Duna') --> "duc" .
iana('Hun-Saare') --> "dud" .
iana('Umiray Dumaget Agta') --> "due" .
iana('Dumbea') --> "duf" .
iana('Duruma') --> "dug" .
iana('Dungra Bhil') --> "duh" .
iana('Dumun') --> "dui" .
iana('Dhuwal') --> "duj" .
iana('Uyajitaya') --> "duk" .
iana('Alabat Island Agta') --> "dul" .
iana('Middle Dutch (ca. 1050-1350)') --> "dum" .
iana('Dusun Deyah') --> "dun" .
iana('Dupaninan Agta') --> "duo" .
iana('Duano') --> "dup" .
iana('Dusun Malang') --> "duq" .
iana('Dii') --> "dur" .
iana('Dumi') --> "dus" .
iana('Drung') --> "duu" .
iana('Duvle') --> "duv" .
iana('Dusun Witu') --> "duw" .
iana('Duungooma') --> "dux" .
iana('Dicamay Agta') --> "duy" .
iana('Duli') --> "duz" .
iana('Duau') --> "dva" .
iana('Diri') --> "dwa" .
iana('Walo Kumbe Dogon') --> "dwl" .
iana('Dawro') --> "dwr" .
iana('Dutton World Speedwords') --> "dws" .
iana('Dawawa') --> "dww" .
iana('Dyan') --> "dya" .
iana('Dyaberdyaber') --> "dyb" .
iana('Dyugun') --> "dyd" .
iana('Villa Viciosa Agta') --> "dyg" .
iana('Djimini Senoufo') --> "dyi" .
iana('Yanda Dom Dogon') --> "dym" .
iana('Dyangadi') --> "dyn" .
iana('Jola-Fonyi') --> "dyo" .
iana('Dyula') --> "dyu" .
iana('Dyaabugay') --> "dyy" .
iana('Tunzu') --> "dza" .
iana('Daza') --> "dzd" .
iana('Djiwarli') --> "dze" .
iana('Dazaga') --> "dzg" .
iana('Dzalakha') --> "dzl" .
iana('Dzando') --> "dzn" .
iana('Karenggapa') --> "eaa" .
iana('Ebughu') --> "ebg" .
iana('Eastern Bontok') --> "ebk" .
iana('Teke-Ebo') --> "ebo" .
iana('Ebrié') --> "ebr" .
iana('Embu') --> "ebu" .
iana('Eteocretan') --> "ecr" .
iana('Ecuadorian Sign Language') --> "ecs" .
iana('Eteocypriot') --> "ecy" .
iana('E') --> "eee" .
iana('Efai') --> "efa" .
iana('Efe') --> "efe" .
iana('Efik') --> "efi" .
iana('Ega') --> "ega" .
iana('Emilian') --> "egl" .
iana('Eggon') --> "ego" .
iana('Egyptian languages') --> "egx" .
iana('Egyptian (Ancient)') --> "egy" .
iana('Ehueun') --> "ehu" .
iana('Eipomek') --> "eip" .
iana('Eitiep') --> "eit" .
iana('Askopan') --> "eiv" .
iana('Ejamat') --> "eja" .
iana('Ekajuk') --> "eka" .
iana('Eastern Karnic') --> "ekc" .
iana('Ekit') --> "eke" .
iana('Ekari') --> "ekg" .
iana('Eki') --> "eki" .
iana('Standard Estonian') --> "ekk" .
iana('Kol (Bangladesh)') --> "ekl" .
iana('Elip') --> "ekm" .
iana('Koti') --> "eko" .
iana('Ekpeye') --> "ekp" .
iana('Yace') --> "ekr" .
iana('Eastern Kayah') --> "eky" .
iana('Elepi') --> "ele" .
iana('El Hugeirat') --> "elh" .
iana('Nding') --> "eli" .
iana('Elkei') --> "elk" .
iana('Eleme') --> "elm" .
iana('El Molo') --> "elo" .
iana('Elpaputih') --> "elp" .
iana('Elu') --> "elu" .
iana('Elamite') --> "elx" .
iana('Emai-Iuleha-Ora') --> "ema" .
iana('Embaloh') --> "emb" .
iana('Emerillon') --> "eme" .
iana('Eastern Meohang') --> "emg" .
iana('Mussau-Emira') --> "emi" .
iana('Eastern Maninkakan') --> "emk" .
iana('Mamulique') --> "emm" .
iana('Eman') --> "emn" .
iana('Emok') --> "emo" .
iana('Northern Emberá') --> "emp" .
iana('Pacific Gulf Yupik') --> "ems" .
iana('Eastern Muria') --> "emu" .
iana('Emplawas') --> "emw" .
iana('Erromintxela') --> "emx" .
iana('Epigraphic Mayan') --> "emy" .
iana('Apali') --> "ena" .
iana('Markweeta') --> "enb" .
iana('En') --> "enc" .
iana('Ende') --> "end" .
iana('Forest Enets') --> "enf" .
iana('Tundra Enets') --> "enh" .
iana('Enlhet') --> "enl" .
iana('Middle English (1100-1500)') --> "enm" .
iana('Engenni') --> "enn" .
iana('Enggano') --> "eno" .
iana('Enga') --> "enq" .
iana('Emumu') --> "enr" .
iana('Enu') --> "enu" .
iana('Enwan (Edu State)') --> "env" .
iana('Enwan (Akwa Ibom State)') --> "enw" .
iana('Enxet') --> "enx" .
iana('Beti (Côte d\'Ivoire)') --> "eot" .
iana('Epie') --> "epi" .
iana('Eravallan') --> "era" .
iana('Sie') --> "erg" .
iana('Eruwa') --> "erh" .
iana('Ogea') --> "eri" .
iana('South Efate') --> "erk" .
iana('Horpa') --> "ero" .
iana('Erre') --> "err" .
iana('Ersu') --> "ers" .
iana('Eritai') --> "ert" .
iana('Erokwanas') --> "erw" .
iana('Ese Ejja') --> "ese" .
iana('Eshtehardi') --> "esh" .
iana('North Alaskan Inupiatun') --> "esi" .
iana('Northwest Alaska Inupiatun') --> "esk" .
iana('Egypt Sign Language') --> "esl" .
iana('Esuma') --> "esm" .
iana('Salvadoran Sign Language') --> "esn" .
iana('Estonian Sign Language') --> "eso" .
iana('Esselen') --> "esq" .
iana('Central Siberian Yupik') --> "ess" .
iana('Central Yupik') --> "esu" .
iana('Eskimo-Aleut languages') --> "esx" .
iana('Eskayan') --> "esy" .
iana('Etebi') --> "etb" .
iana('Etchemin') --> "etc" .
iana('Ethiopian Sign Language') --> "eth" .
iana('Eton (Vanuatu)') --> "etn" .
iana('Eton (Cameroon)') --> "eto" .
iana('Edolo') --> "etr" .
iana('Yekhee') --> "ets" .
iana('Etruscan') --> "ett" .
iana('Ejagham') --> "etu" .
iana('Eten') --> "etx" .
iana('Semimi') --> "etz" .
iana('Basque (family)') --> "euq" .
iana('Even') --> "eve" .
iana('Uvbie') --> "evh" .
iana('Evenki') --> "evn" .
iana('Ewondo') --> "ewo" .
iana('Extremaduran') --> "ext" .
iana('Eyak') --> "eya" .
iana('Keiyo') --> "eyo" .
iana('Ezaa') --> "eza" .
iana('Uzekwe') --> "eze" .
iana('Fasu') --> "faa" .
iana('Fa d\'Ambu') --> "fab" .
iana('Wagi') --> "fad" .
iana('Fagani') --> "faf" .
iana('Finongan') --> "fag" .
iana('Baissa Fali') --> "fah" .
iana('Faiwol') --> "fai" .
iana('Faita') --> "faj" .
iana('Fang (Cameroon)') --> "fak" .
iana('South Fali') --> "fal" .
iana('Fam') --> "fam" .
iana('Fang (Equatorial Guinea)') --> "fan" .
iana('Palor') --> "fap" .
iana('Fataleka') --> "far" .
iana('Fanti') --> "fat" .
iana('Fayu') --> "fau" .
iana('Fala') --> "fax" .
iana('Southwestern Fars') --> "fay" .
iana('Northwestern Fars') --> "faz" .
iana('West Albay Bikol') --> "fbl" .
iana('Quebec Sign Language') --> "fcs" .
iana('Feroge') --> "fer" .
iana('Foia Foia') --> "ffi" .
iana('Maasina Fulfulde') --> "ffm" .
iana('Fongoro') --> "fgr" .
iana('Nobiin') --> "fia" .
iana('Fyer') --> "fie" .
iana('Filipino') --> "fil" .
iana('Fipa') --> "fip" .
iana('Firan') --> "fir" .
iana('Tornedalen Finnish') --> "fit" .
iana('Finno-Ugrian languages') --> "fiu" .
iana('Fiwaga') --> "fiw" .
iana('Kirya-Konzəl') --> "fkk" .
iana('Kven Finnish') --> "fkv" .
iana('Kalispel-Pend d\'Oreille') --> "fla" .
iana('Foau') --> "flh" .
iana('Fali') --> "fli" .
iana('North Fali') --> "fll" .
iana('Flinders Island') --> "fln" .
iana('Fuliiru') --> "flr" .
iana('Flaaitaal') --> "fly" .
iana('Fe\'fe\'') --> "fmp" .
iana('Far Western Muria') --> "fmu" .
iana('Fanagalo') --> "fng" .
iana('Fania') --> "fni" .
iana('Foodo') --> "fod" .
iana('Foi') --> "foi" .
iana('Foma') --> "fom" .
iana('Fon') --> "fon" .
iana('Fore') --> "for" .
iana('Siraya') --> "fos" .
iana('Formosan languages') --> "fox" .
iana('Fernando Po Creole English') --> "fpe" .
iana('Fas') --> "fqs" .
iana('Cajun French') --> "frc" .
iana('Fordata') --> "frd" .
iana('Frankish') --> "frk" .
iana('Middle French (ca. 1400-1600)') --> "frm" .
iana('Old French (842-ca. 1400)') --> "fro" .
iana('Arpitan') --> "frp" .
iana('Forak') --> "frq" .
iana('Northern Frisian') --> "frr" .
iana('Eastern Frisian') --> "frs" .
iana('Fortsenal') --> "frt" .
iana('Finnish Sign Language') --> "fse" .
iana('French Sign Language') --> "fsl" .
iana('Finland-Swedish Sign Language') --> "fss" .
iana('Adamawa Fulfulde') --> "fub" .
iana('Pulaar') --> "fuc" .
iana('East Futuna') --> "fud" .
iana('Borgu Fulfulde') --> "fue" .
iana('Pular') --> "fuf" .
iana('Western Niger Fulfulde') --> "fuh" .
iana('Bagirmi Fulfulde') --> "fui" .
iana('Ko') --> "fuj" .
iana('Fum') --> "fum" .
iana('Fulniô') --> "fun" .
iana('Central-Eastern Niger Fulfulde') --> "fuq" .
iana('Friulian') --> "fur" .
iana('Futuna-Aniwa') --> "fut" .
iana('Furu') --> "fuu" .
iana('Nigerian Fulfulde') --> "fuv" .
iana('Fuyug') --> "fuy" .
iana('Fur') --> "fvr" .
iana('Fwâi') --> "fwa" .
iana('Fwe') --> "fwe" .
iana('Ga') --> "gaa" .
iana('Gabri') --> "gab" .
iana('Mixed Great Andamanese') --> "gac" .
iana('Gaddang') --> "gad" .
iana('Guarequena') --> "gae" .
iana('Gende') --> "gaf" .
iana('Gagauz') --> "gag" .
iana('Alekano') --> "gah" .
iana('Borei') --> "gai" .
iana('Gadsup') --> "gaj" .
iana('Gamkonora') --> "gak" .
iana('Galolen') --> "gal" .
iana('Kandawo') --> "gam" .
iana('Gan Chinese') --> "gan" .
iana('Gants') --> "gao" .
iana('Gal') --> "gap" .
iana('Gata\'') --> "gaq" .
iana('Galeya') --> "gar" .
iana('Adiwasi Garasia') --> "gas" .
iana('Kenati') --> "gat" .
iana('Mudhili Gadaba') --> "gau" .
iana('Gabutamon') --> "gav" .
iana('Nobonob') --> "gaw" .
iana('Borana-Arsi-Guji Oromo') --> "gax" .
iana('Gayo') --> "gay" .
iana('West Central Oromo') --> "gaz" .
iana('Gbaya (Central African Republic)') --> "gba" .
iana('Kaytetye') --> "gbb" .
iana('Garawa') --> "gbc" .
iana('Karadjeri') --> "gbd" .
iana('Niksek') --> "gbe" .
iana('Gaikundi') --> "gbf" .
iana('Gbanziri') --> "gbg" .
iana('Defi Gbe') --> "gbh" .
iana('Galela') --> "gbi" .
iana('Bodo Gadaba') --> "gbj" .
iana('Gaddi') --> "gbk" .
iana('Gamit') --> "gbl" .
iana('Garhwali') --> "gbm" .
iana('Mo\'da') --> "gbn" .
iana('Northern Grebo') --> "gbo" .
iana('Gbaya-Bossangoa') --> "gbp" .
iana('Gbaya-Bozoum') --> "gbq" .
iana('Gbagyi') --> "gbr" .
iana('Gbesi Gbe') --> "gbs" .
iana('Gagadu') --> "gbu" .
iana('Gbanu') --> "gbv" .
iana('Gabi-Gabi') --> "gbw" .
iana('Eastern Xwla Gbe') --> "gbx" .
iana('Gbari') --> "gby" .
iana('Zoroastrian Dari') --> "gbz" .
iana('Mali') --> "gcc" .
iana('Ganggalida') --> "gcd" .
iana('Galice') --> "gce" .
iana('Guadeloupean Creole French') --> "gcf" .
iana('Grenadian Creole English') --> "gcl" .
iana('Gaina') --> "gcn" .
iana('Guianese Creole French') --> "gcr" .
iana('Colonia Tovar German') --> "gct" .
iana('Gade Lohar') --> "gda" .
iana('Pottangi Ollar Gadaba') --> "gdb" .
iana('Gugu Badhun') --> "gdc" .
iana('Gedaged') --> "gdd" .
iana('Gude') --> "gde" .
iana('Guduf-Gava') --> "gdf" .
iana('Ga\'dang') --> "gdg" .
iana('Gadjerawang') --> "gdh" .
iana('Gundi') --> "gdi" .
iana('Gurdjar') --> "gdj" .
iana('Gadang') --> "gdk" .
iana('Dirasha') --> "gdl" .
iana('Laal') --> "gdm" .
iana('Umanakaina') --> "gdn" .
iana('Ghodoberi') --> "gdo" .
iana('Mehri') --> "gdq" .
iana('Wipi') --> "gdr" .
iana('Ghandruk Sign Language') --> "gds" .
iana('Kungardutyi') --> "gdt" .
iana('Gudu') --> "gdu" .
iana('Godwari') --> "gdx" .
iana('Geruma') --> "gea" .
iana('Kire') --> "geb" .
iana('Gboloo Grebo') --> "gec" .
iana('Gade') --> "ged" .
iana('Gengle') --> "geg" .
iana('Hutterite German') --> "geh" .
iana('Gebe') --> "gei" .
iana('Gen') --> "gej" .
iana('Yiwom') --> "gek" .
iana('ut-Ma\'in') --> "gel" .
iana('Germanic languages') --> "gem" .
iana('Geme') --> "geq" .
iana('Geser-Gorom') --> "ges" .
iana('Eviya') --> "gev" .
iana('Gera') --> "gew" .
iana('Garre') --> "gex" .
iana('Enya') --> "gey" .
iana('Geez') --> "gez" .
iana('Patpatar') --> "gfk" .
iana('Gafat') --> "gft" .
iana('Mangetti Dune !Xung') --> "gfx" .
iana('Gao') --> "gga" .
iana('Gbii') --> "ggb" .
iana('Gugadj') --> "ggd" .
iana('Guragone') --> "gge" .
iana('Gurgula') --> "ggg" .
iana('Kungarakany') --> "ggk" .
iana('Ganglau') --> "ggl" .
iana('Eastern Gurung') --> "ggn" .
iana('Southern Gondi') --> "ggo" .
iana('Aghu Tharnggalu') --> "ggr" .
iana('Gitua') --> "ggt" .
iana('Gagu') --> "ggu" .
iana('Gogodala') --> "ggw" .
iana('Ghadamès') --> "gha" .
iana('Hiberno-Scottish Gaelic') --> "ghc" .
iana('Southern Ghale') --> "ghe" .
iana('Northern Ghale') --> "ghh" .
iana('Geko Karen') --> "ghk" .
iana('Ghulfan') --> "ghl" .
iana('Ghanongga') --> "ghn" .
iana('Ghomara') --> "gho" .
iana('Ghera') --> "ghr" .
iana('Guhu-Samane') --> "ghs" .
iana('Kuke') --> "ght" .
iana('Kitja') --> "gia" .
iana('Gibanawa') --> "gib" .
iana('Gail') --> "gic" .
iana('Gidar') --> "gid" .
iana('Goaria') --> "gig" .
iana('Githabul') --> "gih" .
iana('Gilbertese') --> "gil" .
iana('Gimi (Eastern Highlands)') --> "gim" .
iana('Hinukh') --> "gin" .
iana('Gelao') --> "gio" .
iana('Gimi (West New Britain)') --> "gip" .
iana('Green Gelao') --> "giq" .
iana('Red Gelao') --> "gir" .
iana('North Giziga') --> "gis" .
iana('Gitxsan') --> "git" .
iana('Mulao') --> "giu" .
iana('White Gelao') --> "giw" .
iana('Gilima') --> "gix" .
iana('Giyug') --> "giy" .
iana('South Giziga') --> "giz" .
iana('Geji') --> "gji" .
iana('Kachi Koli') --> "gjk" .
iana('Gunditjmara') --> "gjm" .
iana('Gonja') --> "gjn" .
iana('Gujari') --> "gju" .
iana('Guya') --> "gka" .
iana('Ndai') --> "gke" .
iana('Gokana') --> "gkn" .
iana('Kok-Nar') --> "gko" .
iana('Guinea Kpelle') --> "gkp" .
iana('ǂUngkue') --> "gku" .
iana('Bon Gula') --> "glc" .
iana('Nanai') --> "gld" .
iana('Northwest Pashai') --> "glh" .
iana('Guliguli') --> "gli" .
iana('Gula Iro') --> "glj" .
iana('Gilaki') --> "glk" .
iana('Garlali') --> "gll" .
iana('Galambu') --> "glo" .
iana('Glaro-Twabo') --> "glr" .
iana('Gula (Chad)') --> "glu" .
iana('Glavda') --> "glw" .
iana('Gule') --> "gly" .
iana('Gambera') --> "gma" .
iana('Gula\'alaa') --> "gmb" .
iana('Mághdì') --> "gmd" .
iana('East Germanic languages') --> "gme" .
iana('Magɨyi') --> "gmg" .
iana('Middle High German (ca. 1050-1500)') --> "gmh" .
iana('Middle Low German') --> "gml" .
iana('Gbaya-Mbodomo') --> "gmm" .
iana('Gimnime') --> "gmn" .
iana('North Germanic languages') --> "gmq" .
iana('Gumalu') --> "gmu" .
iana('Gamo') --> "gmv" .
iana('West Germanic languages') --> "gmw" .
iana('Magoma') --> "gmx" .
iana('Mycenaean Greek') --> "gmy" .
iana('Mgbolizhia') --> "gmz" .
iana('Kaansa') --> "gna" .
iana('Gangte') --> "gnb" .
iana('Guanche') --> "gnc" .
iana('Zulgo-Gemzek') --> "gnd" .
iana('Ganang') --> "gne" .
iana('Ngangam') --> "gng" .
iana('Lere') --> "gnh" .
iana('Gooniyandi') --> "gni" .
iana('//Gana') --> "gnk" .
iana('Gangulu') --> "gnl" .
iana('Ginuman') --> "gnm" .
iana('Gumatj') --> "gnn" .
iana('Northern Gondi') --> "gno" .
iana('Gana') --> "gnq" .
iana('Gureng Gureng') --> "gnr" .
iana('Guntai') --> "gnt" .
iana('Gnau') --> "gnu" .
iana('Western Bolivian Guaraní') --> "gnw" .
iana('Ganzi') --> "gnz" .
iana('Guro') --> "goa" .
iana('Playero') --> "gob" .
iana('Gorakor') --> "goc" .
iana('Godié') --> "god" .
iana('Gongduk') --> "goe" .
iana('Gofa') --> "gof" .
iana('Gogo') --> "gog" .
iana('Old High German (ca. 750-1050)') --> "goh" .
iana('Gobasi') --> "goi" .
iana('Gowlan') --> "goj" .
iana('Gowli') --> "gok" .
iana('Gola') --> "gol" .
iana('Goan Konkani') --> "gom" .
iana('Gondi') --> "gon" .
iana('Gone Dau') --> "goo" .
iana('Yeretuar') --> "gop" .
iana('Gorap') --> "goq" .
iana('Gorontalo') --> "gor" .
iana('Gronings') --> "gos" .
iana('Gothic') --> "got" .
iana('Gavar') --> "gou" .
iana('Gorowa') --> "gow" .
iana('Gobu') --> "gox" .
iana('Goundo') --> "goy" .
iana('Gozarkhani') --> "goz" .
iana('Gupa-Abawa') --> "gpa" .
iana('Ghanaian Pidgin English') --> "gpe" .
iana('Taiap') --> "gpn" .
iana('Ga\'anda') --> "gqa" .
iana('Guiqiong') --> "gqi" .
iana('Guana (Brazil)') --> "gqn" .
iana('Gor') --> "gqr" .
iana('Qau') --> "gqu" .
iana('Rajput Garasia') --> "gra" .
iana('Grebo') --> "grb" .
iana('Ancient Greek (to 1453)') --> "grc" .
iana('Guruntum-Mbaaru') --> "grd" .
iana('Madi') --> "grg" .
iana('Gbiri-Niragu') --> "grh" .
iana('Ghari') --> "gri" .
iana('Southern Grebo') --> "grj" .
iana('Greek languages') --> "grk" .
iana('Kota Marudu Talantang') --> "grm" .
iana('Groma') --> "gro" .
iana('Gorovu') --> "grq" .
iana('Taznatit') --> "grr" .
iana('Gresi') --> "grs" .
iana('Garo') --> "grt" .
iana('Kistane') --> "gru" .
iana('Central Grebo') --> "grv" .
iana('Gweda') --> "grw" .
iana('Guriaso') --> "grx" .
iana('Barclayville Grebo') --> "gry" .
iana('Guramalum') --> "grz" .
iana('Ghanaian Sign Language') --> "gse" .
iana('German Sign Language') --> "gsg" .
iana('Gusilay') --> "gsl" .
iana('Guatemalan Sign Language') --> "gsm" .
iana('Gusan') --> "gsn" .
iana('Southwest Gbaya') --> "gso" .
iana('Wasembo') --> "gsp" .
iana('Greek Sign Language') --> "gss" .
iana('Swiss German') --> "gsw" .
iana('Guató') --> "gta" .
iana('Gbati-ri') --> "gti" .
iana('Aghu-Tharnggala') --> "gtu" .
iana('Shiki') --> "gua" .
iana('Guajajára') --> "gub" .
iana('Wayuu') --> "guc" .
iana('Yocoboué Dida') --> "gud" .
iana('Gurinji') --> "gue" .
iana('Gupapuyngu') --> "guf" .
iana('Paraguayan Guaraní') --> "gug" .
iana('Guahibo') --> "guh" .
iana('Eastern Bolivian Guaraní') --> "gui" .
iana('Gumuz') --> "guk" .
iana('Sea Island Creole English') --> "gul" .
iana('Guambiano') --> "gum" .
iana('Mbyá Guaraní') --> "gun" .
iana('Guayabero') --> "guo" .
iana('Gunwinggu') --> "gup" .
iana('Aché') --> "guq" .
iana('Farefare') --> "gur" .
iana('Guinean Sign Language') --> "gus" .
iana('Maléku Jaíka') --> "gut" .
iana('Yanomamö') --> "guu" .
iana('Gey') --> "guv" .
iana('Gun') --> "guw" .
iana('Gourmanchéma') --> "gux" .
iana('Gusii') --> "guz" .
iana('Guana (Paraguay)') --> "gva" .
iana('Guanano') --> "gvc" .
iana('Duwet') --> "gve" .
iana('Golin') --> "gvf" .
iana('Guajá') --> "gvj" .
iana('Gulay') --> "gvl" .
iana('Gurmana') --> "gvm" .
iana('Kuku-Yalanji') --> "gvn" .
iana('Gavião Do Jiparaná') --> "gvo" .
iana('Pará Gavião') --> "gvp" .
iana('Western Gurung') --> "gvr" .
iana('Gumawana') --> "gvs" .
iana('Guyani') --> "gvy" .
iana('Mbato') --> "gwa" .
iana('Gwa') --> "gwb" .
iana('Kalami') --> "gwc" .
iana('Gawwada') --> "gwd" .
iana('Gweno') --> "gwe" .
iana('Gowro') --> "gwf" .
iana('Moo') --> "gwg" .
iana('Gwichʼin') --> "gwi" .
iana('/Gwi') --> "gwj" .
iana('Awngthim') --> "gwm" .
iana('Gwandara') --> "gwn" .
iana('Gwere') --> "gwr" .
iana('Gawar-Bati') --> "gwt" .
iana('Guwamu') --> "gwu" .
iana('Kwini') --> "gww" .
iana('Gua') --> "gwx" .
iana('Wè Southern') --> "gxx" .
iana('Northwest Gbaya') --> "gya" .
iana('Garus') --> "gyb" .
iana('Kayardild') --> "gyd" .
iana('Gyem') --> "gye" .
iana('Gungabula') --> "gyf" .
iana('Gbayi') --> "gyg" .
iana('Gyele') --> "gyi" .
iana('Gayil') --> "gyl" .
iana('Ngäbere') --> "gym" .
iana('Guyanese Creole English') --> "gyn" .
iana('Guarayu') --> "gyr" .
iana('Gunya') --> "gyy" .
iana('Ganza') --> "gza" .
iana('Gazi') --> "gzi" .
iana('Gane') --> "gzn" .
iana('Han') --> "haa" .
iana('Hanoi Sign Language') --> "hab" .
iana('Gurani') --> "hac" .
iana('Hatam') --> "had" .
iana('Eastern Oromo') --> "hae" .
iana('Haiphong Sign Language') --> "haf" .
iana('Hanga') --> "hag" .
iana('Hahon') --> "hah" .
iana('Haida') --> "hai" .
iana('Hajong') --> "haj" .
iana('Hakka Chinese') --> "hak" .
iana('Halang') --> "hal" .
iana('Hewa') --> "ham" .
iana('Hangaza') --> "han" .
iana('Hakö') --> "hao" .
iana('Hupla') --> "hap" .
iana('Ha') --> "haq" .
iana('Harari') --> "har" .
iana('Haisla') --> "has" .
iana('Havu') --> "hav" .
iana('Hawaiian') --> "haw" .
iana('Southern Haida') --> "hax" .
iana('Haya') --> "hay" .
iana('Hazaragi') --> "haz" .
iana('Hamba') --> "hba" .
iana('Huba') --> "hbb" .
iana('Heiban') --> "hbn" .
iana('Ancient Hebrew') --> "hbo" .
iana('Habu') --> "hbu" .
iana('Andaman Creole Hindi') --> "hca" .
iana('Huichol') --> "hch" .
iana('Northern Haida') --> "hdn" .
iana('Honduras Sign Language') --> "hds" .
iana('Hadiyya') --> "hdy" .
iana('Northern Qiandong Miao') --> "hea" .
iana('Herdé') --> "hed" .
iana('Helong') --> "heg" .
iana('Hehe') --> "heh" .
iana('Heiltsuk') --> "hei" .
iana('Hemba') --> "hem" .
iana('Hai//om') --> "hgm" .
iana('Haigwai') --> "hgw" .
iana('Hoia Hoia') --> "hhi" .
iana('Kerak') --> "hhr" .
iana('Hoyahoya') --> "hhy" .
iana('Lamang') --> "hia" .
iana('Hibito') --> "hib" .
iana('Hidatsa') --> "hid" .
iana('Fiji Hindi') --> "hif" .
iana('Kamwe') --> "hig" .
iana('Pamosu') --> "hih" .
iana('Hinduri') --> "hii" .
iana('Hijuk') --> "hij" .
iana('Seit-Kaitetu') --> "hik" .
iana('Hiligaynon') --> "hil" .
iana('Himachali languages') --> "him" .
iana('Tsoa') --> "hio" .
iana('Himarimã') --> "hir" .
iana('Hittite') --> "hit" .
iana('Hiw') --> "hiw" .
iana('Hixkaryána') --> "hix" .
iana('Haji') --> "hji" .
iana('Kahe') --> "hka" .
iana('Hunde') --> "hke" .
iana('Hunjara-Kaina Ke') --> "hkk" .
iana('Hong Kong Sign Language') --> "hks" .
iana('Halia') --> "hla" .
iana('Halbi') --> "hlb" .
iana('Halang Doan') --> "hld" .
iana('Hlersu') --> "hle" .
iana('Matu Chin') --> "hlt" .
iana('Hieroglyphic Luwian') --> "hlu" .
iana('Southern Mashan Hmong') --> "hma" .
iana('Humburi Senni Songhay') --> "hmb" .
iana('Central Huishui Hmong') --> "hmc" .
iana('Large Flowery Miao') --> "hmd" .
iana('Eastern Huishui Hmong') --> "hme" .
iana('Hmong Don') --> "hmf" .
iana('Southwestern Guiyang Hmong') --> "hmg" .
iana('Southwestern Huishui Hmong') --> "hmh" .
iana('Northern Huishui Hmong') --> "hmi" .
iana('Ge') --> "hmj" .
iana('Maek') --> "hmk" .
iana('Luopohe Hmong') --> "hml" .
iana('Central Mashan Hmong') --> "hmm" .
iana('Hmong') --> "hmn" .
iana('Northern Mashan Hmong') --> "hmp" .
iana('Eastern Qiandong Miao') --> "hmq" .
iana('Hmar') --> "hmr" .
iana('Southern Qiandong Miao') --> "hms" .
iana('Hamtai') --> "hmt" .
iana('Hamap') --> "hmu" .
iana('Hmong Dô') --> "hmv" .
iana('Western Mashan Hmong') --> "hmw" .
iana('Hmong-Mien languages') --> "hmx" .
iana('Southern Guiyang Hmong') --> "hmy" .
iana('Hmong Shua') --> "hmz" .
iana('Mina (Cameroon)') --> "hna" .
iana('Southern Hindko') --> "hnd" .
iana('Chhattisgarhi') --> "hne" .
iana('//Ani') --> "hnh" .
iana('Hani') --> "hni" .
iana('Hmong Njua') --> "hnj" .
iana('Hanunoo') --> "hnn" .
iana('Northern Hindko') --> "hno" .
iana('Caribbean Hindustani') --> "hns" .
iana('Hung') --> "hnu" .
iana('Hoava') --> "hoa" .
iana('Mari (Madang Province)') --> "hob" .
iana('Ho') --> "hoc" .
iana('Holma') --> "hod" .
iana('Horom') --> "hoe" .
iana('Hobyót') --> "hoh" .
iana('Holikachuk') --> "hoi" .
iana('Hadothi') --> "hoj" .
iana('Hokan languages') --> "hok" .
iana('Holu') --> "hol" .
iana('Homa') --> "hom" .
iana('Holoholo') --> "hoo" .
iana('Hopi') --> "hop" .
iana('Horo') --> "hor" .
iana('Ho Chi Minh City Sign Language') --> "hos" .
iana('Hote') --> "hot" .
iana('Hovongan') --> "hov" .
iana('Honi') --> "how" .
iana('Holiya') --> "hoy" .
iana('Hozo') --> "hoz" .
iana('Hpon') --> "hpo" .
iana('Hawai\'i Sign Language (HSL)') --> "hps" .
iana('Hrangkhol') --> "hra" .
iana('Niwer Mil') --> "hrc" .
iana('Hre') --> "hre" .
iana('Haruku') --> "hrk" .
iana('Horned Miao') --> "hrm" .
iana('Haroi') --> "hro" .
iana('Nhirrpi') --> "hrp" .
iana('Horuru') --> "hrr" .
iana('Hértevin') --> "hrt" .
iana('Hruso') --> "hru" .
iana('Warwar Feni') --> "hrw" .
iana('Hunsrik') --> "hrx" .
iana('Harzani') --> "hrz" .
iana('Upper Sorbian') --> "hsb" .
iana('Hungarian Sign Language') --> "hsh" .
iana('Hausa Sign Language') --> "hsl" .
iana('Xiang Chinese') --> "hsn" .
iana('Harsusi') --> "hss" .
iana('Hoti') --> "hti" .
iana('Minica Huitoto') --> "hto" .
iana('Hadza') --> "hts" .
iana('Hitu') --> "htu" .
iana('Middle Hittite') --> "htx" .
iana('Huambisa') --> "hub" .
iana('=/Hua') --> "huc" .
iana('Huaulu') --> "hud" .
iana('San Francisco Del Mar Huave') --> "hue" .
iana('Humene') --> "huf" .
iana('Huachipaeri') --> "hug" .
iana('Huilliche') --> "huh" .
iana('Huli') --> "hui" .
iana('Northern Guiyang Hmong') --> "huj" .
iana('Hulung') --> "huk" .
iana('Hula') --> "hul" .
iana('Hungana') --> "hum" .
iana('Hu') --> "huo" .
iana('Hupa') --> "hup" .
iana('Tsat') --> "huq" .
iana('Halkomelem') --> "hur" .
iana('Huastec') --> "hus" .
iana('Humla') --> "hut" .
iana('Murui Huitoto') --> "huu" .
iana('San Mateo Del Mar Huave') --> "huv" .
iana('Hukumina') --> "huw" .
iana('Nüpode Huitoto') --> "hux" .
iana('Hulaulá') --> "huy" .
iana('Hunzib') --> "huz" .
iana('Haitian Vodoun Culture Language') --> "hvc" .
iana('San Dionisio Del Mar Huave') --> "hve" .
iana('Haveke') --> "hvk" .
iana('Sabu') --> "hvn" .
iana('Santa María Del Mar Huave') --> "hvv" .
iana('Wané') --> "hwa" .
iana('Hawai\'i Creole English') --> "hwc" .
iana('Hwana') --> "hwo" .
iana('Hya') --> "hya" .
iana('Armenian (family)') --> "hyx" .
iana('Iaai') --> "iai" .
iana('Iatmul') --> "ian" .
iana('Iapama') --> "iap" .
iana('Purari') --> "iar" .
iana('Iban') --> "iba" .
iana('Ibibio') --> "ibb" .
iana('Iwaidja') --> "ibd" .
iana('Akpes') --> "ibe" .
iana('Ibanag') --> "ibg" .
iana('Ibilo') --> "ibi" .
iana('Ibaloi') --> "ibl" .
iana('Agoi') --> "ibm" .
iana('Ibino') --> "ibn" .
iana('Ibuoro') --> "ibr" .
iana('Ibu') --> "ibu" .
iana('Ibani') --> "iby" .
iana('Ede Ica') --> "ica" .
iana('Etkywan') --> "ich" .
iana('Icelandic Sign Language') --> "icl" .
iana('Islander Creole English') --> "icr" .
iana('Idakho-Isukha-Tiriki') --> "ida" .
iana('Indo-Portuguese') --> "idb" .
iana('Idon') --> "idc" .
iana('Ede Idaca') --> "idd" .
iana('Idere') --> "ide" .
iana('Idi') --> "idi" .
iana('Indri') --> "idr" .
iana('Idesa') --> "ids" .
iana('Idaté') --> "idt" .
iana('Idoma') --> "idu" .
iana('Amganad Ifugao') --> "ifa" .
iana('Batad Ifugao') --> "ifb" .
iana('Ifè') --> "ife" .
iana('Ifo') --> "iff" .
iana('Tuwali Ifugao') --> "ifk" .
iana('Teke-Fuumu') --> "ifm" .
iana('Mayoyao Ifugao') --> "ifu" .
iana('Keley-I Kallahan') --> "ify" .
iana('Ebira') --> "igb" .
iana('Igede') --> "ige" .
iana('Igana') --> "igg" .
iana('Igala') --> "igl" .
iana('Kanggape') --> "igm" .
iana('Ignaciano') --> "ign" .
iana('Isebe') --> "igo" .
iana('Interglossa') --> "igs" .
iana('Igwe') --> "igw" .
iana('Iha Based Pidgin') --> "ihb" .
iana('Ihievbe') --> "ihi" .
iana('Iha') --> "ihp" .
iana('Bidhawal') --> "ihw" .
iana('Thiin') --> "iin" .
iana('Indo-Iranian languages') --> "iir" .
iana('Izon') --> "ijc" .
iana('Biseni') --> "ije" .
iana('Ede Ije') --> "ijj" .
iana('Kalabari') --> "ijn" .
iana('Ijo languages') --> "ijo" .
iana('Southeast Ijo') --> "ijs" .
iana('Eastern Canadian Inuktitut') --> "ike" .
iana('Iko') --> "iki" .
iana('Ika') --> "ikk" .
iana('Ikulu') --> "ikl" .
iana('Olulumo-Ikom') --> "iko" .
iana('Ikpeshi') --> "ikp" .
iana('Ikaranggal') --> "ikr" .
iana('Inuit Sign Language') --> "iks" .
iana('Inuinnaqtun') --> "ikt" .
iana('Iku-Gora-Ankwa') --> "ikv" .
iana('Ikwere') --> "ikw" .
iana('Ik') --> "ikx" .
iana('Ikizu') --> "ikz" .
iana('Ile Ape') --> "ila" .
iana('Ila') --> "ilb" .
iana('Garig-Ilgar') --> "ilg" .
iana('Ili Turki') --> "ili" .
iana('Ilongot') --> "ilk" .
iana('Iranun') --> "ill" .
iana('Iloko') --> "ilo" .
iana('International Sign') --> "ils" .
iana('Ili\'uun') --> "ilu" .
iana('Ilue') --> "ilv" .
iana('Talur') --> "ilw" .
iana('Mala Malasar') --> "ima" .
iana('Imeraguen') --> "ime" .
iana('Anamgura') --> "imi" .
iana('Miluk') --> "iml" .
iana('Imonda') --> "imn" .
iana('Imbongu') --> "imo" .
iana('Imroing') --> "imr" .
iana('Marsian') --> "ims" .
iana('Milyan') --> "imy" .
iana('Inga') --> "inb" .
iana('Indic languages') --> "inc" .
iana('Indo-European languages') --> "ine" .
iana('Degexit\'an') --> "ing" .
iana('Ingush') --> "inh" .
iana('Jungle Inga') --> "inj" .
iana('Indonesian Sign Language') --> "inl" .
iana('Minaean') --> "inm" .
iana('Isinai') --> "inn" .
iana('Inoke-Yate') --> "ino" .
iana('Iñapari') --> "inp" .
iana('Indian Sign Language') --> "ins" .
iana('Intha') --> "int" .
iana('Ineseño') --> "inz" .
iana('Inor') --> "ior" .
iana('Tuma-Irumu') --> "iou" .
iana('Iowa-Oto') --> "iow" .
iana('Ipili') --> "ipi" .
iana('Ipiko') --> "ipo" .
iana('Iquito') --> "iqu" .
iana('Ikwo') --> "iqw" .
iana('Iranian languages') --> "ira" .
iana('Iresim') --> "ire" .
iana('Irarutu') --> "irh" .
iana('Irigwe') --> "iri" .
iana('Iraqw') --> "irk" .
iana('Irántxe') --> "irn" .
iana('Iroquoian languages') --> "iro" .
iana('Ir') --> "irr" .
iana('Irula') --> "iru" .
iana('Kamberau') --> "irx" .
iana('Iraya') --> "iry" .
iana('Isabi') --> "isa" .
iana('Isconahua') --> "isc" .
iana('Isnag') --> "isd" .
iana('Italian Sign Language') --> "ise" .
iana('Irish Sign Language') --> "isg" .
iana('Esan') --> "ish" .
iana('Nkem-Nkum') --> "isi" .
iana('Ishkashimi') --> "isk" .
iana('Masimasi') --> "ism" .
iana('Isanzu') --> "isn" .
iana('Isoko') --> "iso" .
iana('Israeli Sign Language') --> "isr" .
iana('Istriot') --> "ist" .
iana('Isu (Menchum Division)') --> "isu" .
iana('Binongan Itneg') --> "itb" .
iana('Italic languages') --> "itc" .
iana('Itene') --> "ite" .
iana('Inlaod Itneg') --> "iti" .
iana('Judeo-Italian') --> "itk" .
iana('Itelmen') --> "itl" .
iana('Itu Mbon Uzo') --> "itm" .
iana('Itonama') --> "ito" .
iana('Iteri') --> "itr" .
iana('Isekiri') --> "its" .
iana('Maeng Itneg') --> "itt" .
iana('Itawit') --> "itv" .
iana('Ito') --> "itw" .
iana('Itik') --> "itx" .
iana('Moyadan Itneg') --> "ity" .
iana('Itzá') --> "itz" .
iana('Iu Mien') --> "ium" .
iana('Ibatan') --> "ivb" .
iana('Ivatan') --> "ivv" .
iana('I-Wak') --> "iwk" .
iana('Iwam') --> "iwm" .
iana('Iwur') --> "iwo" .
iana('Sepik Iwam') --> "iws" .
iana('Ixcatec') --> "ixc" .
iana('Ixil') --> "ixl" .
iana('Iyayu') --> "iya" .
iana('Mesaka') --> "iyo" .
iana('Yaka (Congo)') --> "iyx" .
iana('Ingrian') --> "izh" .
iana('Izi-Ezaa-Ikwo-Mgbo') --> "izi" .
iana('Izere') --> "izr" .
iana('Izii') --> "izz" .
iana('Jamamadí') --> "jaa" .
iana('Hyam') --> "jab" .
iana('Popti\'') --> "jac" .
iana('Jahanka') --> "jad" .
iana('Yabem') --> "jae" .
iana('Jara') --> "jaf" .
iana('Jah Hut') --> "jah" .
iana('Zazao') --> "jaj" .
iana('Jakun') --> "jak" .
iana('Yalahatan') --> "jal" .
iana('Jamaican Creole English') --> "jam" .
iana('Jandai') --> "jan" .
iana('Yanyuwa') --> "jao" .
iana('Yaqay') --> "jaq" .
iana('Jarawa (Nigeria)') --> "jar" .
iana('New Caledonian Javanese') --> "jas" .
iana('Jakati') --> "jat" .
iana('Yaur') --> "jau" .
iana('Jambi Malay') --> "jax" .
iana('Yan-nhangu') --> "jay" .
iana('Jawe') --> "jaz" .
iana('Judeo-Berber') --> "jbe" .
iana('Badjiri') --> "jbi" .
iana('Arandai') --> "jbj" .
iana('Barikewa') --> "jbk" .
iana('Nafusi') --> "jbn" .
iana('Lojban') --> "jbo" .
iana('Jofotek-Bromnya') --> "jbr" .
iana('Jabutí') --> "jbt" .
iana('Jukun Takum') --> "jbu" .
iana('Yawijibaya') --> "jbw" .
iana('Jamaican Country Sign Language') --> "jcs" .
iana('Krymchak') --> "jct" .
iana('Jad') --> "jda" .
iana('Jadgali') --> "jdg" .
iana('Judeo-Tat') --> "jdt" .
iana('Jebero') --> "jeb" .
iana('Jerung') --> "jee" .
iana('Jeng') --> "jeg" .
iana('Jeh') --> "jeh" .
iana('Yei') --> "jei" .
iana('Jeri Kuo') --> "jek" .
iana('Yelmek') --> "jel" .
iana('Dza') --> "jen" .
iana('Jere') --> "jer" .
iana('Manem') --> "jet" .
iana('Jonkor Bourmataguil') --> "jeu" .
iana('Ngbee') --> "jgb" .
iana('Judeo-Georgian') --> "jge" .
iana('Gwak') --> "jgk" .
iana('Ngomba') --> "jgo" .
iana('Jehai') --> "jhi" .
iana('Jhankot Sign Language') --> "jhs" .
iana('Jina') --> "jia" .
iana('Jibu') --> "jib" .
iana('Tol') --> "jic" .
iana('Bu') --> "jid" .
iana('Jilbe') --> "jie" .
iana('Djingili') --> "jig" .
iana('sTodsde') --> "jih" .
iana('Jiiddu') --> "jii" .
iana('Jilim') --> "jil" .
iana('Jimi (Cameroon)') --> "jim" .
iana('Jiamao') --> "jio" .
iana('Guanyinqiao') --> "jiq" .
iana('Jita') --> "jit" .
iana('Youle Jinuo') --> "jiu" .
iana('Shuar') --> "jiv" .
iana('Buyuan Jinuo') --> "jiy" .
iana('Jejueo') --> "jje" .
iana('Bankal') --> "jjr" .
iana('Mobwa Karen') --> "jkm" .
iana('Kubo') --> "jko" .
iana('Paku Karen') --> "jkp" .
iana('Koro (India)') --> "jkr" .
iana('Labir') --> "jku" .
iana('Ngile') --> "jle" .
iana('Jamaican Sign Language') --> "jls" .
iana('Dima') --> "jma" .
iana('Zumbun') --> "jmb" .
iana('Machame') --> "jmc" .
iana('Yamdena') --> "jmd" .
iana('Jimi (Nigeria)') --> "jmi" .
iana('Jumli') --> "jml" .
iana('Makuri Naga') --> "jmn" .
iana('Kamara') --> "jmr" .
iana('Mashi (Nigeria)') --> "jms" .
iana('Mouwase') --> "jmw" .
iana('Western Juxtlahuaca Mixtec') --> "jmx" .
iana('Jangshung') --> "jna" .
iana('Jandavra') --> "jnd" .
iana('Yangman') --> "jng" .
iana('Janji') --> "jni" .
iana('Yemsa') --> "jnj" .
iana('Rawat') --> "jnl" .
iana('Jaunsari') --> "jns" .
iana('Joba') --> "job" .
iana('Wojenaka') --> "jod" .
iana('Jogi') --> "jog" .
iana('Jorá') --> "jor" .
iana('Jordanian Sign Language') --> "jos" .
iana('Jowulu') --> "jow" .
iana('Jewish Palestinian Aramaic') --> "jpa" .
iana('Judeo-Persian') --> "jpr" .
iana('Japanese (family)') --> "jpx" .
iana('Jaqaru') --> "jqr" .
iana('Jarai') --> "jra" .
iana('Judeo-Arabic') --> "jrb" .
iana('Jiru') --> "jrr" .
iana('Jorto') --> "jrt" .
iana('Japrería') --> "jru" .
iana('Japanese Sign Language') --> "jsl" .
iana('Júma') --> "jua" .
iana('Wannu') --> "jub" .
iana('Jurchen') --> "juc" .
iana('Worodougou') --> "jud" .
iana('Hõne') --> "juh" .
iana('Ngadjuri') --> "jui" .
iana('Wapan') --> "juk" .
iana('Jirel') --> "jul" .
iana('Jumjum') --> "jum" .
iana('Juang') --> "jun" .
iana('Jiba') --> "juo" .
iana('Hupdë') --> "jup" .
iana('Jurúna') --> "jur" .
iana('Jumla Sign Language') --> "jus" .
iana('Jutish') --> "jut" .
iana('Ju') --> "juu" .
iana('Wãpha') --> "juw" .
iana('Juray') --> "juy" .
iana('Javindo') --> "jvd" .
iana('Caribbean Javanese') --> "jvn" .
iana('Jwira-Pepesa') --> "jwi" .
iana('Jiarong') --> "jya" .
iana('Judeo-Yemeni Arabic') --> "jye" .
iana('Jaya') --> "jyy" .
iana('Kara-Kalpak') --> "kaa" .
iana('Kabyle') --> "kab" .
iana('Kachin') --> "kac" .
iana('Adara') --> "kad" .
iana('Ketangalan') --> "kae" .
iana('Katso') --> "kaf" .
iana('Kajaman') --> "kag" .
iana('Kara (Central African Republic)') --> "kah" .
iana('Karekare') --> "kai" .
iana('Jju') --> "kaj" .
iana('Kayapa Kallahan') --> "kak" .
iana('Kamba (Kenya)') --> "kam" .
iana('Xaasongaxango') --> "kao" .
iana('Bezhta') --> "kap" .
iana('Capanahua') --> "kaq" .
iana('Karen languages') --> "kar" .
iana('Katukína') --> "kav" .
iana('Kawi') --> "kaw" .
iana('Kao') --> "kax" .
iana('Kamayurá') --> "kay" .
iana('Kalarko') --> "kba" .
iana('Kaxuiâna') --> "kbb" .
iana('Kadiwéu') --> "kbc" .
iana('Kabardian') --> "kbd" .
iana('Kanju') --> "kbe" .
iana('Kakauhua') --> "kbf" .
iana('Khamba') --> "kbg" .
iana('Camsá') --> "kbh" .
iana('Kaptiau') --> "kbi" .
iana('Kari') --> "kbj" .
iana('Grass Koiari') --> "kbk" .
iana('Kanembu') --> "kbl" .
iana('Iwal') --> "kbm" .
iana('Kare (Central African Republic)') --> "kbn" .
iana('Keliko') --> "kbo" .
iana('Kabiyè') --> "kbp" .
iana('Kamano') --> "kbq" .
iana('Kafa') --> "kbr" .
iana('Kande') --> "kbs" .
iana('Abadi') --> "kbt" .
iana('Kabutra') --> "kbu" .
iana('Dera (Indonesia)') --> "kbv" .
iana('Kaiep') --> "kbw" .
iana('Ap Ma') --> "kbx" .
iana('Manga Kanuri') --> "kby" .
iana('Duhwa') --> "kbz" .
iana('Khanty') --> "kca" .
iana('Kawacha') --> "kcb" .
iana('Lubila') --> "kcc" .
iana('Ngkâlmpw Kanum') --> "kcd" .
iana('Kaivi') --> "kce" .
iana('Ukaan') --> "kcf" .
iana('Tyap') --> "kcg" .
iana('Vono') --> "kch" .
iana('Kamantan') --> "kci" .
iana('Kobiana') --> "kck" .
iana('Kela (Papua New Guinea)') --> "kcl" .
iana('Gula (Central African Republic)') --> "kcm" .
iana('Nubi') --> "kcn" .
iana('Kinalakna') --> "kco" .
iana('Kanga') --> "kcp" .
iana('Kamo') --> "kcq" .
iana('Katla') --> "kcr" .
iana('Koenoem') --> "kcs" .
iana('Kaian') --> "kct" .
iana('Kami (Tanzania)') --> "kcu" .
iana('Kete') --> "kcv" .
iana('Kabwari') --> "kcw" .
iana('Kachama-Ganjule') --> "kcx" .
iana('Korandje') --> "kcy" .
iana('Konongo') --> "kcz" .
iana('Worimi') --> "kda" .
iana('Kutu') --> "kdc" .
iana('Yankunytjatjara') --> "kdd" .
iana('Makonde') --> "kde" .
iana('Mamusi') --> "kdf" .
iana('Seba') --> "kdg" .
iana('Tem') --> "kdh" .
iana('Kumam') --> "kdi" .
iana('Karamojong') --> "kdj" .
iana('Numèè') --> "kdk" .
iana('Tsikimba') --> "kdl" .
iana('Kagoma') --> "kdm" .
iana('Kunda') --> "kdn" .
iana('Kordofanian languages') --> "kdo" .
iana('Kaningdon-Nindem') --> "kdp" .
iana('Koch') --> "kdq" .
iana('Karaim') --> "kdr" .
iana('Kuy') --> "kdt" .
iana('Kadaru') --> "kdu" .
iana('Kado') --> "kdv" .
iana('Koneraw') --> "kdw" .
iana('Kam') --> "kdx" .
iana('Keder') --> "kdy" .
iana('Kwaja') --> "kdz" .
iana('Kabuverdianu') --> "kea" .
iana('Kélé') --> "keb" .
iana('Keiga') --> "kec" .
iana('Kerewe') --> "ked" .
iana('Eastern Keres') --> "kee" .
iana('Kpessi') --> "kef" .
iana('Tese') --> "keg" .
iana('Keak') --> "keh" .
iana('Kei') --> "kei" .
iana('Kadar') --> "kej" .
iana('Kekchí') --> "kek" .
iana('Kela (Democratic Republic of Congo)') --> "kel" .
iana('Kemak') --> "kem" .
iana('Kenyang') --> "ken" .
iana('Kakwa') --> "keo" .
iana('Kaikadi') --> "kep" .
iana('Kamar') --> "keq" .
iana('Kera') --> "ker" .
iana('Kugbo') --> "kes" .
iana('Ket') --> "ket" .
iana('Akebu') --> "keu" .
iana('Kanikkaran') --> "kev" .
iana('West Kewa') --> "kew" .
iana('Kukna') --> "kex" .
iana('Kupia') --> "key" .
iana('Kukele') --> "kez" .
iana('Kodava') --> "kfa" .
iana('Northwestern Kolami') --> "kfb" .
iana('Konda-Dora') --> "kfc" .
iana('Korra Koraga') --> "kfd" .
iana('Kota (India)') --> "kfe" .
iana('Koya') --> "kff" .
iana('Kudiya') --> "kfg" .
iana('Kurichiya') --> "kfh" .
iana('Kannada Kurumba') --> "kfi" .
iana('Kemiehua') --> "kfj" .
iana('Kinnauri') --> "kfk" .
iana('Kung') --> "kfl" .
iana('Khunsari') --> "kfm" .
iana('Kuk') --> "kfn" .
iana('Koro (Côte d\'Ivoire)') --> "kfo" .
iana('Korwa') --> "kfp" .
iana('Korku') --> "kfq" .
iana('Kachchi') --> "kfr" .
iana('Bilaspuri') --> "kfs" .
iana('Kanjari') --> "kft" .
iana('Katkari') --> "kfu" .
iana('Kurmukar') --> "kfv" .
iana('Kharam Naga') --> "kfw" .
iana('Kullu Pahari') --> "kfx" .
iana('Kumaoni') --> "kfy" .
iana('Koromfé') --> "kfz" .
iana('Koyaga') --> "kga" .
iana('Kawe') --> "kgb" .
iana('Kasseng') --> "kgc" .
iana('Kataang') --> "kgd" .
iana('Komering') --> "kge" .
iana('Kube') --> "kgf" .
iana('Kusunda') --> "kgg" .
iana('Upper Tanudan Kalinga') --> "kgh" .
iana('Selangor Sign Language') --> "kgi" .
iana('Gamale Kham') --> "kgj" .
iana('Kaiwá') --> "kgk" .
iana('Kunggari') --> "kgl" .
iana('Karipúna') --> "kgm" .
iana('Karingani') --> "kgn" .
iana('Krongo') --> "kgo" .
iana('Kaingang') --> "kgp" .
iana('Kamoro') --> "kgq" .
iana('Abun') --> "kgr" .
iana('Kumbainggar') --> "kgs" .
iana('Somyev') --> "kgt" .
iana('Kobol') --> "kgu" .
iana('Karas') --> "kgv" .
iana('Karon Dori') --> "kgw" .
iana('Kamaru') --> "kgx" .
iana('Kyerung') --> "kgy" .
iana('Khasi') --> "kha" .
iana('Lü') --> "khb" .
iana('Tukang Besi North') --> "khc" .
iana('Bädi Kanum') --> "khd" .
iana('Korowai') --> "khe" .
iana('Khuen') --> "khf" .
iana('Khams Tibetan') --> "khg" .
iana('Kehu') --> "khh" .
iana('Khoisan languages') --> "khi" .
iana('Kuturmi') --> "khj" .
iana('Halh Mongolian') --> "khk" .
iana('Lusi') --> "khl" .
iana('Khandesi') --> "khn" .
iana('Khotanese') --> "kho" .
iana('Kapori') --> "khp" .
iana('Koyra Chiini Songhay') --> "khq" .
iana('Kharia') --> "khr" .
iana('Kasua') --> "khs" .
iana('Khamti') --> "kht" .
iana('Nkhumbi') --> "khu" .
iana('Khvarshi') --> "khv" .
iana('Khowar') --> "khw" .
iana('Kanu') --> "khx" .
iana('Kele (Democratic Republic of Congo)') --> "khy" .
iana('Keapara') --> "khz" .
iana('Kim') --> "kia" .
iana('Koalib') --> "kib" .
iana('Kickapoo') --> "kic" .
iana('Koshin') --> "kid" .
iana('Kibet') --> "kie" .
iana('Eastern Parbate Kham') --> "kif" .
iana('Kimaama') --> "kig" .
iana('Kilmeri') --> "kih" .
iana('Kitsai') --> "kii" .
iana('Kilivila') --> "kij" .
iana('Kariya') --> "kil" .
iana('Karagas') --> "kim" .
iana('Kiowa') --> "kio" .
iana('Sheshi Kham') --> "kip" .
iana('Kosadle') --> "kiq" .
iana('Kis') --> "kis" .
iana('Agob') --> "kit" .
iana('Kirmanjki (individual language)') --> "kiu" .
iana('Kimbu') --> "kiv" .
iana('Northeast Kiwai') --> "kiw" .
iana('Khiamniungan Naga') --> "kix" .
iana('Kirikiri') --> "kiy" .
iana('Kisi') --> "kiz" .
iana('Mlap') --> "kja" .
iana('Q\'anjob\'al') --> "kjb" .
iana('Coastal Konjo') --> "kjc" .
iana('Southern Kiwai') --> "kjd" .
iana('Kisar') --> "kje" .
iana('Khalaj') --> "kjf" .
iana('Khmu') --> "kjg" .
iana('Khakas') --> "kjh" .
iana('Zabana') --> "kji" .
iana('Khinalugh') --> "kjj" .
iana('Highland Konjo') --> "kjk" .
iana('Western Parbate Kham') --> "kjl" .
iana('Kháng') --> "kjm" .
iana('Kunjen') --> "kjn" .
iana('Harijan Kinnauri') --> "kjo" .
iana('Pwo Eastern Karen') --> "kjp" .
iana('Western Keres') --> "kjq" .
iana('Kurudu') --> "kjr" .
iana('East Kewa') --> "kjs" .
iana('Phrae Pwo Karen') --> "kjt" .
iana('Kashaya') --> "kju" .
iana('Kaikavian Literary Language') --> "kjv" .
iana('Ramopa') --> "kjx" .
iana('Erave') --> "kjy" .
iana('Bumthangkha') --> "kjz" .
iana('Kakanda') --> "kka" .
iana('Kwerisa') --> "kkb" .
iana('Odoodee') --> "kkc" .
iana('Kinuku') --> "kkd" .
iana('Kakabe') --> "kke" .
iana('Kalaktang Monpa') --> "kkf" .
iana('Mabaka Valley Kalinga') --> "kkg" .
iana('Khün') --> "kkh" .
iana('Kagulu') --> "kki" .
iana('Kako') --> "kkj" .
iana('Kokota') --> "kkk" .
iana('Kosarek Yale') --> "kkl" .
iana('Kiong') --> "kkm" .
iana('Kon Keu') --> "kkn" .
iana('Karko') --> "kko" .
iana('Gugubera') --> "kkp" .
iana('Kaiku') --> "kkq" .
iana('Kir-Balar') --> "kkr" .
iana('Giiwo') --> "kks" .
iana('Koi') --> "kkt" .
iana('Tumi') --> "kku" .
iana('Kangean') --> "kkv" .
iana('Teke-Kukuya') --> "kkw" .
iana('Kohin') --> "kkx" .
iana('Guguyimidjir') --> "kky" .
iana('Kaska') --> "kkz" .
iana('Klamath-Modoc') --> "kla" .
iana('Kiliwa') --> "klb" .
iana('Kolbila') --> "klc" .
iana('Gamilaraay') --> "kld" .
iana('Kulung (Nepal)') --> "kle" .
iana('Kendeje') --> "klf" .
iana('Tagakaulo') --> "klg" .
iana('Weliki') --> "klh" .
iana('Kalumpang') --> "kli" .
iana('Turkic Khalaj') --> "klj" .
iana('Kono (Nigeria)') --> "klk" .
iana('Kagan Kalagan') --> "kll" .
iana('Migum') --> "klm" .
iana('Kalenjin') --> "kln" .
iana('Kapya') --> "klo" .
iana('Kamasa') --> "klp" .
iana('Rumu') --> "klq" .
iana('Khaling') --> "klr" .
iana('Kalasha') --> "kls" .
iana('Nukna') --> "klt" .
iana('Klao') --> "klu" .
iana('Maskelynes') --> "klv" .
iana('Lindu') --> "klw" .
iana('Koluwawa') --> "klx" .
iana('Kalao') --> "kly" .
iana('Kabola') --> "klz" .
iana('Konni') --> "kma" .
iana('Kimbundu') --> "kmb" .
iana('Southern Dong') --> "kmc" .
iana('Majukayang Kalinga') --> "kmd" .
iana('Bakole') --> "kme" .
iana('Kare (Papua New Guinea)') --> "kmf" .
iana('Kâte') --> "kmg" .
iana('Kalam') --> "kmh" .
iana('Kami (Nigeria)') --> "kmi" .
iana('Kumarbhag Paharia') --> "kmj" .
iana('Limos Kalinga') --> "kmk" .
iana('Tanudan Kalinga') --> "kml" .
iana('Kom (India)') --> "kmm" .
iana('Awtuw') --> "kmn" .
iana('Kwoma') --> "kmo" .
iana('Gimme') --> "kmp" .
iana('Kwama') --> "kmq" .
iana('Northern Kurdish') --> "kmr" .
iana('Kamasau') --> "kms" .
iana('Kemtuik') --> "kmt" .
iana('Kanite') --> "kmu" .
iana('Karipúna Creole French') --> "kmv" .
iana('Komo (Democratic Republic of Congo)') --> "kmw" .
iana('Waboda') --> "kmx" .
iana('Koma') --> "kmy" .
iana('Khorasani Turkish') --> "kmz" .
iana('Dera (Nigeria)') --> "kna" .
iana('Lubuagan Kalinga') --> "knb" .
iana('Central Kanuri') --> "knc" .
iana('Konda') --> "knd" .
iana('Kankanaey') --> "kne" .
iana('Mankanya') --> "knf" .
iana('Koongo') --> "kng" .
iana('Kanufi') --> "kni" .
iana('Western Kanjobal') --> "knj" .
iana('Kuranko') --> "knk" .
iana('Keninjal') --> "knl" .
iana('Kanamarí') --> "knm" .
iana('Konkani (individual language)') --> "knn" .
iana('Kono (Sierra Leone)') --> "kno" .
iana('Kwanja') --> "knp" .
iana('Kintaq') --> "knq" .
iana('Kaningra') --> "knr" .
iana('Kensiu') --> "kns" .
iana('Panoan Katukína') --> "knt" .
iana('Kono (Guinea)') --> "knu" .
iana('Tabo') --> "knv" .
iana('Kung-Ekoka') --> "knw" .
iana('Kendayan') --> "knx" .
iana('Kanyok') --> "kny" .
iana('Kalamsé') --> "knz" .
iana('Konomala') --> "koa" .
iana('Kpati') --> "koc" .
iana('Kodi') --> "kod" .
iana('Kacipo-Balesi') --> "koe" .
iana('Kubi') --> "kof" .
iana('Cogui') --> "kog" .
iana('Koyo') --> "koh" .
iana('Komi-Permyak') --> "koi" .
iana('Sara Dunjo') --> "koj" .
iana('Konkani (macrolanguage)') --> "kok" .
iana('Kol (Papua New Guinea)') --> "kol" .
iana('Konzo') --> "koo" .
iana('Waube') --> "kop" .
iana('Kota (Gabon)') --> "koq" .
iana('Kosraean') --> "kos" .
iana('Lagwan') --> "kot" .
iana('Koke') --> "kou" .
iana('Kudu-Camo') --> "kov" .
iana('Kugama') --> "kow" .
iana('Coxima') --> "kox" .
iana('Koyukon') --> "koy" .
iana('Korak') --> "koz" .
iana('Kutto') --> "kpa" .
iana('Mullu Kurumba') --> "kpb" .
iana('Curripaco') --> "kpc" .
iana('Koba') --> "kpd" .
iana('Kpelle') --> "kpe" .
iana('Komba') --> "kpf" .
iana('Kapingamarangi') --> "kpg" .
iana('Kplang') --> "kph" .
iana('Kofei') --> "kpi" .
iana('Karajá') --> "kpj" .
iana('Kpan') --> "kpk" .
iana('Kpala') --> "kpl" .
iana('Koho') --> "kpm" .
iana('Kepkiriwát') --> "kpn" .
iana('Ikposo') --> "kpo" .
iana('Paku Karen') --> "kpp" .
iana('Korupun-Sela') --> "kpq" .
iana('Korafe-Yegha') --> "kpr" .
iana('Tehit') --> "kps" .
iana('Karata') --> "kpt" .
iana('Kafoa') --> "kpu" .
iana('Komi-Zyrian') --> "kpv" .
iana('Kobon') --> "kpw" .
iana('Mountain Koiali') --> "kpx" .
iana('Koryak') --> "kpy" .
iana('Kupsabiny') --> "kpz" .
iana('Mum') --> "kqa" .
iana('Kovai') --> "kqb" .
iana('Doromu-Koki') --> "kqc" .
iana('Koy Sanjaq Surat') --> "kqd" .
iana('Kalagan') --> "kqe" .
iana('Kakabai') --> "kqf" .
iana('Khe') --> "kqg" .
iana('Kisankasa') --> "kqh" .
iana('Koitabu') --> "kqi" .
iana('Koromira') --> "kqj" .
iana('Kotafon Gbe') --> "kqk" .
iana('Kyenele') --> "kql" .
iana('Khisa') --> "kqm" .
iana('Kaonde') --> "kqn" .
iana('Eastern Krahn') --> "kqo" .
iana('Kimré') --> "kqp" .
iana('Krenak') --> "kqq" .
iana('Kimaragang') --> "kqr" .
iana('Northern Kissi') --> "kqs" .
iana('Klias River Kadazan') --> "kqt" .
iana('Seroa') --> "kqu" .
iana('Okolod') --> "kqv" .
iana('Kandas') --> "kqw" .
iana('Mser') --> "kqx" .
iana('Koorete') --> "kqy" .
iana('Korana') --> "kqz" .
iana('Kumhali') --> "kra" .
iana('Karkin') --> "krb" .
iana('Karachay-Balkar') --> "krc" .
iana('Kairui-Midiki') --> "krd" .
iana('Panará') --> "kre" .
iana('Koro (Vanuatu)') --> "krf" .
iana('Kurama') --> "krh" .
iana('Krio') --> "kri" .
iana('Kinaray-A') --> "krj" .
iana('Kerek') --> "krk" .
iana('Karelian') --> "krl" .
iana('Krim') --> "krm" .
iana('Sapo') --> "krn" .
iana('Kru languages') --> "kro" .
iana('Korop') --> "krp" .
iana('Kru\'ng 2') --> "krr" .
iana('Gbaya (Sudan)') --> "krs" .
iana('Tumari Kanuri') --> "krt" .
iana('Kurukh') --> "kru" .
iana('Kavet') --> "krv" .
iana('Western Krahn') --> "krw" .
iana('Karon') --> "krx" .
iana('Kryts') --> "kry" .
iana('Sota Kanum') --> "krz" .
iana('Shuwa-Zamani') --> "ksa" .
iana('Shambala') --> "ksb" .
iana('Southern Kalinga') --> "ksc" .
iana('Kuanua') --> "ksd" .
iana('Kuni') --> "kse" .
iana('Bafia') --> "ksf" .
iana('Kusaghe') --> "ksg" .
iana('Kölsch') --> "ksh" .
iana('Krisa') --> "ksi" .
iana('Uare') --> "ksj" .
iana('Kansa') --> "ksk" .
iana('Kumalu') --> "ksl" .
iana('Kumba') --> "ksm" .
iana('Kasiguranin') --> "ksn" .
iana('Kofa') --> "kso" .
iana('Kaba') --> "ksp" .
iana('Kwaami') --> "ksq" .
iana('Borong') --> "ksr" .
iana('Southern Kisi') --> "kss" .
iana('Winyé') --> "kst" .
iana('Khamyang') --> "ksu" .
iana('Kusu') --> "ksv" .
iana('S\'gaw Karen') --> "ksw" .
iana('Kedang') --> "ksx" .
iana('Kharia Thar') --> "ksy" .
iana('Kodaku') --> "ksz" .
iana('Katua') --> "kta" .
iana('Kambaata') --> "ktb" .
iana('Kholok') --> "ktc" .
iana('Kokata') --> "ktd" .
iana('Nubri') --> "kte" .
iana('Kwami') --> "ktf" .
iana('Kalkutung') --> "ktg" .
iana('Karanga') --> "kth" .
iana('North Muyu') --> "kti" .
iana('Plapo Krumen') --> "ktj" .
iana('Kaniet') --> "ktk" .
iana('Koroshi') --> "ktl" .
iana('Kurti') --> "ktm" .
iana('Karitiâna') --> "ktn" .
iana('Kuot') --> "kto" .
iana('Kaduo') --> "ktp" .
iana('Katabaga') --> "ktq" .
iana('Kota Marudu Tinagas') --> "ktr" .
iana('South Muyu') --> "kts" .
iana('Ketum') --> "ktt" .
iana('Kituba (Democratic Republic of Congo)') --> "ktu" .
iana('Eastern Katu') --> "ktv" .
iana('Kato') --> "ktw" .
iana('Kaxararí') --> "ktx" .
iana('Kango (Bas-Uélé District)') --> "kty" .
iana('Ju/\'hoan') --> "ktz" .
iana('Kutep') --> "kub" .
iana('Kwinsu') --> "kuc" .
iana('\'Auhelawa') --> "kud" .
iana('Kuman (Papua New Guinea)') --> "kue" .
iana('Western Katu') --> "kuf" .
iana('Kupa') --> "kug" .
iana('Kushi') --> "kuh" .
iana('Kuikúro-Kalapálo') --> "kui" .
iana('Kuria') --> "kuj" .
iana('Kepo\'') --> "kuk" .
iana('Kulere') --> "kul" .
iana('Kumyk') --> "kum" .
iana('Kunama') --> "kun" .
iana('Kumukio') --> "kuo" .
iana('Kunimaipa') --> "kup" .
iana('Karipuna') --> "kuq" .
iana('Kusaal') --> "kus" .
iana('Kutenai') --> "kut" .
iana('Upper Kuskokwim') --> "kuu" .
iana('Kur') --> "kuv" .
iana('Kpagua') --> "kuw" .
iana('Kukatja') --> "kux" .
iana('Kuuku-Ya\'u') --> "kuy" .
iana('Kunza') --> "kuz" .
iana('Bagvalal') --> "kva" .
iana('Kubu') --> "kvb" .
iana('Kove') --> "kvc" .
iana('Kui (Indonesia)') --> "kvd" .
iana('Kalabakan') --> "kve" .
iana('Kabalai') --> "kvf" .
iana('Kuni-Boazi') --> "kvg" .
iana('Komodo') --> "kvh" .
iana('Kwang') --> "kvi" .
iana('Psikye') --> "kvj" .
iana('Korean Sign Language') --> "kvk" .
iana('Kayaw') --> "kvl" .
iana('Kendem') --> "kvm" .
iana('Border Kuna') --> "kvn" .
iana('Dobel') --> "kvo" .
iana('Kompane') --> "kvp" .
iana('Geba Karen') --> "kvq" .
iana('Kerinci') --> "kvr" .
iana('Kunggara') --> "kvs" .
iana('Lahta Karen') --> "kvt" .
iana('Yinbaw Karen') --> "kvu" .
iana('Kola') --> "kvv" .
iana('Wersing') --> "kvw" .
iana('Parkari Koli') --> "kvx" .
iana('Yintale Karen') --> "kvy" .
iana('Tsakwambo') --> "kvz" .
iana('Dâw') --> "kwa" .
iana('Kwa') --> "kwb" .
iana('Likwala') --> "kwc" .
iana('Kwaio') --> "kwd" .
iana('Kwerba') --> "kwe" .
iana('Kwara\'ae') --> "kwf" .
iana('Sara Kaba Deme') --> "kwg" .
iana('Kowiai') --> "kwh" .
iana('Awa-Cuaiquer') --> "kwi" .
iana('Kwanga') --> "kwj" .
iana('Kwakiutl') --> "kwk" .
iana('Kofyar') --> "kwl" .
iana('Kwambi') --> "kwm" .
iana('Kwangali') --> "kwn" .
iana('Kwomtari') --> "kwo" .
iana('Kodia') --> "kwp" .
iana('Kwak') --> "kwq" .
iana('Kwer') --> "kwr" .
iana('Kwese') --> "kws" .
iana('Kwesten') --> "kwt" .
iana('Kwakum') --> "kwu" .
iana('Sara Kaba Náà') --> "kwv" .
iana('Kwinti') --> "kww" .
iana('Khirwar') --> "kwx" .
iana('San Salvador Kongo') --> "kwy" .
iana('Kwadi') --> "kwz" .
iana('Kairiru') --> "kxa" .
iana('Krobu') --> "kxb" .
iana('Konso') --> "kxc" .
iana('Brunei') --> "kxd" .
iana('Kakihum') --> "kxe" .
iana('Manumanaw Karen') --> "kxf" .
iana('Karo (Ethiopia)') --> "kxh" .
iana('Keningau Murut') --> "kxi" .
iana('Kulfa') --> "kxj" .
iana('Zayein Karen') --> "kxk" .
iana('Nepali Kurux') --> "kxl" .
iana('Northern Khmer') --> "kxm" .
iana('Kanowit-Tanjong Melanau') --> "kxn" .
iana('Kanoé') --> "kxo" .
iana('Wadiyara Koli') --> "kxp" .
iana('Smärky Kanum') --> "kxq" .
iana('Koro (Papua New Guinea)') --> "kxr" .
iana('Kangjia') --> "kxs" .
iana('Koiwat') --> "kxt" .
iana('Kui (India)') --> "kxu" .
iana('Kuvi') --> "kxv" .
iana('Konai') --> "kxw" .
iana('Likuba') --> "kxx" .
iana('Kayong') --> "kxy" .
iana('Kerewo') --> "kxz" .
iana('Kwaya') --> "kya" .
iana('Butbut Kalinga') --> "kyb" .
iana('Kyaka') --> "kyc" .
iana('Karey') --> "kyd" .
iana('Krache') --> "kye" .
iana('Kouya') --> "kyf" .
iana('Keyagana') --> "kyg" .
iana('Karok') --> "kyh" .
iana('Kiput') --> "kyi" .
iana('Karao') --> "kyj" .
iana('Kamayo') --> "kyk" .
iana('Kalapuya') --> "kyl" .
iana('Kpatili') --> "kym" .
iana('Northern Binukidnon') --> "kyn" .
iana('Kelon') --> "kyo" .
iana('Kang') --> "kyp" .
iana('Kenga') --> "kyq" .
iana('Kuruáya') --> "kyr" .
iana('Baram Kayan') --> "kys" .
iana('Kayagar') --> "kyt" .
iana('Western Kayah') --> "kyu" .
iana('Kayort') --> "kyv" .
iana('Kudmali') --> "kyw" .
iana('Rapoisi') --> "kyx" .
iana('Kambaira') --> "kyy" .
iana('Kayabí') --> "kyz" .
iana('Western Karaboro') --> "kza" .
iana('Kaibobo') --> "kzb" .
iana('Bondoukou Kulango') --> "kzc" .
iana('Kadai') --> "kzd" .
iana('Kosena') --> "kze" .
iana('Da\'a Kaili') --> "kzf" .
iana('Kikai') --> "kzg" .
iana('Kenuzi-Dongola') --> "kzh" .
iana('Kelabit') --> "kzi" .
iana('Coastal Kadazan') --> "kzj" .
iana('Kazukuru') --> "kzk" .
iana('Kayeli') --> "kzl" .
iana('Kais') --> "kzm" .
iana('Kokola') --> "kzn" .
iana('Kaningi') --> "kzo" .
iana('Kaidipang') --> "kzp" .
iana('Kaike') --> "kzq" .
iana('Karang') --> "kzr" .
iana('Sugut Dusun') --> "kzs" .
iana('Tambunan Dusun') --> "kzt" .
iana('Kayupulau') --> "kzu" .
iana('Komyandaret') --> "kzv" .
iana('Karirí-Xocó') --> "kzw" .
iana('Kamarian') --> "kzx" .
iana('Kango (Tshopo District)') --> "kzy" .
iana('Kalabra') --> "kzz" .
iana('Southern Subanen') --> "laa" .
iana('Linear A') --> "lab" .
iana('Lacandon') --> "lac" .
iana('Ladino') --> "lad" .
iana('Pattani') --> "lae" .
iana('Lafofa') --> "laf" .
iana('Langi') --> "lag" .
iana('Lahnda') --> "lah" .
iana('Lambya') --> "lai" .
iana('Lango (Uganda)') --> "laj" .
iana('Laka (Nigeria)') --> "lak" .
iana('Lalia') --> "lal" .
iana('Lamba') --> "lam" .
iana('Laru') --> "lan" .
iana('Laka (Chad)') --> "lap" .
iana('Qabiao') --> "laq" .
iana('Larteh') --> "lar" .
iana('Lama (Togo)') --> "las" .
iana('Laba') --> "lau" .
iana('Lauje') --> "law" .
iana('Tiwa') --> "lax" .
iana('Lama Bai') --> "lay" .
iana('Aribwatsa') --> "laz" .
iana('Lui') --> "lba" .
iana('Label') --> "lbb" .
iana('Lakkia') --> "lbc" .
iana('Lak') --> "lbe" .
iana('Tinani') --> "lbf" .
iana('Laopang') --> "lbg" .
iana('La\'bi') --> "lbi" .
iana('Ladakhi') --> "lbj" .
iana('Central Bontok') --> "lbk" .
iana('Libon Bikol') --> "lbl" .
iana('Lodhi') --> "lbm" .
iana('Lamet') --> "lbn" .
iana('Laven') --> "lbo" .
iana('Wampar') --> "lbq" .
iana('Lohorung') --> "lbr" .
iana('Libyan Sign Language') --> "lbs" .
iana('Lachi') --> "lbt" .
iana('Labu') --> "lbu" .
iana('Lavatbura-Lamusong') --> "lbv" .
iana('Tolaki') --> "lbw" .
iana('Lawangan') --> "lbx" .
iana('Lamu-Lamu') --> "lby" .
iana('Lardil') --> "lbz" .
iana('Legenyem') --> "lcc" .
iana('Lola') --> "lcd" .
iana('Loncong') --> "lce" .
iana('Lubu') --> "lcf" .
iana('Luchazi') --> "lch" .
iana('Lisela') --> "lcl" .
iana('Tungag') --> "lcm" .
iana('Western Lawa') --> "lcp" .
iana('Luhu') --> "lcq" .
iana('Lisabata-Nuniali') --> "lcs" .
iana('Kla-Dan') --> "lda" .
iana('Dũya') --> "ldb" .
iana('Luri') --> "ldd" .
iana('Lenyima') --> "ldg" .
iana('Lamja-Dengsa-Tola') --> "ldh" .
iana('Laari') --> "ldi" .
iana('Lemoro') --> "ldj" .
iana('Leelau') --> "ldk" .
iana('Kaan') --> "ldl" .
iana('Landoma') --> "ldm" .
iana('Láadan') --> "ldn" .
iana('Loo') --> "ldo" .
iana('Tso') --> "ldp" .
iana('Lufu') --> "ldq" .
iana('Lega-Shabunda') --> "lea" .
iana('Lala-Bisa') --> "leb" .
iana('Leco') --> "lec" .
iana('Lendu') --> "led" .
iana('Lyélé') --> "lee" .
iana('Lelemi') --> "lef" .
iana('Lengua') --> "leg" .
iana('Lenje') --> "leh" .
iana('Lemio') --> "lei" .
iana('Lengola') --> "lej" .
iana('Leipon') --> "lek" .
iana('Lele (Democratic Republic of Congo)') --> "lel" .
iana('Nomaande') --> "lem" .
iana('Lenca') --> "len" .
iana('Leti (Cameroon)') --> "leo" .
iana('Lepcha') --> "lep" .
iana('Lembena') --> "leq" .
iana('Lenkau') --> "ler" .
iana('Lese') --> "les" .
iana('Lesing-Gelimi') --> "let" .
iana('Kara (Papua New Guinea)') --> "leu" .
iana('Lamma') --> "lev" .
iana('Ledo Kaili') --> "lew" .
iana('Luang') --> "lex" .
iana('Lemolang') --> "ley" .
iana('Lezghian') --> "lez" .
iana('Lefa') --> "lfa" .
iana('Lingua Franca Nova') --> "lfn" .
iana('Lungga') --> "lga" .
iana('Laghu') --> "lgb" .
iana('Lugbara') --> "lgg" .
iana('Laghuu') --> "lgh" .
iana('Lengilu') --> "lgi" .
iana('Lingarak') --> "lgk" .
iana('Wala') --> "lgl" .
iana('Lega-Mwenga') --> "lgm" .
iana('Opuuo') --> "lgn" .
iana('Logba') --> "lgq" .
iana('Lengo') --> "lgr" .
iana('Pahi') --> "lgt" .
iana('Longgu') --> "lgu" .
iana('Ligenza') --> "lgz" .
iana('Laha (Viet Nam)') --> "lha" .
iana('Laha (Indonesia)') --> "lhh" .
iana('Lahu Shi') --> "lhi" .
iana('Lahul Lohar') --> "lhl" .
iana('Lhomi') --> "lhm" .
iana('Lahanan') --> "lhn" .
iana('Lhokpu') --> "lhp" .
iana('Mlahsö') --> "lhs" .
iana('Lo-Toga') --> "lht" .
iana('Lahu') --> "lhu" .
iana('West-Central Limba') --> "lia" .
iana('Likum') --> "lib" .
iana('Hlai') --> "lic" .
iana('Nyindrou') --> "lid" .
iana('Likila') --> "lie" .
iana('Limbu') --> "lif" .
iana('Ligbi') --> "lig" .
iana('Lihir') --> "lih" .
iana('Lingkhim') --> "lii" .
iana('Ligurian') --> "lij" .
iana('Lika') --> "lik" .
iana('Lillooet') --> "lil" .
iana('Liki') --> "lio" .
iana('Sekpele') --> "lip" .
iana('Libido') --> "liq" .
iana('Liberian English') --> "lir" .
iana('Lisu') --> "lis" .
iana('Logorik') --> "liu" .
iana('Liv') --> "liv" .
iana('Col') --> "liw" .
iana('Liabuku') --> "lix" .
iana('Banda-Bambari') --> "liy" .
iana('Libinza') --> "liz" .
iana('Golpa') --> "lja" .
iana('Rampi') --> "lje" .
iana('Laiyolo') --> "lji" .
iana('Li\'o') --> "ljl" .
iana('Lampung Api') --> "ljp" .
iana('Yirandali') --> "ljw" .
iana('Yuru') --> "ljx" .
iana('Lakalei') --> "lka" .
iana('Kabras') --> "lkb" .
iana('Kucong') --> "lkc" .
iana('Lakondê') --> "lkd" .
iana('Kenyi') --> "lke" .
iana('Lakha') --> "lkh" .
iana('Laki') --> "lki" .
iana('Remun') --> "lkj" .
iana('Laeko-Libuat') --> "lkl" .
iana('Kalaamaya') --> "lkm" .
iana('Lakon') --> "lkn" .
iana('Khayo') --> "lko" .
iana('Päri') --> "lkr" .
iana('Kisa') --> "lks" .
iana('Lakota') --> "lkt" .
iana('Kungkari') --> "lku" .
iana('Lokoya') --> "lky" .
iana('Lala-Roba') --> "lla" .
iana('Lolo') --> "llb" .
iana('Lele (Guinea)') --> "llc" .
iana('Ladin') --> "lld" .
iana('Lele (Papua New Guinea)') --> "lle" .
iana('Hermit') --> "llf" .
iana('Lole') --> "llg" .
iana('Lamu') --> "llh" .
iana('Teke-Laali') --> "lli" .
iana('Ladji Ladji') --> "llj" .
iana('Lelak') --> "llk" .
iana('Lilau') --> "lll" .
iana('Lasalimu') --> "llm" .
iana('Lele (Chad)') --> "lln" .
iana('Khlor') --> "llo" .
iana('North Efate') --> "llp" .
iana('Lolak') --> "llq" .
iana('Lithuanian Sign Language') --> "lls" .
iana('Lau') --> "llu" .
iana('Lauan') --> "llx" .
iana('East Limba') --> "lma" .
iana('Merei') --> "lmb" .
iana('Limilngan') --> "lmc" .
iana('Lumun') --> "lmd" .
iana('Pévé') --> "lme" .
iana('South Lembata') --> "lmf" .
iana('Lamogai') --> "lmg" .
iana('Lambichhong') --> "lmh" .
iana('Lombi') --> "lmi" .
iana('West Lembata') --> "lmj" .
iana('Lamkang') --> "lmk" .
iana('Hano') --> "lml" .
iana('Lamam') --> "lmm" .
iana('Lambadi') --> "lmn" .
iana('Lombard') --> "lmo" .
iana('Limbum') --> "lmp" .
iana('Lamatuka') --> "lmq" .
iana('Lamalera') --> "lmr" .
iana('Lamenu') --> "lmu" .
iana('Lomaiviti') --> "lmv" .
iana('Lake Miwok') --> "lmw" .
iana('Laimbue') --> "lmx" .
iana('Lamboya') --> "lmy" .
iana('Lumbee') --> "lmz" .
iana('Langbashe') --> "lna" .
iana('Mbalanhu') --> "lnb" .
iana('Lundayeh') --> "lnd" .
iana('Langobardic') --> "lng" .
iana('Lanoh') --> "lnh" .
iana('Daantanai\'') --> "lni" .
iana('Leningitij') --> "lnj" .
iana('South Central Banda') --> "lnl" .
iana('Langam') --> "lnm" .
iana('Lorediakarkar') --> "lnn" .
iana('Lango (Sudan)') --> "lno" .
iana('Lamnso\'') --> "lns" .
iana('Longuda') --> "lnu" .
iana('Lanima') --> "lnw" .
iana('Lonzo') --> "lnz" .
iana('Loloda') --> "loa" .
iana('Lobi') --> "lob" .
iana('Inonhan') --> "loc" .
iana('Saluan') --> "loe" .
iana('Logol') --> "lof" .
iana('Logo') --> "log" .
iana('Narim') --> "loh" .
iana('Loma (Côte d\'Ivoire)') --> "loi" .
iana('Lou') --> "loj" .
iana('Loko') --> "lok" .
iana('Mongo') --> "lol" .
iana('Loma (Liberia)') --> "lom" .
iana('Malawi Lomwe') --> "lon" .
iana('Lombo') --> "loo" .
iana('Lopa') --> "lop" .
iana('Lobala') --> "loq" .
iana('Téén') --> "lor" .
iana('Loniu') --> "los" .
iana('Otuho') --> "lot" .
iana('Louisiana Creole French') --> "lov" .
iana('Tampias Lobu') --> "low" .
iana('Loun') --> "lox" .
iana('Loke') --> "loy" .
iana('Lozi') --> "loz" .
iana('Lelepa') --> "lpa" .
iana('Lepki') --> "lpe" .
iana('Long Phuri Naga') --> "lpn" .
iana('Lipo') --> "lpo" .
iana('Lopit') --> "lpx" .
iana('Rara Bakati\'') --> "lra" .
iana('Northern Luri') --> "lrc" .
iana('Laurentian') --> "lre" .
iana('Laragia') --> "lrg" .
iana('Marachi') --> "lri" .
iana('Loarki') --> "lrk" .
iana('Lari') --> "lrl" .
iana('Marama') --> "lrm" .
iana('Lorang') --> "lrn" .
iana('Laro') --> "lro" .
iana('Southern Yamphu') --> "lrr" .
iana('Larantuka Malay') --> "lrt" .
iana('Larevat') --> "lrv" .
iana('Lemerig') --> "lrz" .
iana('Lasgerdi') --> "lsa" .
iana('Lishana Deni') --> "lsd" .
iana('Lusengo') --> "lse" .
iana('Lyons Sign Language') --> "lsg" .
iana('Lish') --> "lsh" .
iana('Lashi') --> "lsi" .
iana('Latvian Sign Language') --> "lsl" .
iana('Saamia') --> "lsm" .
iana('Laos Sign Language') --> "lso" .
iana('Panamanian Sign Language') --> "lsp" .
iana('Aruop') --> "lsr" .
iana('Lasi') --> "lss" .
iana('Trinidad and Tobago Sign Language') --> "lst" .
iana('Mauritian Sign Language') --> "lsy" .
iana('Late Middle Chinese') --> "ltc" .
iana('Latgalian') --> "ltg" .
iana('Leti (Indonesia)') --> "lti" .
iana('Latundê') --> "ltn" .
iana('Tsotso') --> "lto" .
iana('Tachoni') --> "lts" .
iana('Latu') --> "ltu" .
iana('Luba-Lulua') --> "lua" .
iana('Aringa') --> "luc" .
iana('Ludian') --> "lud" .
iana('Luvale') --> "lue" .
iana('Laua') --> "luf" .
iana('Luiseno') --> "lui" .
iana('Luna') --> "luj" .
iana('Lunanakha') --> "luk" .
iana('Olu\'bo') --> "lul" .
iana('Luimbi') --> "lum" .
iana('Lunda') --> "lun" .
iana('Luo (Kenya and Tanzania)') --> "luo" .
iana('Lumbu') --> "lup" .
iana('Lucumi') --> "luq" .
iana('Laura') --> "lur" .
iana('Lushai') --> "lus" .
iana('Lushootseed') --> "lut" .
iana('Lumba-Yakkha') --> "luu" .
iana('Luwati') --> "luv" .
iana('Luo (Cameroon)') --> "luw" .
iana('Luyia') --> "luy" .
iana('Southern Luri') --> "luz" .
iana('Maku\'a') --> "lva" .
iana('Lavukaleve') --> "lvk" .
iana('Standard Latvian') --> "lvs" .
iana('Levuka') --> "lvu" .
iana('Lwalu') --> "lwa" .
iana('Lewo Eleng') --> "lwe" .
iana('Wanga') --> "lwg" .
iana('White Lachi') --> "lwh" .
iana('Eastern Lawa') --> "lwl" .
iana('Laomian') --> "lwm" .
iana('Luwo') --> "lwo" .
iana('Lewotobi') --> "lwt" .
iana('Lawu') --> "lwu" .
iana('Lewo') --> "lww" .
iana('Layakha') --> "lya" .
iana('Lyngngam') --> "lyg" .
iana('Luyana') --> "lyn" .
iana('Literary Chinese') --> "lzh" .
iana('Litzlitz') --> "lzl" .
iana('Leinong Naga') --> "lzn" .
iana('Laz') --> "lzz" .
iana('San Jerónimo Tecóatl Mazatec') --> "maa" .
iana('Yutanduchi Mixtec') --> "mab" .
iana('Madurese') --> "mad" .
iana('Bo-Rukul') --> "mae" .
iana('Mafa') --> "maf" .
iana('Magahi') --> "mag" .
iana('Maithili') --> "mai" .
iana('Jalapa De Díaz Mazatec') --> "maj" .
iana('Makasar') --> "mak" .
iana('Mam') --> "mam" .
iana('Mandingo') --> "man" .
iana('Austronesian languages') --> "map" .
iana('Chiquihuitlán Mazatec') --> "maq" .
iana('Masai') --> "mas" .
iana('San Francisco Matlatzinca') --> "mat" .
iana('Huautla Mazatec') --> "mau" .
iana('Sateré-Mawé') --> "mav" .
iana('Mampruli') --> "maw" .
iana('North Moluccan Malay') --> "max" .
iana('Central Mazahua') --> "maz" .
iana('Higaonon') --> "mba" .
iana('Western Bukidnon Manobo') --> "mbb" .
iana('Macushi') --> "mbc" .
iana('Dibabawon Manobo') --> "mbd" .
iana('Molale') --> "mbe" .
iana('Baba Malay') --> "mbf" .
iana('Mangseng') --> "mbh" .
iana('Ilianen Manobo') --> "mbi" .
iana('Nadëb') --> "mbj" .
iana('Malol') --> "mbk" .
iana('Maxakalí') --> "mbl" .
iana('Ombamba') --> "mbm" .
iana('Macaguán') --> "mbn" .
iana('Mbo (Cameroon)') --> "mbo" .
iana('Malayo') --> "mbp" .
iana('Maisin') --> "mbq" .
iana('Nukak Makú') --> "mbr" .
iana('Sarangani Manobo') --> "mbs" .
iana('Matigsalug Manobo') --> "mbt" .
iana('Mbula-Bwazza') --> "mbu" .
iana('Mbulungish') --> "mbv" .
iana('Maring') --> "mbw" .
iana('Mari (East Sepik Province)') --> "mbx" .
iana('Memoni') --> "mby" .
iana('Amoltepec Mixtec') --> "mbz" .
iana('Maca') --> "mca" .
iana('Machiguenga') --> "mcb" .
iana('Bitur') --> "mcc" .
iana('Sharanahua') --> "mcd" .
iana('Itundujia Mixtec') --> "mce" .
iana('Matsés') --> "mcf" .
iana('Mapoyo') --> "mcg" .
iana('Maquiritari') --> "mch" .
iana('Mese') --> "mci" .
iana('Mvanip') --> "mcj" .
iana('Mbunda') --> "mck" .
iana('Macaguaje') --> "mcl" .
iana('Malaccan Creole Portuguese') --> "mcm" .
iana('Masana') --> "mcn" .
iana('Coatlán Mixe') --> "mco" .
iana('Makaa') --> "mcp" .
iana('Ese') --> "mcq" .
iana('Menya') --> "mcr" .
iana('Mambai') --> "mcs" .
iana('Mengisa') --> "mct" .
iana('Cameroon Mambila') --> "mcu" .
iana('Minanibai') --> "mcv" .
iana('Mawa (Chad)') --> "mcw" .
iana('Mpiemo') --> "mcx" .
iana('South Watut') --> "mcy" .
iana('Mawan') --> "mcz" .
iana('Mada (Nigeria)') --> "mda" .
iana('Morigi') --> "mdb" .
iana('Male (Papua New Guinea)') --> "mdc" .
iana('Mbum') --> "mdd" .
iana('Maba (Chad)') --> "mde" .
iana('Moksha') --> "mdf" .
iana('Massalat') --> "mdg" .
iana('Maguindanaon') --> "mdh" .
iana('Mamvu') --> "mdi" .
iana('Mangbetu') --> "mdj" .
iana('Mangbutu') --> "mdk" .
iana('Maltese Sign Language') --> "mdl" .
iana('Mayogo') --> "mdm" .
iana('Mbati') --> "mdn" .
iana('Mbala') --> "mdp" .
iana('Mbole') --> "mdq" .
iana('Mandar') --> "mdr" .
iana('Maria (Papua New Guinea)') --> "mds" .
iana('Mbere') --> "mdt" .
iana('Mboko') --> "mdu" .
iana('Santa Lucía Monteverde Mixtec') --> "mdv" .
iana('Mbosi') --> "mdw" .
iana('Dizin') --> "mdx" .
iana('Male (Ethiopia)') --> "mdy" .
iana('Suruí Do Pará') --> "mdz" .
iana('Menka') --> "mea" .
iana('Ikobi') --> "meb" .
iana('Mara') --> "mec" .
iana('Melpa') --> "med" .
iana('Mengen') --> "mee" .
iana('Megam') --> "mef" .
iana('Mea') --> "meg" .
iana('Southwestern Tlaxiaco Mixtec') --> "meh" .
iana('Midob') --> "mei" .
iana('Meyah') --> "mej" .
iana('Mekeo') --> "mek" .
iana('Central Melanau') --> "mel" .
iana('Mangala') --> "mem" .
iana('Mende (Sierra Leone)') --> "men" .
iana('Kedah Malay') --> "meo" .
iana('Miriwung') --> "mep" .
iana('Merey') --> "meq" .
iana('Meru') --> "mer" .
iana('Masmaje') --> "mes" .
iana('Mato') --> "met" .
iana('Motu') --> "meu" .
iana('Mano') --> "mev" .
iana('Maaka') --> "mew" .
iana('Hassaniyya') --> "mey" .
iana('Menominee') --> "mez" .
iana('Pattani Malay') --> "mfa" .
iana('Bangka') --> "mfb" .
iana('Mba') --> "mfc" .
iana('Mendankwe-Nkwen') --> "mfd" .
iana('Morisyen') --> "mfe" .
iana('Naki') --> "mff" .
iana('Mogofin') --> "mfg" .
iana('Matal') --> "mfh" .
iana('Wandala') --> "mfi" .
iana('Mefele') --> "mfj" .
iana('North Mofu') --> "mfk" .
iana('Putai') --> "mfl" .
iana('Marghi South') --> "mfm" .
iana('Cross River Mbembe') --> "mfn" .
iana('Mbe') --> "mfo" .
iana('Makassar Malay') --> "mfp" .
iana('Moba') --> "mfq" .
iana('Marithiel') --> "mfr" .
iana('Mexican Sign Language') --> "mfs" .
iana('Mokerang') --> "mft" .
iana('Mbwela') --> "mfu" .
iana('Mandjak') --> "mfv" .
iana('Mulaha') --> "mfw" .
iana('Melo') --> "mfx" .
iana('Mayo') --> "mfy" .
iana('Mabaan') --> "mfz" .
iana('Middle Irish (900-1200)') --> "mga" .
iana('Mararit') --> "mgb" .
iana('Morokodo') --> "mgc" .
iana('Moru') --> "mgd" .
iana('Mango') --> "mge" .
iana('Maklew') --> "mgf" .
iana('Mpumpong') --> "mgg" .
iana('Makhuwa-Meetto') --> "mgh" .
iana('Lijili') --> "mgi" .
iana('Abureni') --> "mgj" .
iana('Mawes') --> "mgk" .
iana('Maleu-Kilenge') --> "mgl" .
iana('Mambae') --> "mgm" .
iana('Mbangi') --> "mgn" .
iana('Meta\'') --> "mgo" .
iana('Eastern Magar') --> "mgp" .
iana('Malila') --> "mgq" .
iana('Mambwe-Lungu') --> "mgr" .
iana('Manda (Tanzania)') --> "mgs" .
iana('Mongol') --> "mgt" .
iana('Mailu') --> "mgu" .
iana('Matengo') --> "mgv" .
iana('Matumbi') --> "mgw" .
iana('Omati') --> "mgx" .
iana('Mbunga') --> "mgy" .
iana('Mbugwe') --> "mgz" .
iana('Manda (India)') --> "mha" .
iana('Mahongwe') --> "mhb" .
iana('Mocho') --> "mhc" .
iana('Mbugu') --> "mhd" .
iana('Besisi') --> "mhe" .
iana('Mamaa') --> "mhf" .
iana('Margu') --> "mhg" .
iana('Maskoy Pidgin') --> "mhh" .
iana('Ma\'di') --> "mhi" .
iana('Mogholi') --> "mhj" .
iana('Mungaka') --> "mhk" .
iana('Mauwake') --> "mhl" .
iana('Makhuwa-Moniga') --> "mhm" .
iana('Mócheno') --> "mhn" .
iana('Mashi (Zambia)') --> "mho" .
iana('Balinese Malay') --> "mhp" .
iana('Mandan') --> "mhq" .
iana('Eastern Mari') --> "mhr" .
iana('Buru (Indonesia)') --> "mhs" .
iana('Mandahuaca') --> "mht" .
iana('Digaro-Mishmi') --> "mhu" .
iana('Mbukushu') --> "mhw" .
iana('Maru') --> "mhx" .
iana('Ma\'anyan') --> "mhy" .
iana('Mor (Mor Islands)') --> "mhz" .
iana('Miami') --> "mia" .
iana('Atatláhuca Mixtec') --> "mib" .
iana('Mi\'kmaq') --> "mic" .
iana('Mandaic') --> "mid" .
iana('Ocotepec Mixtec') --> "mie" .
iana('Mofu-Gudur') --> "mif" .
iana('San Miguel El Grande Mixtec') --> "mig" .
iana('Chayuco Mixtec') --> "mih" .
iana('Chigmecatitlán Mixtec') --> "mii" .
iana('Abar') --> "mij" .
iana('Mikasuki') --> "mik" .
iana('Peñoles Mixtec') --> "mil" .
iana('Alacatlatzala Mixtec') --> "mim" .
iana('Minangkabau') --> "min" .
iana('Pinotepa Nacional Mixtec') --> "mio" .
iana('Apasco-Apoala Mixtec') --> "mip" .
iana('Mískito') --> "miq" .
iana('Isthmus Mixe') --> "mir" .
iana('Uncoded languages') --> "mis" .
iana('Southern Puebla Mixtec') --> "mit" .
iana('Cacaloxtepec Mixtec') --> "miu" .
iana('Akoye') --> "miw" .
iana('Mixtepec Mixtec') --> "mix" .
iana('Ayutla Mixtec') --> "miy" .
iana('Coatzospan Mixtec') --> "miz" .
iana('Mahei') --> "mja" .
iana('San Juan Colorado Mixtec') --> "mjc" .
iana('Northwest Maidu') --> "mjd" .
iana('Muskum') --> "mje" .
iana('Tu') --> "mjg" .
iana('Mwera (Nyasa)') --> "mjh" .
iana('Kim Mun') --> "mji" .
iana('Mawak') --> "mjj" .
iana('Matukar') --> "mjk" .
iana('Mandeali') --> "mjl" .
iana('Medebur') --> "mjm" .
iana('Ma (Papua New Guinea)') --> "mjn" .
iana('Malankuravan') --> "mjo" .
iana('Malapandaram') --> "mjp" .
iana('Malaryan') --> "mjq" .
iana('Malavedan') --> "mjr" .
iana('Miship') --> "mjs" .
iana('Sauria Paharia') --> "mjt" .
iana('Manna-Dora') --> "mju" .
iana('Mannan') --> "mjv" .
iana('Karbi') --> "mjw" .
iana('Mahali') --> "mjx" .
iana('Mahican') --> "mjy" .
iana('Majhi') --> "mjz" .
iana('Mbre') --> "mka" .
iana('Mal Paharia') --> "mkb" .
iana('Siliput') --> "mkc" .
iana('Mawchi') --> "mke" .
iana('Miya') --> "mkf" .
iana('Mak (China)') --> "mkg" .
iana('Mon-Khmer languages') --> "mkh" .
iana('Dhatki') --> "mki" .
iana('Mokilese') --> "mkj" .
iana('Byep') --> "mkk" .
iana('Mokole') --> "mkl" .
iana('Moklen') --> "mkm" .
iana('Kupang Malay') --> "mkn" .
iana('Mingang Doso') --> "mko" .
iana('Moikodi') --> "mkp" .
iana('Bay Miwok') --> "mkq" .
iana('Malas') --> "mkr" .
iana('Silacayoapan Mixtec') --> "mks" .
iana('Vamale') --> "mkt" .
iana('Konyanka Maninka') --> "mku" .
iana('Mafea') --> "mkv" .
iana('Kituba (Congo)') --> "mkw" .
iana('Kinamiging Manobo') --> "mkx" .
iana('East Makian') --> "mky" .
iana('Makasae') --> "mkz" .
iana('Malo') --> "mla" .
iana('Mbule') --> "mlb" .
iana('Cao Lan') --> "mlc" .
iana('Malakhel') --> "mld" .
iana('Manambu') --> "mle" .
iana('Mal') --> "mlf" .
iana('Mape') --> "mlh" .
iana('Malimpung') --> "mli" .
iana('Miltu') --> "mlj" .
iana('Ilwana') --> "mlk" .
iana('Malua Bay') --> "mll" .
iana('Mulam') --> "mlm" .
iana('Malango') --> "mln" .
iana('Mlomp') --> "mlo" .
iana('Bargam') --> "mlp" .
iana('Western Maninkakan') --> "mlq" .
iana('Vame') --> "mlr" .
iana('Masalit') --> "mls" .
iana('To\'abaita') --> "mlu" .
iana('Motlav') --> "mlv" .
iana('Moloko') --> "mlw" .
iana('Malfaxal') --> "mlx" .
iana('Malaynon') --> "mlz" .
iana('Mama') --> "mma" .
iana('Momina') --> "mmb" .
iana('Michoacán Mazahua') --> "mmc" .
iana('Maonan') --> "mmd" .
iana('Mae') --> "mme" .
iana('Mundat') --> "mmf" .
iana('North Ambrym') --> "mmg" .
iana('Mehináku') --> "mmh" .
iana('Musar') --> "mmi" .
iana('Majhwar') --> "mmj" .
iana('Mukha-Dora') --> "mmk" .
iana('Man Met') --> "mml" .
iana('Maii') --> "mmm" .
iana('Mamanwa') --> "mmn" .
iana('Mangga Buang') --> "mmo" .
iana('Siawi') --> "mmp" .
iana('Musak') --> "mmq" .
iana('Western Xiangxi Miao') --> "mmr" .
iana('Malalamai') --> "mmt" .
iana('Mmaala') --> "mmu" .
iana('Miriti') --> "mmv" .
iana('Emae') --> "mmw" .
iana('Madak') --> "mmx" .
iana('Migaama') --> "mmy" .
iana('Mabaale') --> "mmz" .
iana('Mbula') --> "mna" .
iana('Muna') --> "mnb" .
iana('Manchu') --> "mnc" .
iana('Mondé') --> "mnd" .
iana('Naba') --> "mne" .
iana('Mundani') --> "mnf" .
iana('Eastern Mnong') --> "mng" .
iana('Mono (Democratic Republic of Congo)') --> "mnh" .
iana('Manipuri') --> "mni" .
iana('Munji') --> "mnj" .
iana('Mandinka') --> "mnk" .
iana('Tiale') --> "mnl" .
iana('Mapena') --> "mnm" .
iana('Southern Mnong') --> "mnn" .
iana('Manobo languages') --> "mno" .
iana('Min Bei Chinese') --> "mnp" .
iana('Minriq') --> "mnq" .
iana('Mono (USA)') --> "mnr" .
iana('Mansi') --> "mns" .
iana('Maykulan') --> "mnt" .
iana('Mer') --> "mnu" .
iana('Rennell-Bellona') --> "mnv" .
iana('Mon') --> "mnw" .
iana('Manikion') --> "mnx" .
iana('Manyawa') --> "mny" .
iana('Moni') --> "mnz" .
iana('Mwan') --> "moa" .
iana('Mocoví') --> "moc" .
iana('Mobilian') --> "mod" .
iana('Montagnais') --> "moe" .
iana('Mohegan-Montauk-Narragansett') --> "mof" .
iana('Mongondow') --> "mog" .
iana('Mohawk') --> "moh" .
iana('Mboi') --> "moi" .
iana('Monzombo') --> "moj" .
iana('Morori') --> "mok" .
iana('Mangue') --> "mom" .
iana('Monom') --> "moo" .
iana('Mopán Maya') --> "mop" .
iana('Mor (Bomberai Peninsula)') --> "moq" .
iana('Moro') --> "mor" .
iana('Mossi') --> "mos" .
iana('Barí') --> "mot" .
iana('Mogum') --> "mou" .
iana('Mohave') --> "mov" .
iana('Moi (Congo)') --> "mow" .
iana('Molima') --> "mox" .
iana('Shekkacho') --> "moy" .
iana('Mukulu') --> "moz" .
iana('Mpoto') --> "mpa" .
iana('Mullukmulluk') --> "mpb" .
iana('Mangarayi') --> "mpc" .
iana('Machinere') --> "mpd" .
iana('Majang') --> "mpe" .
iana('Marba') --> "mpg" .
iana('Maung') --> "mph" .
iana('Mpade') --> "mpi" .
iana('Martu Wangka') --> "mpj" .
iana('Mbara (Chad)') --> "mpk" .
iana('Middle Watut') --> "mpl" .
iana('Yosondúa Mixtec') --> "mpm" .
iana('Mindiri') --> "mpn" .
iana('Miu') --> "mpo" .
iana('Migabac') --> "mpp" .
iana('Matís') --> "mpq" .
iana('Vangunu') --> "mpr" .
iana('Dadibi') --> "mps" .
iana('Mian') --> "mpt" .
iana('Makuráp') --> "mpu" .
iana('Mungkip') --> "mpv" .
iana('Mapidian') --> "mpw" .
iana('Misima-Panaeati') --> "mpx" .
iana('Mapia') --> "mpy" .
iana('Mpi') --> "mpz" .
iana('Maba (Indonesia)') --> "mqa" .
iana('Mbuko') --> "mqb" .
iana('Mangole') --> "mqc" .
iana('Matepi') --> "mqe" .
iana('Momuna') --> "mqf" .
iana('Kota Bangun Kutai Malay') --> "mqg" .
iana('Tlazoyaltepec Mixtec') --> "mqh" .
iana('Mariri') --> "mqi" .
iana('Mamasa') --> "mqj" .
iana('Rajah Kabunsuwan Manobo') --> "mqk" .
iana('Mbelime') --> "mql" .
iana('South Marquesan') --> "mqm" .
iana('Moronene') --> "mqn" .
iana('Modole') --> "mqo" .
iana('Manipa') --> "mqp" .
iana('Minokok') --> "mqq" .
iana('Mander') --> "mqr" .
iana('West Makian') --> "mqs" .
iana('Mok') --> "mqt" .
iana('Mandari') --> "mqu" .
iana('Mosimo') --> "mqv" .
iana('Murupi') --> "mqw" .
iana('Mamuju') --> "mqx" .
iana('Manggarai') --> "mqy" .
iana('Pano') --> "mqz" .
iana('Mlabri') --> "mra" .
iana('Marino') --> "mrb" .
iana('Maricopa') --> "mrc" .
iana('Western Magar') --> "mrd" .
iana('Martha\'s Vineyard Sign Language') --> "mre" .
iana('Elseng') --> "mrf" .
iana('Mising') --> "mrg" .
iana('Mara Chin') --> "mrh" .
iana('Western Mari') --> "mrj" .
iana('Hmwaveke') --> "mrk" .
iana('Mortlockese') --> "mrl" .
iana('Merlav') --> "mrm" .
iana('Cheke Holo') --> "mrn" .
iana('Mru') --> "mro" .
iana('Morouas') --> "mrp" .
iana('North Marquesan') --> "mrq" .
iana('Maria (India)') --> "mrr" .
iana('Maragus') --> "mrs" .
iana('Marghi Central') --> "mrt" .
iana('Mono (Cameroon)') --> "mru" .
iana('Mangareva') --> "mrv" .
iana('Maranao') --> "mrw" .
iana('Maremgi') --> "mrx" .
iana('Mandaya') --> "mry" .
iana('Marind') --> "mrz" .
iana('Masbatenyo') --> "msb" .
iana('Sankaran Maninka') --> "msc" .
iana('Yucatec Maya Sign Language') --> "msd" .
iana('Musey') --> "mse" .
iana('Mekwei') --> "msf" .
iana('Moraid') --> "msg" .
iana('Masikoro Malagasy') --> "msh" .
iana('Sabah Malay') --> "msi" .
iana('Ma (Democratic Republic of Congo)') --> "msj" .
iana('Mansaka') --> "msk" .
iana('Molof') --> "msl" .
iana('Agusan Manobo') --> "msm" .
iana('Vurës') --> "msn" .
iana('Mombum') --> "mso" .
iana('Maritsauá') --> "msp" .
iana('Caac') --> "msq" .
iana('Mongolian Sign Language') --> "msr" .
iana('West Masela') --> "mss" .
iana('Cataelano Mandaya') --> "mst" .
iana('Musom') --> "msu" .
iana('Maslam') --> "msv" .
iana('Mansoanka') --> "msw" .
iana('Moresada') --> "msx" .
iana('Aruamu') --> "msy" .
iana('Momare') --> "msz" .
iana('Cotabato Manobo') --> "mta" .
iana('Anyin Morofo') --> "mtb" .
iana('Munit') --> "mtc" .
iana('Mualang') --> "mtd" .
iana('Mono (Solomon Islands)') --> "mte" .
iana('Murik (Papua New Guinea)') --> "mtf" .
iana('Una') --> "mtg" .
iana('Munggui') --> "mth" .
iana('Maiwa (Papua New Guinea)') --> "mti" .
iana('Moskona') --> "mtj" .
iana('Mbe\'') --> "mtk" .
iana('Montol') --> "mtl" .
iana('Mator') --> "mtm" .
iana('Matagalpa') --> "mtn" .
iana('Totontepec Mixe') --> "mto" .
iana('Wichí Lhamtés Nocten') --> "mtp" .
iana('Muong') --> "mtq" .
iana('Mewari') --> "mtr" .
iana('Yora') --> "mts" .
iana('Mota') --> "mtt" .
iana('Tututepec Mixtec') --> "mtu" .
iana('Asaro\'o') --> "mtv" .
iana('Southern Binukidnon') --> "mtw" .
iana('Tidaá Mixtec') --> "mtx" .
iana('Nabi') --> "mty" .
iana('Mundang') --> "mua" .
iana('Mubi') --> "mub" .
iana('Ajumbu') --> "muc" .
iana('Mednyj Aleut') --> "mud" .
iana('Media Lengua') --> "mue" .
iana('Musgu') --> "mug" .
iana('Mündü') --> "muh" .
iana('Musi') --> "mui" .
iana('Mabire') --> "muj" .
iana('Mugom') --> "muk" .
iana('Multiple languages') --> "mul" .
iana('Maiwala') --> "mum" .
iana('Munda languages') --> "mun" .
iana('Nyong') --> "muo" .
iana('Malvi') --> "mup" .
iana('Eastern Xiangxi Miao') --> "muq" .
iana('Murle') --> "mur" .
iana('Creek') --> "mus" .
iana('Western Muria') --> "mut" .
iana('Yaaku') --> "muu" .
iana('Muthuvan') --> "muv" .
iana('Bo-Ung') --> "mux" .
iana('Muyang') --> "muy" .
iana('Mursi') --> "muz" .
iana('Manam') --> "mva" .
iana('Mattole') --> "mvb" .
iana('Mamboru') --> "mvd" .
iana('Marwari (Pakistan)') --> "mve" .
iana('Peripheral Mongolian') --> "mvf" .
iana('Yucuañe Mixtec') --> "mvg" .
iana('Mulgi') --> "mvh" .
iana('Miyako') --> "mvi" .
iana('Mekmek') --> "mvk" .
iana('Mbara (Australia)') --> "mvl" .
iana('Muya') --> "mvm" .
iana('Minaveha') --> "mvn" .
iana('Marovo') --> "mvo" .
iana('Duri') --> "mvp" .
iana('Moere') --> "mvq" .
iana('Marau') --> "mvr" .
iana('Massep') --> "mvs" .
iana('Mpotovoro') --> "mvt" .
iana('Marfa') --> "mvu" .
iana('Tagal Murut') --> "mvv" .
iana('Machinga') --> "mvw" .
iana('Meoswar') --> "mvx" .
iana('Indus Kohistani') --> "mvy" .
iana('Mesqan') --> "mvz" .
iana('Mwatebu') --> "mwa" .
iana('Juwal') --> "mwb" .
iana('Are') --> "mwc" .
iana('Mudbura') --> "mwd" .
iana('Mwera (Chimwera)') --> "mwe" .
iana('Murrinh-Patha') --> "mwf" .
iana('Aiklep') --> "mwg" .
iana('Mouk-Aria') --> "mwh" .
iana('Labo') --> "mwi" .
iana('Maligo') --> "mwj" .
iana('Kita Maninkakan') --> "mwk" .
iana('Mirandese') --> "mwl" .
iana('Sar') --> "mwm" .
iana('Nyamwanga') --> "mwn" .
iana('Central Maewo') --> "mwo" .
iana('Kala Lagaw Ya') --> "mwp" .
iana('Mün Chin') --> "mwq" .
iana('Marwari') --> "mwr" .
iana('Mwimbi-Muthambi') --> "mws" .
iana('Moken') --> "mwt" .
iana('Mittu') --> "mwu" .
iana('Mentawai') --> "mwv" .
iana('Hmong Daw') --> "mww" .
iana('Mediak') --> "mwx" .
iana('Mosiro') --> "mwy" .
iana('Moingi') --> "mwz" .
iana('Northwest Oaxaca Mixtec') --> "mxa" .
iana('Tezoatlán Mixtec') --> "mxb" .
iana('Manyika') --> "mxc" .
iana('Modang') --> "mxd" .
iana('Mele-Fila') --> "mxe" .
iana('Malgbe') --> "mxf" .
iana('Mbangala') --> "mxg" .
iana('Mvuba') --> "mxh" .
iana('Mozarabic') --> "mxi" .
iana('Miju-Mishmi') --> "mxj" .
iana('Monumbo') --> "mxk" .
iana('Maxi Gbe') --> "mxl" .
iana('Meramera') --> "mxm" .
iana('Moi (Indonesia)') --> "mxn" .
iana('Mbowe') --> "mxo" .
iana('Tlahuitoltepec Mixe') --> "mxp" .
iana('Juquila Mixe') --> "mxq" .
iana('Murik (Malaysia)') --> "mxr" .
iana('Huitepec Mixtec') --> "mxs" .
iana('Jamiltepec Mixtec') --> "mxt" .
iana('Mada (Cameroon)') --> "mxu" .
iana('Metlatónoc Mixtec') --> "mxv" .
iana('Namo') --> "mxw" .
iana('Mahou') --> "mxx" .
iana('Southeastern Nochixtlán Mixtec') --> "mxy" .
iana('Central Masela') --> "mxz" .
iana('Mbay') --> "myb" .
iana('Mayeka') --> "myc" .
iana('Maramba') --> "myd" .
iana('Myene') --> "mye" .
iana('Bambassi') --> "myf" .
iana('Manta') --> "myg" .
iana('Makah') --> "myh" .
iana('Mina (India)') --> "myi" .
iana('Mangayat') --> "myj" .
iana('Mamara Senoufo') --> "myk" .
iana('Moma') --> "myl" .
iana('Me\'en') --> "mym" .
iana('Mayan languages') --> "myn" .
iana('Anfillo') --> "myo" .
iana('Pirahã') --> "myp" .
iana('Forest Maninka') --> "myq" .
iana('Muniche') --> "myr" .
iana('Mesmes') --> "mys" .
iana('Sangab Mandaya') --> "myt" .
iana('Mundurukú') --> "myu" .
iana('Erzya') --> "myv" .
iana('Muyuw') --> "myw" .
iana('Masaaba') --> "myx" .
iana('Macuna') --> "myy" .
iana('Classical Mandaic') --> "myz" .
iana('Santa María Zacatepec Mixtec') --> "mza" .
iana('Tumzabt') --> "mzb" .
iana('Madagascar Sign Language') --> "mzc" .
iana('Malimba') --> "mzd" .
iana('Morawa') --> "mze" .
iana('Monastic Sign Language') --> "mzg" .
iana('Wichí Lhamtés Güisnay') --> "mzh" .
iana('Ixcatlán Mazatec') --> "mzi" .
iana('Manya') --> "mzj" .
iana('Nigeria Mambila') --> "mzk" .
iana('Mazatlán Mixe') --> "mzl" .
iana('Mumuye') --> "mzm" .
iana('Mazanderani') --> "mzn" .
iana('Matipuhy') --> "mzo" .
iana('Movima') --> "mzp" .
iana('Mori Atas') --> "mzq" .
iana('Marúbo') --> "mzr" .
iana('Macanese') --> "mzs" .
iana('Mintil') --> "mzt" .
iana('Inapang') --> "mzu" .
iana('Manza') --> "mzv" .
iana('Deg') --> "mzw" .
iana('Mawayana') --> "mzx" .
iana('Mozambican Sign Language') --> "mzy" .
iana('Maiadomu') --> "mzz" .
iana('Namla') --> "naa" .
iana('Southern Nambikuára') --> "nab" .
iana('Narak') --> "nac" .
iana('Nijadali') --> "nad" .
iana('Naka\'ela') --> "nae" .
iana('Nabak') --> "naf" .
iana('Naga Pidgin') --> "nag" .
iana('Nahuatl languages') --> "nah" .
iana('North American Indian languages') --> "nai" .
iana('Nalu') --> "naj" .
iana('Nakanai') --> "nak" .
iana('Nalik') --> "nal" .
iana('Ngan\'gityemerri') --> "nam" .
iana('Min Nan Chinese') --> "nan" .
iana('Naaba') --> "nao" .
iana('Neapolitan') --> "nap" .
iana('Khoekhoe') --> "naq" .
iana('Iguta') --> "nar" .
iana('Naasioi') --> "nas" .
iana('Ca̱hungwa̱rya̱') --> "nat" .
iana('Nawuri') --> "naw" .
iana('Nakwi') --> "nax" .
iana('Narrinyeri') --> "nay" .
iana('Coatepec Nahuatl') --> "naz" .
iana('Nyemba') --> "nba" .
iana('Ndoe') --> "nbb" .
iana('Chang Naga') --> "nbc" .
iana('Ngbinda') --> "nbd" .
iana('Konyak Naga') --> "nbe" .
iana('Naxi') --> "nbf" .
iana('Nagarchal') --> "nbg" .
iana('Ngamo') --> "nbh" .
iana('Mao Naga') --> "nbi" .
iana('Ngarinman') --> "nbj" .
iana('Nake') --> "nbk" .
iana('Ngbaka Ma\'bo') --> "nbm" .
iana('Kuri') --> "nbn" .
iana('Nkukoli') --> "nbo" .
iana('Nnam') --> "nbp" .
iana('Nggem') --> "nbq" .
iana('Numana-Nunku-Gbantu-Numbu') --> "nbr" .
iana('Namibian Sign Language') --> "nbs" .
iana('Na') --> "nbt" .
iana('Rongmei Naga') --> "nbu" .
iana('Ngamambo') --> "nbv" .
iana('Southern Ngbandi') --> "nbw" .
iana('Ngura') --> "nbx" .
iana('Ningera') --> "nby" .
iana('Iyo') --> "nca" .
iana('Central Nicobarese') --> "ncb" .
iana('Ponam') --> "ncc" .
iana('Nachering') --> "ncd" .
iana('Yale') --> "nce" .
iana('Notsi') --> "ncf" .
iana('Nisga\'a') --> "ncg" .
iana('Central Huasteca Nahuatl') --> "nch" .
iana('Classical Nahuatl') --> "nci" .
iana('Northern Puebla Nahuatl') --> "ncj" .
iana('Nakara') --> "nck" .
iana('Michoacán Nahuatl') --> "ncl" .
iana('Nambo') --> "ncm" .
iana('Nauna') --> "ncn" .
iana('Sibe') --> "nco" .
iana('Ndaktup') --> "ncp" .
iana('Ncane') --> "ncr" .
iana('Nicaraguan Sign Language') --> "ncs" .
iana('Chothe Naga') --> "nct" .
iana('Chumburung') --> "ncu" .
iana('Central Puebla Nahuatl') --> "ncx" .
iana('Natchez') --> "ncz" .
iana('Ndasa') --> "nda" .
iana('Kenswei Nsei') --> "ndb" .
iana('Ndau') --> "ndc" .
iana('Nde-Nsele-Nta') --> "ndd" .
iana('Nadruvian') --> "ndf" .
iana('Ndengereko') --> "ndg" .
iana('Ndali') --> "ndh" .
iana('Samba Leko') --> "ndi" .
iana('Ndamba') --> "ndj" .
iana('Ndaka') --> "ndk" .
iana('Ndolo') --> "ndl" .
iana('Ndam') --> "ndm" .
iana('Ngundi') --> "ndn" .
iana('Ndo') --> "ndp" .
iana('Ndombe') --> "ndq" .
iana('Ndoola') --> "ndr" .
iana('Low German') --> "nds" .
iana('Ndunga') --> "ndt" .
iana('Dugun') --> "ndu" .
iana('Ndut') --> "ndv" .
iana('Ndobo') --> "ndw" .
iana('Nduga') --> "ndx" .
iana('Lutos') --> "ndy" .
iana('Ndogo') --> "ndz" .
iana('Eastern Ngad\'a') --> "nea" .
iana('Toura (Côte d\'Ivoire)') --> "neb" .
iana('Nedebang') --> "nec" .
iana('Nde-Gbite') --> "ned" .
iana('Nêlêmwa-Nixumwak') --> "nee" .
iana('Nefamese') --> "nef" .
iana('Negidal') --> "neg" .
iana('Nyenkha') --> "neh" .
iana('Neo-Hittite') --> "nei" .
iana('Neko') --> "nej" .
iana('Neku') --> "nek" .
iana('Nemi') --> "nem" .
iana('Nengone') --> "nen" .
iana('Ná-Meo') --> "neo" .
iana('North Central Mixe') --> "neq" .
iana('Yahadian') --> "ner" .
iana('Bhoti Kinnauri') --> "nes" .
iana('Nete') --> "net" .
iana('Neo') --> "neu" .
iana('Nyaheun') --> "nev" .
iana('Newari') --> "new" .
iana('Neme') --> "nex" .
iana('Neyo') --> "ney" .
iana('Nez Perce') --> "nez" .
iana('Dhao') --> "nfa" .
iana('Ahwai') --> "nfd" .
iana('Ayiwo') --> "nfl" .
iana('Nafaanra') --> "nfr" .
iana('Mfumte') --> "nfu" .
iana('Ngbaka') --> "nga" .
iana('Northern Ngbandi') --> "ngb" .
iana('Ngombe (Democratic Republic of Congo)') --> "ngc" .
iana('Ngando (Central African Republic)') --> "ngd" .
iana('Ngemba') --> "nge" .
iana('Trans-New Guinea languages') --> "ngf" .
iana('Ngbaka Manza') --> "ngg" .
iana('N/u') --> "ngh" .
iana('Ngizim') --> "ngi" .
iana('Ngie') --> "ngj" .
iana('Dalabon') --> "ngk" .
iana('Lomwe') --> "ngl" .
iana('Ngatik Men\'s Creole') --> "ngm" .
iana('Ngwo') --> "ngn" .
iana('Ngoni') --> "ngo" .
iana('Ngulu') --> "ngp" .
iana('Ngurimi') --> "ngq" .
iana('Engdewu') --> "ngr" .
iana('Gvoko') --> "ngs" .
iana('Ngeq') --> "ngt" .
iana('Guerrero Nahuatl') --> "ngu" .
iana('Nagumi') --> "ngv" .
iana('Ngwaba') --> "ngw" .
iana('Nggwahyi') --> "ngx" .
iana('Tibea') --> "ngy" .
iana('Ngungwel') --> "ngz" .
iana('Nhanda') --> "nha" .
iana('Beng') --> "nhb" .
iana('Tabasco Nahuatl') --> "nhc" .
iana('Chiripá') --> "nhd" .
iana('Eastern Huasteca Nahuatl') --> "nhe" .
iana('Nhuwala') --> "nhf" .
iana('Tetelcingo Nahuatl') --> "nhg" .
iana('Nahari') --> "nhh" .
iana('Zacatlán-Ahuacatlán-Tepetzintla Nahuatl') --> "nhi" .
iana('Isthmus-Cosoleacaque Nahuatl') --> "nhk" .
iana('Morelos Nahuatl') --> "nhm" .
iana('Central Nahuatl') --> "nhn" .
iana('Takuu') --> "nho" .
iana('Isthmus-Pajapan Nahuatl') --> "nhp" .
iana('Huaxcaleca Nahuatl') --> "nhq" .
iana('Naro') --> "nhr" .
iana('Ometepec Nahuatl') --> "nht" .
iana('Noone') --> "nhu" .
iana('Temascaltepec Nahuatl') --> "nhv" .
iana('Western Huasteca Nahuatl') --> "nhw" .
iana('Isthmus-Mecayapan Nahuatl') --> "nhx" .
iana('Northern Oaxaca Nahuatl') --> "nhy" .
iana('Santa María La Alta Nahuatl') --> "nhz" .
iana('Nias') --> "nia" .
iana('Nakame') --> "nib" .
iana('Niger-Kordofanian languages') --> "nic" .
iana('Ngandi') --> "nid" .
iana('Niellim') --> "nie" .
iana('Nek') --> "nif" .
iana('Ngalakan') --> "nig" .
iana('Nyiha (Tanzania)') --> "nih" .
iana('Nii') --> "nii" .
iana('Ngaju') --> "nij" .
iana('Southern Nicobarese') --> "nik" .
iana('Nila') --> "nil" .
iana('Nilamba') --> "nim" .
iana('Ninzo') --> "nin" .
iana('Nganasan') --> "nio" .
iana('Nandi') --> "niq" .
iana('Nimboran') --> "nir" .
iana('Nimi') --> "nis" .
iana('Southeastern Kolami') --> "nit" .
iana('Niuean') --> "niu" .
iana('Gilyak') --> "niv" .
iana('Nimo') --> "niw" .
iana('Hema') --> "nix" .
iana('Ngiti') --> "niy" .
iana('Ningil') --> "niz" .
iana('Nzanyi') --> "nja" .
iana('Nocte Naga') --> "njb" .
iana('Ndonde Hamba') --> "njd" .
iana('Lotha Naga') --> "njh" .
iana('Gudanji') --> "nji" .
iana('Njen') --> "njj" .
iana('Njalgulgule') --> "njl" .
iana('Angami Naga') --> "njm" .
iana('Liangmai Naga') --> "njn" .
iana('Ao Naga') --> "njo" .
iana('Njerep') --> "njr" .
iana('Nisa') --> "njs" .
iana('Ndyuka-Trio Pidgin') --> "njt" .
iana('Ngadjunmaya') --> "nju" .
iana('Kunyi') --> "njx" .
iana('Njyem') --> "njy" .
iana('Nyishi') --> "njz" .
iana('Nkoya') --> "nka" .
iana('Khoibu Naga') --> "nkb" .
iana('Nkongho') --> "nkc" .
iana('Koireng') --> "nkd" .
iana('Duke') --> "nke" .
iana('Inpui Naga') --> "nkf" .
iana('Nekgini') --> "nkg" .
iana('Khezha Naga') --> "nkh" .
iana('Thangal Naga') --> "nki" .
iana('Nakai') --> "nkj" .
iana('Nokuku') --> "nkk" .
iana('Namat') --> "nkm" .
iana('Nkangala') --> "nkn" .
iana('Nkonya') --> "nko" .
iana('Niuatoputapu') --> "nkp" .
iana('Nkami') --> "nkq" .
iana('Nukuoro') --> "nkr" .
iana('North Asmat') --> "nks" .
iana('Nyika (Tanzania)') --> "nkt" .
iana('Bouna Kulango') --> "nku" .
iana('Nyika (Malawi and Zambia)') --> "nkv" .
iana('Nkutu') --> "nkw" .
iana('Nkoroo') --> "nkx" .
iana('Nkari') --> "nkz" .
iana('Ngombale') --> "nla" .
iana('Nalca') --> "nlc" .
iana('East Nyala') --> "nle" .
iana('Gela') --> "nlg" .
iana('Grangali') --> "nli" .
iana('Nyali') --> "nlj" .
iana('Ninia Yali') --> "nlk" .
iana('Nihali') --> "nll" .
iana('Durango Nahuatl') --> "nln" .
iana('Ngul') --> "nlo" .
iana('Lao Naga') --> "nlq" .
iana('Ngarla') --> "nlr" .
iana('Nchumbulu') --> "nlu" .
iana('Orizaba Nahuatl') --> "nlv" .
iana('Walangama') --> "nlw" .
iana('Nahali') --> "nlx" .
iana('Nyamal') --> "nly" .
iana('Nalögo') --> "nlz" .
iana('Maram Naga') --> "nma" .
iana('Big Nambas') --> "nmb" .
iana('Ngam') --> "nmc" .
iana('Ndumu') --> "nmd" .
iana('Mzieme Naga') --> "nme" .
iana('Tangkhul Naga (India)') --> "nmf" .
iana('Kwasio') --> "nmg" .
iana('Monsang Naga') --> "nmh" .
iana('Nyam') --> "nmi" .
iana('Ngombe (Central African Republic)') --> "nmj" .
iana('Namakura') --> "nmk" .
iana('Ndemli') --> "nml" .
iana('Manangba') --> "nmm" .
iana('!Xóõ') --> "nmn" .
iana('Moyon Naga') --> "nmo" .
iana('Nimanbur') --> "nmp" .
iana('Nambya') --> "nmq" .
iana('Nimbari') --> "nmr" .
iana('Letemboi') --> "nms" .
iana('Namonuito') --> "nmt" .
iana('Northeast Maidu') --> "nmu" .
iana('Ngamini') --> "nmv" .
iana('Nimoa') --> "nmw" .
iana('Nama (Papua New Guinea)') --> "nmx" .
iana('Namuyi') --> "nmy" .
iana('Nawdm') --> "nmz" .
iana('Nyangumarta') --> "nna" .
iana('Nande') --> "nnb" .
iana('Nancere') --> "nnc" .
iana('West Ambae') --> "nnd" .
iana('Ngandyera') --> "nne" .
iana('Ngaing') --> "nnf" .
iana('Maring Naga') --> "nng" .
iana('Ngiemboon') --> "nnh" .
iana('North Nuaulu') --> "nni" .
iana('Nyangatom') --> "nnj" .
iana('Nankina') --> "nnk" .
iana('Northern Rengma Naga') --> "nnl" .
iana('Namia') --> "nnm" .
iana('Ngete') --> "nnn" .
iana('Wancho Naga') --> "nnp" .
iana('Ngindo') --> "nnq" .
iana('Narungga') --> "nnr" .
iana('Ningye') --> "nns" .
iana('Nanticoke') --> "nnt" .
iana('Dwang') --> "nnu" .
iana('Nugunu (Australia)') --> "nnv" .
iana('Southern Nuni') --> "nnw" .
iana('Ngong') --> "nnx" .
iana('Nyangga') --> "nny" .
iana('Nda\'nda\'') --> "nnz" .
iana('Woun Meu') --> "noa" .
iana('Nuk') --> "noc" .
iana('Northern Thai') --> "nod" .
iana('Nimadi') --> "noe" .
iana('Nomane') --> "nof" .
iana('Nogai') --> "nog" .
iana('Nomu') --> "noh" .
iana('Noiri') --> "noi" .
iana('Nonuya') --> "noj" .
iana('Nooksack') --> "nok" .
iana('Nomlaki') --> "nol" .
iana('Nocamán') --> "nom" .
iana('Old Norse') --> "non" .
iana('Nootka') --> "noo" .
iana('Numanggang') --> "nop" .
iana('Ngongo') --> "noq" .
iana('Eastern Nisu') --> "nos" .
iana('Nomatsiguenga') --> "not" .
iana('Ewage-Notu') --> "nou" .
iana('Novial') --> "nov" .
iana('Nyambo') --> "now" .
iana('Noy') --> "noy" .
iana('Nayi') --> "noz" .
iana('Nar Phu') --> "npa" .
iana('Nupbikha') --> "npb" .
iana('Ponyo-Gongwang Naga') --> "npg" .
iana('Phom Naga') --> "nph" .
iana('Nepali (individual language)') --> "npi" .
iana('Southeastern Puebla Nahuatl') --> "npl" .
iana('Mondropolon') --> "npn" .
iana('Pochuri Naga') --> "npo" .
iana('Nipsan') --> "nps" .
iana('Puimei Naga') --> "npu" .
iana('Napu') --> "npy" .
iana('Southern Nago') --> "nqg" .
iana('Kura Ede Nago') --> "nqk" .
iana('Ndom') --> "nqm" .
iana('Nen') --> "nqn" .
iana('N\'Ko') --> "nqo" .
iana('Kyan-Karyaw Naga') --> "nqq" .
iana('Akyaung Ari Naga') --> "nqy" .
iana('Ngom') --> "nra" .
iana('Nara') --> "nrb" .
iana('Noric') --> "nrc" .
iana('Southern Rengma Naga') --> "nre" .
iana('Jèrriais') --> "nrf" .
iana('Narango') --> "nrg" .
iana('Chokri Naga') --> "nri" .
iana('Ngarla') --> "nrk" .
iana('Ngarluma') --> "nrl" .
iana('Narom') --> "nrm" .
iana('Norn') --> "nrn" .
iana('North Picene') --> "nrp" .
iana('Norra') --> "nrr" .
iana('Northern Kalapuya') --> "nrt" .
iana('Narua') --> "nru" .
iana('Ngurmbur') --> "nrx" .
iana('Lala') --> "nrz" .
iana('Sangtam Naga') --> "nsa" .
iana('Nshi') --> "nsc" .
iana('Southern Nisu') --> "nsd" .
iana('Nsenga') --> "nse" .
iana('Northwestern Nisu') --> "nsf" .
iana('Ngasa') --> "nsg" .
iana('Ngoshie') --> "nsh" .
iana('Nigerian Sign Language') --> "nsi" .
iana('Naskapi') --> "nsk" .
iana('Norwegian Sign Language') --> "nsl" .
iana('Sumi Naga') --> "nsm" .
iana('Nehan') --> "nsn" .
iana('Pedi') --> "nso" .
iana('Nepalese Sign Language') --> "nsp" .
iana('Northern Sierra Miwok') --> "nsq" .
iana('Maritime Sign Language') --> "nsr" .
iana('Nali') --> "nss" .
iana('Tase Naga') --> "nst" .
iana('Sierra Negra Nahuatl') --> "nsu" .
iana('Southwestern Nisu') --> "nsv" .
iana('Navut') --> "nsw" .
iana('Nsongo') --> "nsx" .
iana('Nasal') --> "nsy" .
iana('Nisenan') --> "nsz" .
iana('Nathembo') --> "nte" .
iana('Ngantangarra') --> "ntg" .
iana('Natioro') --> "nti" .
iana('Ngaanyatjarra') --> "ntj" .
iana('Ikoma-Nata-Isenye') --> "ntk" .
iana('Nateni') --> "ntm" .
iana('Ntomba') --> "nto" .
iana('Northern Tepehuan') --> "ntp" .
iana('Delo') --> "ntr" .
iana('Natagaimas') --> "nts" .
iana('Natügu') --> "ntu" .
iana('Nottoway') --> "ntw" .
iana('Tangkhul Naga (Myanmar)') --> "ntx" .
iana('Mantsi') --> "nty" .
iana('Natanzi') --> "ntz" .
iana('Yuanga') --> "nua" .
iana('Nubian languages') --> "nub" .
iana('Nukuini') --> "nuc" .
iana('Ngala') --> "nud" .
iana('Ngundu') --> "nue" .
iana('Nusu') --> "nuf" .
iana('Nungali') --> "nug" .
iana('Ndunda') --> "nuh" .
iana('Ngumbi') --> "nui" .
iana('Nyole') --> "nuj" .
iana('Nuu-chah-nulth') --> "nuk" .
iana('Nusa Laut') --> "nul" .
iana('Niuafo\'ou') --> "num" .
iana('Anong') --> "nun" .
iana('Nguôn') --> "nuo" .
iana('Nupe-Nupe-Tako') --> "nup" .
iana('Nukumanu') --> "nuq" .
iana('Nukuria') --> "nur" .
iana('Nuer') --> "nus" .
iana('Nung (Viet Nam)') --> "nut" .
iana('Ngbundu') --> "nuu" .
iana('Northern Nuni') --> "nuv" .
iana('Nguluwan') --> "nuw" .
iana('Mehek') --> "nux" .
iana('Nunggubuyu') --> "nuy" .
iana('Tlamacazapa Nahuatl') --> "nuz" .
iana('Nasarian') --> "nvh" .
iana('Namiae') --> "nvm" .
iana('Nyokon') --> "nvo" .
iana('Nawathinehena') --> "nwa" .
iana('Nyabwa') --> "nwb" .
iana('Classical Newari') --> "nwc" .
iana('Ngwe') --> "nwe" .
iana('Ngayawung') --> "nwg" .
iana('Southwest Tanna') --> "nwi" .
iana('Nyamusa-Molo') --> "nwm" .
iana('Nauo') --> "nwo" .
iana('Nawaru') --> "nwr" .
iana('Middle Newar') --> "nwx" .
iana('Nottoway-Meherrin') --> "nwy" .
iana('Nauete') --> "nxa" .
iana('Ngando (Democratic Republic of Congo)') --> "nxd" .
iana('Nage') --> "nxe" .
iana('Ngad\'a') --> "nxg" .
iana('Nindi') --> "nxi" .
iana('Koki Naga') --> "nxk" .
iana('South Nuaulu') --> "nxl" .
iana('Numidian') --> "nxm" .
iana('Ngawun') --> "nxn" .
iana('Ndambomo') --> "nxo" .
iana('Naxi') --> "nxq" .
iana('Ninggerum') --> "nxr" .
iana('Narau') --> "nxu" .
iana('Nafri') --> "nxx" .
iana('Nyangbo') --> "nyb" .
iana('Nyanga-li') --> "nyc" .
iana('Nyore') --> "nyd" .
iana('Nyengo') --> "nye" .
iana('Giryama') --> "nyf" .
iana('Nyindu') --> "nyg" .
iana('Nyigina') --> "nyh" .
iana('Ama (Sudan)') --> "nyi" .
iana('Nyanga') --> "nyj" .
iana('Nyaneka') --> "nyk" .
iana('Nyeu') --> "nyl" .
iana('Nyamwezi') --> "nym" .
iana('Nyankole') --> "nyn" .
iana('Nyoro') --> "nyo" .
iana('Nyang\'i') --> "nyp" .
iana('Nayini') --> "nyq" .
iana('Nyiha (Malawi)') --> "nyr" .
iana('Nyunga') --> "nys" .
iana('Nyawaygi') --> "nyt" .
iana('Nyungwe') --> "nyu" .
iana('Nyulnyul') --> "nyv" .
iana('Nyaw') --> "nyw" .
iana('Nganyaywana') --> "nyx" .
iana('Nyakyusa-Ngonde') --> "nyy" .
iana('Tigon Mbembe') --> "nza" .
iana('Njebi') --> "nzb" .
iana('Nzima') --> "nzi" .
iana('Nzakara') --> "nzk" .
iana('Zeme Naga') --> "nzm" .
iana('New Zealand Sign Language') --> "nzs" .
iana('Teke-Nzikou') --> "nzu" .
iana('Nzakambay') --> "nzy" .
iana('Nanga Dama Dogon') --> "nzz" .
iana('Orok') --> "oaa" .
iana('Oroch') --> "oac" .
iana('Old Aramaic (up to 700 BCE)') --> "oar" .
iana('Old Avar') --> "oav" .
iana('Obispeño') --> "obi" .
iana('Southern Bontok') --> "obk" .
iana('Oblo') --> "obl" .
iana('Moabite') --> "obm" .
iana('Obo Manobo') --> "obo" .
iana('Old Burmese') --> "obr" .
iana('Old Breton') --> "obt" .
iana('Obulom') --> "obu" .
iana('Ocaina') --> "oca" .
iana('Old Chinese') --> "och" .
iana('Old Cornish') --> "oco" .
iana('Atzingo Matlatzinca') --> "ocu" .
iana('Odut') --> "oda" .
iana('Od') --> "odk" .
iana('Old Dutch') --> "odt" .
iana('Odual') --> "odu" .
iana('Ofo') --> "ofo" .
iana('Old Frisian') --> "ofs" .
iana('Efutop') --> "ofu" .
iana('Ogbia') --> "ogb" .
iana('Ogbah') --> "ogc" .
iana('Old Georgian') --> "oge" .
iana('Ogbogolo') --> "ogg" .
iana('Khana') --> "ogo" .
iana('Ogbronuagum') --> "ogu" .
iana('Old Hittite') --> "oht" .
iana('Old Hungarian') --> "ohu" .
iana('Oirata') --> "oia" .
iana('Inebu One') --> "oin" .
iana('Northwestern Ojibwa') --> "ojb" .
iana('Central Ojibwa') --> "ojc" .
iana('Eastern Ojibwa') --> "ojg" .
iana('Old Japanese') --> "ojp" .
iana('Severn Ojibwa') --> "ojs" .
iana('Ontong Java') --> "ojv" .
iana('Western Ojibwa') --> "ojw" .
iana('Okanagan') --> "oka" .
iana('Okobo') --> "okb" .
iana('Okodia') --> "okd" .
iana('Okpe (Southwestern Edo)') --> "oke" .
iana('Koko Babangk') --> "okg" .
iana('Koresh-e Rostam') --> "okh" .
iana('Okiek') --> "oki" .
iana('Oko-Juwoi') --> "okj" .
iana('Kwamtim One') --> "okk" .
iana('Old Kentish Sign Language') --> "okl" .
iana('Middle Korean (10th-16th cent.)') --> "okm" .
iana('Oki-No-Erabu') --> "okn" .
iana('Old Korean (3rd-9th cent.)') --> "oko" .
iana('Kirike') --> "okr" .
iana('Oko-Eni-Osayen') --> "oks" .
iana('Oku') --> "oku" .
iana('Orokaiva') --> "okv" .
iana('Okpe (Northwestern Edo)') --> "okx" .
iana('Walungge') --> "ola" .
iana('Mochi') --> "old" .
iana('Olekha') --> "ole" .
iana('Olkol') --> "olk" .
iana('Oloma') --> "olm" .
iana('Livvi') --> "olo" .
iana('Olrat') --> "olr" .
iana('Old Lithuanian') --> "olt" .
iana('Omaha-Ponca') --> "oma" .
iana('East Ambae') --> "omb" .
iana('Mochica') --> "omc" .
iana('Omejes') --> "ome" .
iana('Omagua') --> "omg" .
iana('Omi') --> "omi" .
iana('Omok') --> "omk" .
iana('Ombo') --> "oml" .
iana('Minoan') --> "omn" .
iana('Utarmbung') --> "omo" .
iana('Old Manipuri') --> "omp" .
iana('Oto-Manguean languages') --> "omq" .
iana('Old Marathi') --> "omr" .
iana('Omotik') --> "omt" .
iana('Omurano') --> "omu" .
iana('Omotic languages') --> "omv" .
iana('South Tairora') --> "omw" .
iana('Old Mon') --> "omx" .
iana('Ona') --> "ona" .
iana('Lingao') --> "onb" .
iana('Oneida') --> "one" .
iana('Olo') --> "ong" .
iana('Onin') --> "oni" .
iana('Onjob') --> "onj" .
iana('Kabore One') --> "onk" .
iana('Onobasulu') --> "onn" .
iana('Onondaga') --> "ono" .
iana('Sartang') --> "onp" .
iana('Northern One') --> "onr" .
iana('Ono') --> "ons" .
iana('Ontenu') --> "ont" .
iana('Unua') --> "onu" .
iana('Old Nubian') --> "onw" .
iana('Onin Based Pidgin') --> "onx" .
iana('Tohono O\'odham') --> "ood" .
iana('Ong') --> "oog" .
iana('Önge') --> "oon" .
iana('Oorlams') --> "oor" .
iana('Old Ossetic') --> "oos" .
iana('Okpamheri') --> "opa" .
iana('Kopkaka') --> "opk" .
iana('Oksapmin') --> "opm" .
iana('Opao') --> "opo" .
iana('Opata') --> "opt" .
iana('Ofayé') --> "opy" .
iana('Oroha') --> "ora" .
iana('Orma') --> "orc" .
iana('Orejón') --> "ore" .
iana('Oring') --> "org" .
iana('Oroqen') --> "orh" .
iana('Orang Kanaq') --> "orn" .
iana('Orokolo') --> "oro" .
iana('Oruma') --> "orr" .
iana('Orang Seletar') --> "ors" .
iana('Adivasi Oriya') --> "ort" .
iana('Ormuri') --> "oru" .
iana('Old Russian') --> "orv" .
iana('Oro Win') --> "orw" .
iana('Oro') --> "orx" .
iana('Oriya (individual language)') --> "ory" .
iana('Ormu') --> "orz" .
iana('Osage') --> "osa" .
iana('Oscan') --> "osc" .
iana('Osing') --> "osi" .
iana('Ososo') --> "oso" .
iana('Old Spanish') --> "osp" .
iana('Osatu') --> "ost" .
iana('Southern One') --> "osu" .
iana('Old Saxon') --> "osx" .
iana('Ottoman Turkish (1500-1928)') --> "ota" .
iana('Old Tibetan') --> "otb" .
iana('Ot Danum') --> "otd" .
iana('Mezquital Otomi') --> "ote" .
iana('Oti') --> "oti" .
iana('Old Turkish') --> "otk" .
iana('Tilapa Otomi') --> "otl" .
iana('Eastern Highland Otomi') --> "otm" .
iana('Tenango Otomi') --> "otn" .
iana('Otomian languages') --> "oto" .
iana('Querétaro Otomi') --> "otq" .
iana('Otoro') --> "otr" .
iana('Estado de México Otomi') --> "ots" .
iana('Temoaya Otomi') --> "ott" .
iana('Otuke') --> "otu" .
iana('Ottawa') --> "otw" .
iana('Texcatepec Otomi') --> "otx" .
iana('Old Tamil') --> "oty" .
iana('Ixtenco Otomi') --> "otz" .
iana('Tagargrent') --> "oua" .
iana('Glio-Oubi') --> "oub" .
iana('Oune') --> "oue" .
iana('Old Uighur') --> "oui" .
iana('Ouma') --> "oum" .
iana('!O!ung') --> "oun" .
iana('Owiniga') --> "owi" .
iana('Old Welsh') --> "owl" .
iana('Oy') --> "oyb" .
iana('Oyda') --> "oyd" .
iana('Wayampi') --> "oym" .
iana('Oya\'oya') --> "oyy" .
iana('Koonzime') --> "ozm" .
iana('Papuan languages') --> "paa" .
iana('Parecís') --> "pab" .
iana('Pacoh') --> "pac" .
iana('Paumarí') --> "pad" .
iana('Pagibete') --> "pae" .
iana('Paranawát') --> "paf" .
iana('Pangasinan') --> "pag" .
iana('Tenharim') --> "pah" .
iana('Pe') --> "pai" .
iana('Parakanã') --> "pak" .
iana('Pahlavi') --> "pal" .
iana('Pampanga') --> "pam" .
iana('Northern Paiute') --> "pao" .
iana('Papiamento') --> "pap" .
iana('Parya') --> "paq" .
iana('Panamint') --> "par" .
iana('Papasena') --> "pas" .
iana('Papitalai') --> "pat" .
iana('Palauan') --> "pau" .
iana('Pakaásnovos') --> "pav" .
iana('Pawnee') --> "paw" .
iana('Pankararé') --> "pax" .
iana('Pech') --> "pay" .
iana('Pankararú') --> "paz" .
iana('Páez') --> "pbb" .
iana('Patamona') --> "pbc" .
iana('Mezontla Popoloca') --> "pbe" .
iana('Coyotepec Popoloca') --> "pbf" .
iana('Paraujano') --> "pbg" .
iana('E\'ñapa Woromaipu') --> "pbh" .
iana('Parkwa') --> "pbi" .
iana('Mak (Nigeria)') --> "pbl" .
iana('Kpasam') --> "pbn" .
iana('Papel') --> "pbo" .
iana('Badyara') --> "pbp" .
iana('Pangwa') --> "pbr" .
iana('Central Pame') --> "pbs" .
iana('Southern Pashto') --> "pbt" .
iana('Northern Pashto') --> "pbu" .
iana('Pnar') --> "pbv" .
iana('Pyu (Papua New Guinea)') --> "pby" .
iana('Palu') --> "pbz" .
iana('Santa Inés Ahuatempan Popoloca') --> "pca" .
iana('Pear') --> "pcb" .
iana('Bouyei') --> "pcc" .
iana('Picard') --> "pcd" .
iana('Ruching Palaung') --> "pce" .
iana('Paliyan') --> "pcf" .
iana('Paniya') --> "pcg" .
iana('Pardhan') --> "pch" .
iana('Duruwa') --> "pci" .
iana('Parenga') --> "pcj" .
iana('Paite Chin') --> "pck" .
iana('Pardhi') --> "pcl" .
iana('Nigerian Pidgin') --> "pcm" .
iana('Piti') --> "pcn" .
iana('Pacahuara') --> "pcp" .
iana('Panang') --> "pcr" .
iana('Pyapun') --> "pcw" .
iana('Anam') --> "pda" .
iana('Pennsylvania German') --> "pdc" .
iana('Pa Di') --> "pdi" .
iana('Podena') --> "pdn" .
iana('Padoe') --> "pdo" .
iana('Plautdietsch') --> "pdt" .
iana('Kayan') --> "pdu" .
iana('Peranakan Indonesian') --> "pea" .
iana('Eastern Pomo') --> "peb" .
iana('Mala (Papua New Guinea)') --> "ped" .
iana('Taje') --> "pee" .
iana('Northeastern Pomo') --> "pef" .
iana('Pengo') --> "peg" .
iana('Bonan') --> "peh" .
iana('Chichimeca-Jonaz') --> "pei" .
iana('Northern Pomo') --> "pej" .
iana('Penchal') --> "pek" .
iana('Pekal') --> "pel" .
iana('Phende') --> "pem" .
iana('Old Persian (ca. 600-400 B.C.)') --> "peo" .
iana('Kunja') --> "pep" .
iana('Southern Pomo') --> "peq" .
iana('Iranian Persian') --> "pes" .
iana('Pémono') --> "pev" .
iana('Petats') --> "pex" .
iana('Petjo') --> "pey" .
iana('Eastern Penan') --> "pez" .
iana('Pááfang') --> "pfa" .
iana('Peere') --> "pfe" .
iana('Pfaelzisch') --> "pfl" .
iana('Sudanese Creole Arabic') --> "pga" .
iana('Gāndhārī') --> "pgd" .
iana('Pangwali') --> "pgg" .
iana('Pagi') --> "pgi" .
iana('Rerep') --> "pgk" .
iana('Primitive Irish') --> "pgl" .
iana('Paelignian') --> "pgn" .
iana('Pangseng') --> "pgs" .
iana('Pagu') --> "pgu" .
iana('Pongyong') --> "pgy" .
iana('Pa-Hng') --> "pha" .
iana('Phudagi') --> "phd" .
iana('Phuong') --> "phg" .
iana('Phukha') --> "phh" .
iana('Philippine languages') --> "phi" .
iana('Phake') --> "phk" .
iana('Phalura') --> "phl" .
iana('Phimbi') --> "phm" .
iana('Phoenician') --> "phn" .
iana('Phunoi') --> "pho" .
iana('Phana\'') --> "phq" .
iana('Pahari-Potwari') --> "phr" .
iana('Phu Thai') --> "pht" .
iana('Phuan') --> "phu" .
iana('Pahlavani') --> "phv" .
iana('Phangduwali') --> "phw" .
iana('Pima Bajo') --> "pia" .
iana('Yine') --> "pib" .
iana('Pinji') --> "pic" .
iana('Piaroa') --> "pid" .
iana('Piro') --> "pie" .
iana('Pingelapese') --> "pif" .
iana('Pisabo') --> "pig" .
iana('Pitcairn-Norfolk') --> "pih" .
iana('Pini') --> "pii" .
iana('Pijao') --> "pij" .
iana('Yom') --> "pil" .
iana('Powhatan') --> "pim" .
iana('Piame') --> "pin" .
iana('Piapoco') --> "pio" .
iana('Pero') --> "pip" .
iana('Piratapuyo') --> "pir" .
iana('Pijin') --> "pis" .
iana('Pitta Pitta') --> "pit" .
iana('Pintupi-Luritja') --> "piu" .
iana('Pileni') --> "piv" .
iana('Pimbwe') --> "piw" .
iana('Piu') --> "pix" .
iana('Piya-Kwonci') --> "piy" .
iana('Pije') --> "piz" .
iana('Pitjantjatjara') --> "pjt" .
iana('Ardhamāgadhī Prākrit') --> "pka" .
iana('Pokomo') --> "pkb" .
iana('Paekche') --> "pkc" .
iana('Pak-Tong') --> "pkg" .
iana('Pankhu') --> "pkh" .
iana('Pakanha') --> "pkn" .
iana('Pökoot') --> "pko" .
iana('Pukapuka') --> "pkp" .
iana('Attapady Kurumba') --> "pkr" .
iana('Pakistan Sign Language') --> "pks" .
iana('Maleng') --> "pkt" .
iana('Paku') --> "pku" .
iana('Miani') --> "pla" .
iana('Polonombauk') --> "plb" .
iana('Central Palawano') --> "plc" .
iana('Polari') --> "pld" .
iana('Palu\'e') --> "ple" .
iana('Central Malayo-Polynesian languages') --> "plf" .
iana('Pilagá') --> "plg" .
iana('Paulohi') --> "plh" .
iana('Polci') --> "plj" .
iana('Kohistani Shina') --> "plk" .
iana('Shwe Palaung') --> "pll" .
iana('Palenquero') --> "pln" .
iana('Oluta Popoluca') --> "plo" .
iana('Palpa') --> "plp" .
iana('Palaic') --> "plq" .
iana('Palaka Senoufo') --> "plr" .
iana('San Marcos Tlacoyalco Popoloca') --> "pls" .
iana('Plateau Malagasy') --> "plt" .
iana('Palikúr') --> "plu" .
iana('Southwest Palawano') --> "plv" .
iana('Brooke\'s Point Palawano') --> "plw" .
iana('Bolyu') --> "ply" .
iana('Paluan') --> "plz" .
iana('Paama') --> "pma" .
iana('Pambia') --> "pmb" .
iana('Palumata') --> "pmc" .
iana('Pallanganmiddang') --> "pmd" .
iana('Pwaamei') --> "pme" .
iana('Pamona') --> "pmf" .
iana('Māhārāṣṭri Prākrit') --> "pmh" .
iana('Northern Pumi') --> "pmi" .
iana('Southern Pumi') --> "pmj" .
iana('Pamlico') --> "pmk" .
iana('Lingua Franca') --> "pml" .
iana('Pomo') --> "pmm" .
iana('Pam') --> "pmn" .
iana('Pom') --> "pmo" .
iana('Northern Pame') --> "pmq" .
iana('Paynamar') --> "pmr" .
iana('Piemontese') --> "pms" .
iana('Tuamotuan') --> "pmt" .
iana('Mirpur Panjabi') --> "pmu" .
iana('Plains Miwok') --> "pmw" .
iana('Poumei Naga') --> "pmx" .
iana('Papuan Malay') --> "pmy" .
iana('Southern Pame') --> "pmz" .
iana('Punan Bah-Biau') --> "pna" .
iana('Western Panjabi') --> "pnb" .
iana('Pannei') --> "pnc" .
iana('Western Penan') --> "pne" .
iana('Pongu') --> "png" .
iana('Penrhyn') --> "pnh" .
iana('Aoheng') --> "pni" .
iana('Pinjarup') --> "pnj" .
iana('Paunaka') --> "pnk" .
iana('Paleni') --> "pnl" .
iana('Punan Batu 1') --> "pnm" .
iana('Pinai-Hagahai') --> "pnn" .
iana('Panobo') --> "pno" .
iana('Pancana') --> "pnp" .
iana('Pana (Burkina Faso)') --> "pnq" .
iana('Panim') --> "pnr" .
iana('Ponosakan') --> "pns" .
iana('Pontic') --> "pnt" .
iana('Jiongnai Bunu') --> "pnu" .
iana('Pinigura') --> "pnv" .
iana('Panytyima') --> "pnw" .
iana('Phong-Kniang') --> "pnx" .
iana('Pinyin') --> "pny" .
iana('Pana (Central African Republic)') --> "pnz" .
iana('Poqomam') --> "poc" .
iana('Ponares') --> "pod" .
iana('San Juan Atzingo Popoloca') --> "poe" .
iana('Poke') --> "pof" .
iana('Potiguára') --> "pog" .
iana('Poqomchi\'') --> "poh" .
iana('Highland Popoluca') --> "poi" .
iana('Pokangá') --> "pok" .
iana('Southeastern Pomo') --> "pom" .
iana('Pohnpeian') --> "pon" .
iana('Central Pomo') --> "poo" .
iana('Pwapwâ') --> "pop" .
iana('Texistepec Popoluca') --> "poq" .
iana('Sayula Popoluca') --> "pos" .
iana('Potawatomi') --> "pot" .
iana('Upper Guinea Crioulo') --> "pov" .
iana('San Felipe Otlaltepec Popoloca') --> "pow" .
iana('Polabian') --> "pox" .
iana('Pogolo') --> "poy" .
iana('Malayo-Polynesian languages') --> "poz" .
iana('Pao') --> "ppa" .
iana('Papi') --> "ppe" .
iana('Paipai') --> "ppi" .
iana('Uma') --> "ppk" .
iana('Pipil') --> "ppl" .
iana('Papuma') --> "ppm" .
iana('Papapana') --> "ppn" .
iana('Folopa') --> "ppo" .
iana('Pelende') --> "ppp" .
iana('Pei') --> "ppq" .
iana('Piru') --> "ppr" .
iana('San Luís Temalacayuca Popoloca') --> "pps" .
iana('Pare') --> "ppt" .
iana('Papora') --> "ppu" .
iana('Pa\'a') --> "pqa" .
iana('Eastern Malayo-Polynesian languages') --> "pqe" .
iana('Malecite-Passamaquoddy') --> "pqm" .
iana('Western Malayo-Polynesian languages') --> "pqw" .
iana('Prakrit languages') --> "pra" .
iana('Lua\'') --> "prb" .
iana('Parachi') --> "prc" .
iana('Parsi-Dari') --> "prd" .
iana('Principense') --> "pre" .
iana('Paranan') --> "prf" .
iana('Prussian') --> "prg" .
iana('Porohanon') --> "prh" .
iana('Paicî') --> "pri" .
iana('Parauk') --> "prk" .
iana('Peruvian Sign Language') --> "prl" .
iana('Kibiri') --> "prm" .
iana('Prasuni') --> "prn" .
iana('Old Provençal (to 1500)') --> "pro" .
iana('Parsi') --> "prp" .
iana('Ashéninka Perené') --> "prq" .
iana('Puri') --> "prr" .
iana('Dari') --> "prs" .
iana('Phai') --> "prt" .
iana('Puragi') --> "pru" .
iana('Parawen') --> "prw" .
iana('Purik') --> "prx" .
iana('Pray 3') --> "pry" .
iana('Providencia Sign Language') --> "prz" .
iana('Asue Awyu') --> "psa" .
iana('Persian Sign Language') --> "psc" .
iana('Plains Indian Sign Language') --> "psd" .
iana('Central Malay') --> "pse" .
iana('Penang Sign Language') --> "psg" .
iana('Southwest Pashai') --> "psh" .
iana('Southeast Pashai') --> "psi" .
iana('Puerto Rican Sign Language') --> "psl" .
iana('Pauserna') --> "psm" .
iana('Panasuan') --> "psn" .
iana('Polish Sign Language') --> "pso" .
iana('Philippine Sign Language') --> "psp" .
iana('Pasi') --> "psq" .
iana('Portuguese Sign Language') --> "psr" .
iana('Kaulong') --> "pss" .
iana('Central Pashto') --> "pst" .
iana('Sauraseni Prākrit') --> "psu" .
iana('Port Sandwich') --> "psw" .
iana('Piscataway') --> "psy" .
iana('Pai Tavytera') --> "pta" .
iana('Pataxó Hã-Ha-Hãe') --> "pth" .
iana('Pintiini') --> "pti" .
iana('Patani') --> "ptn" .
iana('Zo\'é') --> "pto" .
iana('Patep') --> "ptp" .
iana('Pattapu') --> "ptq" .
iana('Piamatsina') --> "ptr" .
iana('Enrekang') --> "ptt" .
iana('Bambam') --> "ptu" .
iana('Port Vato') --> "ptv" .
iana('Pentlatch') --> "ptw" .
iana('Pathiya') --> "pty" .
iana('Western Highland Purepecha') --> "pua" .
iana('Purum') --> "pub" .
iana('Punan Merap') --> "puc" .
iana('Punan Aput') --> "pud" .
iana('Puelche') --> "pue" .
iana('Punan Merah') --> "puf" .
iana('Phuie') --> "pug" .
iana('Puinave') --> "pui" .
iana('Punan Tubu') --> "puj" .
iana('Pu Ko') --> "puk" .
iana('Puma') --> "pum" .
iana('Puoc') --> "puo" .
iana('Pulabu') --> "pup" .
iana('Puquina') --> "puq" .
iana('Puruborá') --> "pur" .
iana('Putoh') --> "put" .
iana('Punu') --> "puu" .
iana('Puluwatese') --> "puw" .
iana('Puare') --> "pux" .
iana('Purisimeño') --> "puy" .
iana('Purum Naga') --> "puz" .
iana('Pawaia') --> "pwa" .
iana('Panawa') --> "pwb" .
iana('Gapapaiwa') --> "pwg" .
iana('Patwin') --> "pwi" .
iana('Molbog') --> "pwm" .
iana('Paiwan') --> "pwn" .
iana('Pwo Western Karen') --> "pwo" .
iana('Powari') --> "pwr" .
iana('Pwo Northern Karen') --> "pww" .
iana('Quetzaltepec Mixe') --> "pxm" .
iana('Pye Krumen') --> "pye" .
iana('Fyam') --> "pym" .
iana('Poyanáwa') --> "pyn" .
iana('Paraguayan Sign Language') --> "pys" .
iana('Puyuma') --> "pyu" .
iana('Pyu (Myanmar)') --> "pyx" .
iana('Pyen') --> "pyy" .
iana('Para Naga') --> "pzn" .
iana('Private use') --> "qaa..qtz" .
iana('Quapaw') --> "qua" .
iana('Huallaga Huánuco Quechua') --> "qub" .
iana('K\'iche\'') --> "quc" .
iana('Calderón Highland Quichua') --> "qud" .
iana('Lambayeque Quechua') --> "quf" .
iana('Chimborazo Highland Quichua') --> "qug" .
iana('South Bolivian Quechua') --> "quh" .
iana('Quileute') --> "qui" .
iana('Chachapoyas Quechua') --> "quk" .
iana('North Bolivian Quechua') --> "qul" .
iana('Sipacapense') --> "qum" .
iana('Quinault') --> "qun" .
iana('Southern Pastaza Quechua') --> "qup" .
iana('Quinqui') --> "quq" .
iana('Yanahuanca Pasco Quechua') --> "qur" .
iana('Santiago del Estero Quichua') --> "qus" .
iana('Sacapulteco') --> "quv" .
iana('Tena Lowland Quichua') --> "quw" .
iana('Yauyos Quechua') --> "qux" .
iana('Ayacucho Quechua') --> "quy" .
iana('Cusco Quechua') --> "quz" .
iana('Ambo-Pasco Quechua') --> "qva" .
iana('Cajamarca Quechua') --> "qvc" .
iana('Eastern Apurímac Quechua') --> "qve" .
iana('Huamalíes-Dos de Mayo Huánuco Quechua') --> "qvh" .
iana('Imbabura Highland Quichua') --> "qvi" .
iana('Loja Highland Quichua') --> "qvj" .
iana('Cajatambo North Lima Quechua') --> "qvl" .
iana('Margos-Yarowilca-Lauricocha Quechua') --> "qvm" .
iana('North Junín Quechua') --> "qvn" .
iana('Napo Lowland Quechua') --> "qvo" .
iana('Pacaraos Quechua') --> "qvp" .
iana('San Martín Quechua') --> "qvs" .
iana('Huaylla Wanca Quechua') --> "qvw" .
iana('Queyu') --> "qvy" .
iana('Northern Pastaza Quichua') --> "qvz" .
iana('Corongo Ancash Quechua') --> "qwa" .
iana('Classical Quechua') --> "qwc" .
iana('Quechuan (family)') --> "qwe" .
iana('Huaylas Ancash Quechua') --> "qwh" .
iana('Kuman (Russia)') --> "qwm" .
iana('Sihuas Ancash Quechua') --> "qws" .
iana('Kwalhioqua-Tlatskanai') --> "qwt" .
iana('Chiquián Ancash Quechua') --> "qxa" .
iana('Chincha Quechua') --> "qxc" .
iana('Panao Huánuco Quechua') --> "qxh" .
iana('Salasaca Highland Quichua') --> "qxl" .
iana('Northern Conchucos Ancash Quechua') --> "qxn" .
iana('Southern Conchucos Ancash Quechua') --> "qxo" .
iana('Puno Quechua') --> "qxp" .
iana('Qashqa\'i') --> "qxq" .
iana('Cañar Highland Quichua') --> "qxr" .
iana('Southern Qiang') --> "qxs" .
iana('Santa Ana de Tusi Pasco Quechua') --> "qxt" .
iana('Arequipa-La Unión Quechua') --> "qxu" .
iana('Jauja Wanca Quechua') --> "qxw" .
iana('Quenya') --> "qya" .
iana('Quiripi') --> "qyp" .
iana('Dungmali') --> "raa" .
iana('Camling') --> "rab" .
iana('Rasawa') --> "rac" .
iana('Rade') --> "rad" .
iana('Western Meohang') --> "raf" .
iana('Logooli') --> "rag" .
iana('Rabha') --> "rah" .
iana('Ramoaaina') --> "rai" .
iana('Rajasthani') --> "raj" .
iana('Tulu-Bohuai') --> "rak" .
iana('Ralte') --> "ral" .
iana('Canela') --> "ram" .
iana('Riantana') --> "ran" .
iana('Rao') --> "rao" .
iana('Rapanui') --> "rap" .
iana('Saam') --> "raq" .
iana('Rarotongan') --> "rar" .
iana('Tegali') --> "ras" .
iana('Razajerdi') --> "rat" .
iana('Raute') --> "rau" .
iana('Sampang') --> "rav" .
iana('Rawang') --> "raw" .
iana('Rang') --> "rax" .
iana('Rapa') --> "ray" .
iana('Rahambuu') --> "raz" .
iana('Rumai Palaung') --> "rbb" .
iana('Northern Bontok') --> "rbk" .
iana('Miraya Bikol') --> "rbl" .
iana('Barababaraba') --> "rbp" .
iana('Réunion Creole French') --> "rcf" .
iana('Rudbari') --> "rdb" .
iana('Rerau') --> "rea" .
iana('Rembong') --> "reb" .
iana('Rejang Kayan') --> "ree" .
iana('Kara (Tanzania)') --> "reg" .
iana('Reli') --> "rei" .
iana('Rejang') --> "rej" .
iana('Rendille') --> "rel" .
iana('Remo') --> "rem" .
iana('Rengao') --> "ren" .
iana('Rer Bare') --> "rer" .
iana('Reshe') --> "res" .
iana('Retta') --> "ret" .
iana('Reyesano') --> "rey" .
iana('Roria') --> "rga" .
iana('Romano-Greek') --> "rge" .
iana('Rangkas') --> "rgk" .
iana('Romagnol') --> "rgn" .
iana('Resígaro') --> "rgr" .
iana('Southern Roglai') --> "rgs" .
iana('Ringgou') --> "rgu" .
iana('Rohingya') --> "rhg" .
iana('Yahang') --> "rhp" .
iana('Riang (India)') --> "ria" .
iana('Rien') --> "rie" .
iana('Tarifit') --> "rif" .
iana('Riang (Myanmar)') --> "ril" .
iana('Nyaturu') --> "rim" .
iana('Nungu') --> "rin" .
iana('Ribun') --> "rir" .
iana('Ritarungo') --> "rit" .
iana('Riung') --> "riu" .
iana('Rajong') --> "rjg" .
iana('Raji') --> "rji" .
iana('Rajbanshi') --> "rjs" .
iana('Kraol') --> "rka" .
iana('Rikbaktsa') --> "rkb" .
iana('Rakahanga-Manihiki') --> "rkh" .
iana('Rakhine') --> "rki" .
iana('Marka') --> "rkm" .
iana('Rangpuri') --> "rkt" .
iana('Arakwal') --> "rkw" .
iana('Rama') --> "rma" .
iana('Rembarunga') --> "rmb" .
iana('Carpathian Romani') --> "rmc" .
iana('Traveller Danish') --> "rmd" .
iana('Angloromani') --> "rme" .
iana('Kalo Finnish Romani') --> "rmf" .
iana('Traveller Norwegian') --> "rmg" .
iana('Murkim') --> "rmh" .
iana('Lomavren') --> "rmi" .
iana('Romkun') --> "rmk" .
iana('Baltic Romani') --> "rml" .
iana('Roma') --> "rmm" .
iana('Balkan Romani') --> "rmn" .
iana('Sinte Romani') --> "rmo" .
iana('Rempi') --> "rmp" .
iana('Caló') --> "rmq" .
iana('Caló') --> "rmr" .
iana('Romanian Sign Language') --> "rms" .
iana('Domari') --> "rmt" .
iana('Tavringer Romani') --> "rmu" .
iana('Romanova') --> "rmv" .
iana('Welsh Romani') --> "rmw" .
iana('Romam') --> "rmx" .
iana('Vlax Romani') --> "rmy" .
iana('Marma') --> "rmz" .
iana('Runa') --> "rna" .
iana('Ruund') --> "rnd" .
iana('Ronga') --> "rng" .
iana('Ranglong') --> "rnl" .
iana('Roon') --> "rnn" .
iana('Rongpo') --> "rnp" .
iana('Nari Nari') --> "rnr" .
iana('Rungwa') --> "rnw" .
iana('Romance languages') --> "roa" .
iana('Tae\'') --> "rob" .
iana('Cacgia Roglai') --> "roc" .
iana('Rogo') --> "rod" .
iana('Ronji') --> "roe" .
iana('Rombo') --> "rof" .
iana('Northern Roglai') --> "rog" .
iana('Romblomanon') --> "rol" .
iana('Romany') --> "rom" .
iana('Rotokas') --> "roo" .
iana('Kriol') --> "rop" .
iana('Rongga') --> "ror" .
iana('Runga') --> "rou" .
iana('Dela-Oenale') --> "row" .
iana('Repanbitip') --> "rpn" .
iana('Rapting') --> "rpt" .
iana('Ririo') --> "rri" .
iana('Waima') --> "rro" .
iana('Arritinngithigh') --> "rrt" .
iana('Romano-Serbian') --> "rsb" .
iana('Rennellese Sign Language') --> "rsi" .
iana('Russian Sign Language') --> "rsl" .
iana('Rungtu Chin') --> "rtc" .
iana('Ratahan') --> "rth" .
iana('Rotuman') --> "rtm" .
iana('Yurats') --> "rts" .
iana('Rathawi') --> "rtw" .
iana('Gungu') --> "rub" .
iana('Ruuli') --> "ruc" .
iana('Rusyn') --> "rue" .
iana('Luguru') --> "ruf" .
iana('Roviana') --> "ruh" .
iana('Rufiji') --> "rui" .
iana('Che') --> "ruk" .
iana('Istro Romanian') --> "ruo" .
iana('Macedo-Romanian') --> "rup" .
iana('Megleno Romanian') --> "ruq" .
iana('Rutul') --> "rut" .
iana('Lanas Lobu') --> "ruu" .
iana('Mala (Nigeria)') --> "ruy" .
iana('Ruma') --> "ruz" .
iana('Rawo') --> "rwa" .
iana('Rwa') --> "rwk" .
iana('Amba (Uganda)') --> "rwm" .
iana('Rawa') --> "rwo" .
iana('Marwari (India)') --> "rwr" .
iana('Ngardi') --> "rxd" .
iana('Karuwali') --> "rxw" .
iana('Northern Amami-Oshima') --> "ryn" .
iana('Yaeyama') --> "rys" .
iana('Central Okinawan') --> "ryu" .
iana('Saba') --> "saa" .
iana('Buglere') --> "sab" .
iana('Meskwaki') --> "sac" .
iana('Sandawe') --> "sad" .
iana('Sabanê') --> "sae" .
iana('Safaliba') --> "saf" .
iana('Yakut') --> "sah" .
iana('South American Indian languages') --> "sai" .
iana('Sahu') --> "saj" .
iana('Sake') --> "sak" .
iana('Salishan languages') --> "sal" .
iana('Samaritan Aramaic') --> "sam" .
iana('Sause') --> "sao" .
iana('Sanapaná') --> "sap" .
iana('Samburu') --> "saq" .
iana('Saraveca') --> "sar" .
iana('Sasak') --> "sas" .
iana('Santali') --> "sat" .
iana('Saleman') --> "sau" .
iana('Saafi-Saafi') --> "sav" .
iana('Sawi') --> "saw" .
iana('Sa') --> "sax" .
iana('Saya') --> "say" .
iana('Saurashtra') --> "saz" .
iana('Ngambay') --> "sba" .
iana('Simbo') --> "sbb" .
iana('Kele (Papua New Guinea)') --> "sbc" .
iana('Southern Samo') --> "sbd" .
iana('Saliba') --> "sbe" .
iana('Chabu') --> "sbf" .
iana('Seget') --> "sbg" .
iana('Sori-Harengan') --> "sbh" .
iana('Seti') --> "sbi" .
iana('Surbakhal') --> "sbj" .
iana('Safwa') --> "sbk" .
iana('Botolan Sambal') --> "sbl" .
iana('Sagala') --> "sbm" .
iana('Sindhi Bhil') --> "sbn" .
iana('Sabüm') --> "sbo" .
iana('Sangu (Tanzania)') --> "sbp" .
iana('Sileibi') --> "sbq" .
iana('Sembakung Murut') --> "sbr" .
iana('Subiya') --> "sbs" .
iana('Kimki') --> "sbt" .
iana('Stod Bhoti') --> "sbu" .
iana('Sabine') --> "sbv" .
iana('Simba') --> "sbw" .
iana('Seberuang') --> "sbx" .
iana('Soli') --> "sby" .
iana('Sara Kaba') --> "sbz" .
iana('Sansu') --> "sca" .
iana('Chut') --> "scb" .
iana('Dongxiang') --> "sce" .
iana('San Miguel Creole French') --> "scf" .
iana('Sanggau') --> "scg" .
iana('Sakachep') --> "sch" .
iana('Sri Lankan Creole Malay') --> "sci" .
iana('Sadri') --> "sck" .
iana('Shina') --> "scl" .
iana('Sicilian') --> "scn" .
iana('Scots') --> "sco" .
iana('Helambu Sherpa') --> "scp" .
iana('Sa\'och') --> "scq" .
iana('North Slavey') --> "scs" .
iana('Shumcho') --> "scu" .
iana('Sheni') --> "scv" .
iana('Sha') --> "scw" .
iana('Sicel') --> "scx" .
iana('Toraja-Sa\'dan') --> "sda" .
iana('Shabak') --> "sdb" .
iana('Sassarese Sardinian') --> "sdc" .
iana('Surubu') --> "sde" .
iana('Sarli') --> "sdf" .
iana('Savi') --> "sdg" .
iana('Southern Kurdish') --> "sdh" .
iana('Suundi') --> "sdj" .
iana('Sos Kundi') --> "sdk" .
iana('Saudi Arabian Sign Language') --> "sdl" .
iana('Semandang') --> "sdm" .
iana('Gallurese Sardinian') --> "sdn" .
iana('Bukar-Sadung Bidayuh') --> "sdo" .
iana('Sherdukpen') --> "sdp" .
iana('Oraon Sadri') --> "sdr" .
iana('Sened') --> "sds" .
iana('Shuadit') --> "sdt" .
iana('Sarudu') --> "sdu" .
iana('Eastern Sudanic languages') --> "sdv" .
iana('Sibu Melanau') --> "sdx" .
iana('Sallands') --> "sdz" .
iana('Semai') --> "sea" .
iana('Shempire Senoufo') --> "seb" .
iana('Sechelt') --> "sec" .
iana('Sedang') --> "sed" .
iana('Seneca') --> "see" .
iana('Cebaara Senoufo') --> "sef" .
iana('Segeju') --> "seg" .
iana('Sena') --> "seh" .
iana('Seri') --> "sei" .
iana('Sene') --> "sej" .
iana('Sekani') --> "sek" .
iana('Selkup') --> "sel" .
iana('Semitic languages') --> "sem" .
iana('Nanerigé Sénoufo') --> "sen" .
iana('Suarmin') --> "seo" .
iana('Sìcìté Sénoufo') --> "sep" .
iana('Senara Sénoufo') --> "seq" .
iana('Serrano') --> "ser" .
iana('Koyraboro Senni Songhai') --> "ses" .
iana('Sentani') --> "set" .
iana('Serui-Laut') --> "seu" .
iana('Nyarafolo Senoufo') --> "sev" .
iana('Sewa Bay') --> "sew" .
iana('Secoya') --> "sey" .
iana('Senthang Chin') --> "sez" .
iana('Langue des signes de Belgique Francophone') --> "sfb" .
iana('Eastern Subanen') --> "sfe" .
iana('Small Flowery Miao') --> "sfm" .
iana('South African Sign Language') --> "sfs" .
iana('Sehwi') --> "sfw" .
iana('Old Irish (to 900)') --> "sga" .
iana('Mag-antsi Ayta') --> "sgb" .
iana('Kipsigis') --> "sgc" .
iana('Surigaonon') --> "sgd" .
iana('Segai') --> "sge" .
iana('Swiss-German Sign Language') --> "sgg" .
iana('Shughni') --> "sgh" .
iana('Suga') --> "sgi" .
iana('Surgujia') --> "sgj" .
iana('Sangkong') --> "sgk" .
iana('Sanglechi-Ishkashimi') --> "sgl" .
iana('Singa') --> "sgm" .
iana('Sign languages') --> "sgn" .
iana('Songa') --> "sgo" .
iana('Singpho') --> "sgp" .
iana('Sangisari') --> "sgr" .
iana('Samogitian') --> "sgs" .
iana('Brokpake') --> "sgt" .
iana('Salas') --> "sgu" .
iana('Sebat Bet Gurage') --> "sgw" .
iana('Sierra Leone Sign Language') --> "sgx" .
iana('Sanglechi') --> "sgy" .
iana('Sursurunga') --> "sgz" .
iana('Shall-Zwall') --> "sha" .
iana('Ninam') --> "shb" .
iana('Sonde') --> "shc" .
iana('Kundal Shahi') --> "shd" .
iana('Sheko') --> "she" .
iana('Shua') --> "shg" .
iana('Shoshoni') --> "shh" .
iana('Tachelhit') --> "shi" .
iana('Shatt') --> "shj" .
iana('Shilluk') --> "shk" .
iana('Shendu') --> "shl" .
iana('Shahrudi') --> "shm" .
iana('Shan') --> "shn" .
iana('Shanga') --> "sho" .
iana('Shipibo-Conibo') --> "shp" .
iana('Sala') --> "shq" .
iana('Shi') --> "shr" .
iana('Shuswap') --> "shs" .
iana('Shasta') --> "sht" .
iana('Chadian Arabic') --> "shu" .
iana('Shehri') --> "shv" .
iana('Shwai') --> "shw" .
iana('She') --> "shx" .
iana('Tachawit') --> "shy" .
iana('Syenara Senoufo') --> "shz" .
iana('Akkala Sami') --> "sia" .
iana('Sebop') --> "sib" .
iana('Sidamo') --> "sid" .
iana('Simaa') --> "sie" .
iana('Siamou') --> "sif" .
iana('Paasaal') --> "sig" .
iana('Zire') --> "sih" .
iana('Shom Peng') --> "sii" .
iana('Numbami') --> "sij" .
iana('Sikiana') --> "sil" .
iana('Mende (Papua New Guinea)') --> "sim" .
iana('Siouan languages') --> "sio" .
iana('Sikkimese') --> "sip" .
iana('Sonia') --> "siq" .
iana('Siri') --> "sir" .
iana('Siuslaw') --> "sis" .
iana('Sino-Tibetan languages') --> "sit" .
iana('Sinagen') --> "siu" .
iana('Sumariup') --> "siv" .
iana('Siwai') --> "siw" .
iana('Sumau') --> "six" .
iana('Sivandi') --> "siy" .
iana('Siwi') --> "siz" .
iana('Epena') --> "sja" .
iana('Sajau Basap') --> "sjb" .
iana('Kildin Sami') --> "sjd" .
iana('Pite Sami') --> "sje" .
iana('Assangori') --> "sjg" .
iana('Kemi Sami') --> "sjk" .
iana('Sajalong') --> "sjl" .
iana('Mapun') --> "sjm" .
iana('Sindarin') --> "sjn" .
iana('Xibe') --> "sjo" .
iana('Surjapuri') --> "sjp" .
iana('Siar-Lak') --> "sjr" .
iana('Senhaja De Srair') --> "sjs" .
iana('Ter Sami') --> "sjt" .
iana('Ume Sami') --> "sju" .
iana('Shawnee') --> "sjw" .
iana('Skagit') --> "ska" .
iana('Saek') --> "skb" .
iana('Ma Manda') --> "skc" .
iana('Southern Sierra Miwok') --> "skd" .
iana('Seke (Vanuatu)') --> "ske" .
iana('Sakirabiá') --> "skf" .
iana('Sakalava Malagasy') --> "skg" .
iana('Sikule') --> "skh" .
iana('Sika') --> "ski" .
iana('Seke (Nepal)') --> "skj" .
iana('Sok') --> "skk" .
iana('Kutong') --> "skm" .
iana('Kolibugan Subanon') --> "skn" .
iana('Seko Tengah') --> "sko" .
iana('Sekapan') --> "skp" .
iana('Sininkere') --> "skq" .
iana('Saraiki') --> "skr" .
iana('Maia') --> "sks" .
iana('Sakata') --> "skt" .
iana('Sakao') --> "sku" .
iana('Skou') --> "skv" .
iana('Skepi Creole Dutch') --> "skw" .
iana('Seko Padang') --> "skx" .
iana('Sikaiana') --> "skz" .
iana('Slavic languages') --> "sla" .
iana('Sáliba') --> "slc" .
iana('Sissala') --> "sld" .
iana('Sholaga') --> "sle" .
iana('Swiss-Italian Sign Language') --> "slf" .
iana('Selungai Murut') --> "slg" .
iana('Southern Puget Sound Salish') --> "slh" .
iana('Lower Silesian') --> "sli" .
iana('Salumá') --> "slj" .
iana('Salt-Yui') --> "sll" .
iana('Pangutaran Sama') --> "slm" .
iana('Salinan') --> "sln" .
iana('Lamaholot') --> "slp" .
iana('Salchuq') --> "slq" .
iana('Salar') --> "slr" .
iana('Singapore Sign Language') --> "sls" .
iana('Sila') --> "slt" .
iana('Selaru') --> "slu" .
iana('Sialum') --> "slw" .
iana('Salampasu') --> "slx" .
iana('Selayar') --> "sly" .
iana('Ma\'ya') --> "slz" .
iana('Southern Sami') --> "sma" .
iana('Simbari') --> "smb" .
iana('Som') --> "smc" .
iana('Sama') --> "smd" .
iana('Auwe') --> "smf" .
iana('Simbali') --> "smg" .
iana('Samei') --> "smh" .
iana('Sami languages') --> "smi" .
iana('Lule Sami') --> "smj" .
iana('Bolinao') --> "smk" .
iana('Central Sama') --> "sml" .
iana('Musasa') --> "smm" .
iana('Inari Sami') --> "smn" .
iana('Samaritan') --> "smp" .
iana('Samo') --> "smq" .
iana('Simeulue') --> "smr" .
iana('Skolt Sami') --> "sms" .
iana('Simte') --> "smt" .
iana('Somray') --> "smu" .
iana('Samvedi') --> "smv" .
iana('Sumbawa') --> "smw" .
iana('Samba') --> "smx" .
iana('Semnani') --> "smy" .
iana('Simeku') --> "smz" .
iana('Sebuyau') --> "snb" .
iana('Sinaugoro') --> "snc" .
iana('Bau Bidayuh') --> "sne" .
iana('Noon') --> "snf" .
iana('Sanga (Democratic Republic of Congo)') --> "sng" .
iana('Shinabo') --> "snh" .
iana('Sensi') --> "sni" .
iana('Riverain Sango') --> "snj" .
iana('Soninke') --> "snk" .
iana('Sangil') --> "snl" .
iana('Southern Ma\'di') --> "snm" .
iana('Siona') --> "snn" .
iana('Snohomish') --> "sno" .
iana('Siane') --> "snp" .
iana('Sangu (Gabon)') --> "snq" .
iana('Sihan') --> "snr" .
iana('South West Bay') --> "sns" .
iana('Senggi') --> "snu" .
iana('Sa\'ban') --> "snv" .
iana('Selee') --> "snw" .
iana('Sam') --> "snx" .
iana('Saniyo-Hiyewe') --> "sny" .
iana('Sinsauru') --> "snz" .
iana('Thai Song') --> "soa" .
iana('Sobei') --> "sob" .
iana('So (Democratic Republic of Congo)') --> "soc" .
iana('Songoora') --> "sod" .
iana('Songomeno') --> "soe" .
iana('Sogdian') --> "sog" .
iana('Aka') --> "soh" .
iana('Sonha') --> "soi" .
iana('Soi') --> "soj" .
iana('Sokoro') --> "sok" .
iana('Solos') --> "sol" .
iana('Songhai languages') --> "son" .
iana('Songo') --> "soo" .
iana('Songe') --> "sop" .
iana('Kanasi') --> "soq" .
iana('Somrai') --> "sor" .
iana('Seeku') --> "sos" .
iana('Southern Thai') --> "sou" .
iana('Sonsorol') --> "sov" .
iana('Sowanda') --> "sow" .
iana('Swo') --> "sox" .
iana('Miyobe') --> "soy" .
iana('Temi') --> "soz" .
iana('Sepa (Indonesia)') --> "spb" .
iana('Sapé') --> "spc" .
iana('Saep') --> "spd" .
iana('Sepa (Papua New Guinea)') --> "spe" .
iana('Sian') --> "spg" .
iana('Saponi') --> "spi" .
iana('Sengo') --> "spk" .
iana('Selepet') --> "spl" .
iana('Akukem') --> "spm" .
iana('Sanapaná') --> "spn" .
iana('Spokane') --> "spo" .
iana('Supyire Senoufo') --> "spp" .
iana('Loreto-Ucayali Spanish') --> "spq" .
iana('Saparua') --> "spr" .
iana('Saposa') --> "sps" .
iana('Spiti Bhoti') --> "spt" .
iana('Sapuan') --> "spu" .
iana('Sambalpuri') --> "spv" .
iana('South Picene') --> "spx" .
iana('Sabaot') --> "spy" .
iana('Shama-Sambuga') --> "sqa" .
iana('Shau') --> "sqh" .
iana('Albanian languages') --> "sqj" .
iana('Albanian Sign Language') --> "sqk" .
iana('Suma') --> "sqm" .
iana('Susquehannock') --> "sqn" .
iana('Sorkhei') --> "sqo" .
iana('Sou') --> "sqq" .
iana('Siculo Arabic') --> "sqr" .
iana('Sri Lankan Sign Language') --> "sqs" .
iana('Soqotri') --> "sqt" .
iana('Squamish') --> "squ" .
iana('Saruga') --> "sra" .
iana('Sora') --> "srb" .
iana('Logudorese Sardinian') --> "src" .
iana('Sara') --> "sre" .
iana('Nafi') --> "srf" .
iana('Sulod') --> "srg" .
iana('Sarikoli') --> "srh" .
iana('Siriano') --> "sri" .
iana('Serudung Murut') --> "srk" .
iana('Isirawa') --> "srl" .
iana('Saramaccan') --> "srm" .
iana('Sranan Tongo') --> "srn" .
iana('Campidanese Sardinian') --> "sro" .
iana('Sirionó') --> "srq" .
iana('Serer') --> "srr" .
iana('Sarsi') --> "srs" .
iana('Sauri') --> "srt" .
iana('Suruí') --> "sru" .
iana('Southern Sorsoganon') --> "srv" .
iana('Serua') --> "srw" .
iana('Sirmauri') --> "srx" .
iana('Sera') --> "sry" .
iana('Shahmirzadi') --> "srz" .
iana('Nilo-Saharan languages') --> "ssa" .
iana('Southern Sama') --> "ssb" .
iana('Suba-Simbiti') --> "ssc" .
iana('Siroi') --> "ssd" .
iana('Balangingi') --> "sse" .
iana('Thao') --> "ssf" .
iana('Seimat') --> "ssg" .
iana('Shihhi Arabic') --> "ssh" .
iana('Sansi') --> "ssi" .
iana('Sausi') --> "ssj" .
iana('Sunam') --> "ssk" .
iana('Western Sisaala') --> "ssl" .
iana('Semnam') --> "ssm" .
iana('Waata') --> "ssn" .
iana('Sissano') --> "sso" .
iana('Spanish Sign Language') --> "ssp" .
iana('So\'a') --> "ssq" .
iana('Swiss-French Sign Language') --> "ssr" .
iana('Sô') --> "sss" .
iana('Sinasina') --> "sst" .
iana('Susuami') --> "ssu" .
iana('Shark Bay') --> "ssv" .
iana('Samberigi') --> "ssx" .
iana('Saho') --> "ssy" .
iana('Sengseng') --> "ssz" .
iana('Settla') --> "sta" .
iana('Northern Subanen') --> "stb" .
iana('Sentinel') --> "std" .
iana('Liana-Seti') --> "stf" .
iana('Trieng') --> "stg" .
iana('Shelta') --> "sth" .
iana('Bulo Stieng') --> "sti" .
iana('Matya Samo') --> "stj" .
iana('Arammba') --> "stk" .
iana('Stellingwerfs') --> "stl" .
iana('Setaman') --> "stm" .
iana('Owa') --> "stn" .
iana('Stoney') --> "sto" .
iana('Southeastern Tepehuan') --> "stp" .
iana('Saterfriesisch') --> "stq" .
iana('Straits Salish') --> "str" .
iana('Shumashti') --> "sts" .
iana('Budeh Stieng') --> "stt" .
iana('Samtao') --> "stu" .
iana('Silt\'e') --> "stv" .
iana('Satawalese') --> "stw" .
iana('Siberian Tatar') --> "sty" .
iana('Sulka') --> "sua" .
iana('Suku') --> "sub" .
iana('Western Subanon') --> "suc" .
iana('Suena') --> "sue" .
iana('Suganga') --> "sug" .
iana('Suki') --> "sui" .
iana('Shubi') --> "suj" .
iana('Sukuma') --> "suk" .
iana('Surigaonon') --> "sul" .
iana('Sumo-Mayangna') --> "sum" .
iana('Suri') --> "suq" .
iana('Mwaghavul') --> "sur" .
iana('Susu') --> "sus" .
iana('Subtiaba') --> "sut" .
iana('Puroik') --> "suv" .
iana('Sumbwa') --> "suw" .
iana('Sumerian') --> "sux" .
iana('Suyá') --> "suy" .
iana('Sunwar') --> "suz" .
iana('Svan') --> "sva" .
iana('Ulau-Suain') --> "svb" .
iana('Vincentian Creole English') --> "svc" .
iana('Serili') --> "sve" .
iana('Slovakian Sign Language') --> "svk" .
iana('Slavomolisano') --> "svm" .
iana('Savara') --> "svr" .
iana('Savosavo') --> "svs" .
iana('Skalvian') --> "svx" .
iana('Maore Comorian') --> "swb" .
iana('Congo Swahili') --> "swc" .
iana('Sere') --> "swf" .
iana('Swabian') --> "swg" .
iana('Swahili (individual language)') --> "swh" .
iana('Sui') --> "swi" .
iana('Sira') --> "swj" .
iana('Malawi Sena') --> "swk" .
iana('Swedish Sign Language') --> "swl" .
iana('Samosa') --> "swm" .
iana('Sawknah') --> "swn" .
iana('Shanenawa') --> "swo" .
iana('Suau') --> "swp" .
iana('Sharwa') --> "swq" .
iana('Saweru') --> "swr" .
iana('Seluwasan') --> "sws" .
iana('Sawila') --> "swt" .
iana('Suwawa') --> "swu" .
iana('Shekhawati') --> "swv" .
iana('Sowa') --> "sww" .
iana('Suruahá') --> "swx" .
iana('Sarua') --> "swy" .
iana('Suba') --> "sxb" .
iana('Sicanian') --> "sxc" .
iana('Sighu') --> "sxe" .
iana('Shixing') --> "sxg" .
iana('Southern Kalapuya') --> "sxk" .
iana('Selian') --> "sxl" .
iana('Samre') --> "sxm" .
iana('Sangir') --> "sxn" .
iana('Sorothaptic') --> "sxo" .
iana('Saaroa') --> "sxr" .
iana('Sasaru') --> "sxs" .
iana('Upper Saxon') --> "sxu" .
iana('Saxwe Gbe') --> "sxw" .
iana('Siang') --> "sya" .
iana('Central Subanen') --> "syb" .
iana('Classical Syriac') --> "syc" .
iana('Samoyedic languages') --> "syd" .
iana('Seki') --> "syi" .
iana('Sukur') --> "syk" .
iana('Sylheti') --> "syl" .
iana('Maya Samo') --> "sym" .
iana('Senaya') --> "syn" .
iana('Suoy') --> "syo" .
iana('Syriac') --> "syr" .
iana('Sinyar') --> "sys" .
iana('Kagate') --> "syw" .
iana('Samay') --> "syx" .
iana('Al-Sayyid Bedouin Sign Language') --> "syy" .
iana('Semelai') --> "sza" .
iana('Ngalum') --> "szb" .
iana('Semaq Beri') --> "szc" .
iana('Seru') --> "szd" .
iana('Seze') --> "sze" .
iana('Sengele') --> "szg" .
iana('Silesian') --> "szl" .
iana('Sula') --> "szn" .
iana('Suabo') --> "szp" .
iana('Isu (Fako Division)') --> "szv" .
iana('Sawai') --> "szw" .
iana('Lower Tanana') --> "taa" .
iana('Tabassaran') --> "tab" .
iana('Lowland Tarahumara') --> "tac" .
iana('Tause') --> "tad" .
iana('Tariana') --> "taf" .
iana('Tagoi') --> "tag" .
iana('Tai languages') --> "tai" .
iana('Eastern Tamang') --> "taj" .
iana('Tala') --> "tak" .
iana('Tal') --> "tal" .
iana('Tangale') --> "tan" .
iana('Yami') --> "tao" .
iana('Taabwa') --> "tap" .
iana('Tamasheq') --> "taq" .
iana('Central Tarahumara') --> "tar" .
iana('Tay Boi') --> "tas" .
iana('Upper Tanana') --> "tau" .
iana('Tatuyo') --> "tav" .
iana('Tai') --> "taw" .
iana('Tamki') --> "tax" .
iana('Atayal') --> "tay" .
iana('Tocho') --> "taz" .
iana('Aikanã') --> "tba" .
iana('Tapeba') --> "tbb" .
iana('Takia') --> "tbc" .
iana('Kaki Ae') --> "tbd" .
iana('Tanimbili') --> "tbe" .
iana('Mandara') --> "tbf" .
iana('North Tairora') --> "tbg" .
iana('Thurawal') --> "tbh" .
iana('Gaam') --> "tbi" .
iana('Tiang') --> "tbj" .
iana('Calamian Tagbanwa') --> "tbk" .
iana('Tboli') --> "tbl" .
iana('Tagbu') --> "tbm" .
iana('Barro Negro Tunebo') --> "tbn" .
iana('Tawala') --> "tbo" .
iana('Taworta') --> "tbp" .
iana('Tibeto-Burman languages') --> "tbq" .
iana('Tumtum') --> "tbr" .
iana('Tanguat') --> "tbs" .
iana('Tembo (Kitembo)') --> "tbt" .
iana('Tubar') --> "tbu" .
iana('Tobo') --> "tbv" .
iana('Tagbanwa') --> "tbw" .
iana('Kapin') --> "tbx" .
iana('Tabaru') --> "tby" .
iana('Ditammari') --> "tbz" .
iana('Ticuna') --> "tca" .
iana('Tanacross') --> "tcb" .
iana('Datooga') --> "tcc" .
iana('Tafi') --> "tcd" .
iana('Southern Tutchone') --> "tce" .
iana('Malinaltepec Me\'phaa') --> "tcf" .
iana('Tamagario') --> "tcg" .
iana('Turks And Caicos Creole English') --> "tch" .
iana('Wára') --> "tci" .
iana('Tchitchege') --> "tck" .
iana('Taman (Myanmar)') --> "tcl" .
iana('Tanahmerah') --> "tcm" .
iana('Tichurong') --> "tcn" .
iana('Taungyo') --> "tco" .
iana('Tawr Chin') --> "tcp" .
iana('Kaiy') --> "tcq" .
iana('Torres Strait Creole') --> "tcs" .
iana('T\'en') --> "tct" .
iana('Southeastern Tarahumara') --> "tcu" .
iana('Tecpatlán Totonac') --> "tcw" .
iana('Toda') --> "tcx" .
iana('Tulu') --> "tcy" .
iana('Thado Chin') --> "tcz" .
iana('Tagdal') --> "tda" .
iana('Panchpargania') --> "tdb" .
iana('Emberá-Tadó') --> "tdc" .
iana('Tai Nüa') --> "tdd" .
iana('Tiranige Diga Dogon') --> "tde" .
iana('Talieng') --> "tdf" .
iana('Western Tamang') --> "tdg" .
iana('Thulung') --> "tdh" .
iana('Tomadino') --> "tdi" .
iana('Tajio') --> "tdj" .
iana('Tambas') --> "tdk" .
iana('Sur') --> "tdl" .
iana('Tondano') --> "tdn" .
iana('Teme') --> "tdo" .
iana('Tita') --> "tdq" .
iana('Todrah') --> "tdr" .
iana('Doutai') --> "tds" .
iana('Tetun Dili') --> "tdt" .
iana('Tempasuk Dusun') --> "tdu" .
iana('Toro') --> "tdv" .
iana('Tandroy-Mahafaly Malagasy') --> "tdx" .
iana('Tadyawan') --> "tdy" .
iana('Temiar') --> "tea" .
iana('Tetete') --> "teb" .
iana('Terik') --> "tec" .
iana('Tepo Krumen') --> "ted" .
iana('Huehuetla Tepehua') --> "tee" .
iana('Teressa') --> "tef" .
iana('Teke-Tege') --> "teg" .
iana('Tehuelche') --> "teh" .
iana('Torricelli') --> "tei" .
iana('Ibali Teke') --> "tek" .
iana('Timne') --> "tem" .
iana('Tama (Colombia)') --> "ten" .
iana('Teso') --> "teo" .
iana('Tepecano') --> "tep" .
iana('Temein') --> "teq" .
iana('Tereno') --> "ter" .
iana('Tengger') --> "tes" .
iana('Tetum') --> "tet" .
iana('Soo') --> "teu" .
iana('Teor') --> "tev" .
iana('Tewa (USA)') --> "tew" .
iana('Tennet') --> "tex" .
iana('Tulishi') --> "tey" .
iana('Tofin Gbe') --> "tfi" .
iana('Tanaina') --> "tfn" .
iana('Tefaro') --> "tfo" .
iana('Teribe') --> "tfr" .
iana('Ternate') --> "tft" .
iana('Sagalla') --> "tga" .
iana('Tobilung') --> "tgb" .
iana('Tigak') --> "tgc" .
iana('Ciwogai') --> "tgd" .
iana('Eastern Gorkha Tamang') --> "tge" .
iana('Chalikha') --> "tgf" .
iana('Tangga') --> "tgg" .
iana('Tobagonian Creole English') --> "tgh" .
iana('Lawunuia') --> "tgi" .
iana('Tagin') --> "tgj" .
iana('Tandaganon') --> "tgn" .
iana('Sudest') --> "tgo" .
iana('Tangoa') --> "tgp" .
iana('Tring') --> "tgq" .
iana('Tareng') --> "tgr" .
iana('Nume') --> "tgs" .
iana('Central Tagbanwa') --> "tgt" .
iana('Tanggu') --> "tgu" .
iana('Tingui-Boto') --> "tgv" .
iana('Tagwana Senoufo') --> "tgw" .
iana('Tagish') --> "tgx" .
iana('Togoyo') --> "tgy" .
iana('Tagalaka') --> "tgz" .
iana('Tai Hang Tong') --> "thc" .
iana('Thayore') --> "thd" .
iana('Chitwania Tharu') --> "the" .
iana('Thangmi') --> "thf" .
iana('Northern Tarahumara') --> "thh" .
iana('Tai Long') --> "thi" .
iana('Tharaka') --> "thk" .
iana('Dangaura Tharu') --> "thl" .
iana('Aheu') --> "thm" .
iana('Thachanadan') --> "thn" .
iana('Thompson') --> "thp" .
iana('Kochila Tharu') --> "thq" .
iana('Rana Tharu') --> "thr" .
iana('Thakali') --> "ths" .
iana('Tahltan') --> "tht" .
iana('Thuri') --> "thu" .
iana('Tahaggart Tamahaq') --> "thv" .
iana('Thudam') --> "thw" .
iana('The') --> "thx" .
iana('Tha') --> "thy" .
iana('Tayart Tamajeq') --> "thz" .
iana('Tidikelt Tamazight') --> "tia" .
iana('Tira') --> "tic" .
iana('Tidong') --> "tid" .
iana('Tingal') --> "tie" .
iana('Tifal') --> "tif" .
iana('Tigre') --> "tig" .
iana('Timugon Murut') --> "tih" .
iana('Tiene') --> "tii" .
iana('Tilung') --> "tij" .
iana('Tikar') --> "tik" .
iana('Tillamook') --> "til" .
iana('Timbe') --> "tim" .
iana('Tindi') --> "tin" .
iana('Teop') --> "tio" .
iana('Trimuris') --> "tip" .
iana('Tiéfo') --> "tiq" .
iana('Masadiit Itneg') --> "tis" .
iana('Tinigua') --> "tit" .
iana('Adasen') --> "tiu" .
iana('Tiv') --> "tiv" .
iana('Tiwi') --> "tiw" .
iana('Southern Tiwa') --> "tix" .
iana('Tiruray') --> "tiy" .
iana('Tai Hongjin') --> "tiz" .
iana('Tajuasohn') --> "tja" .
iana('Tunjung') --> "tjg" .
iana('Northern Tujia') --> "tji" .
iana('Tai Laing') --> "tjl" .
iana('Timucua') --> "tjm" .
iana('Tonjon') --> "tjn" .
iana('Temacine Tamazight') --> "tjo" .
iana('Southern Tujia') --> "tjs" .
iana('Tjurruru') --> "tju" .
iana('Djabwurrung') --> "tjw" .
iana('Truká') --> "tka" .
iana('Buksa') --> "tkb" .
iana('Tukudede') --> "tkd" .
iana('Takwane') --> "tke" .
iana('Tukumanféd') --> "tkf" .
iana('Tesaka Malagasy') --> "tkg" .
iana('Takpa') --> "tkk" .
iana('Tokelau') --> "tkl" .
iana('Takelma') --> "tkm" .
iana('Toku-No-Shima') --> "tkn" .
iana('Tikopia') --> "tkp" .
iana('Tee') --> "tkq" .
iana('Tsakhur') --> "tkr" .
iana('Takestani') --> "tks" .
iana('Kathoriya Tharu') --> "tkt" .
iana('Upper Necaxa Totonac') --> "tku" .
iana('Mur Pano') --> "tkv" .
iana('Teanu') --> "tkw" .
iana('Tangko') --> "tkx" .
iana('Takua') --> "tkz" .
iana('Southwestern Tepehuan') --> "tla" .
iana('Tobelo') --> "tlb" .
iana('Yecuatla Totonac') --> "tlc" .
iana('Talaud') --> "tld" .
iana('Telefol') --> "tlf" .
iana('Tofanma') --> "tlg" .
iana('Klingon') --> "tlh" .
iana('Tlingit') --> "tli" .
iana('Talinga-Bwisi') --> "tlj" .
iana('Taloki') --> "tlk" .
iana('Tetela') --> "tll" .
iana('Tolomako') --> "tlm" .
iana('Talondo\'') --> "tln" .
iana('Talodi') --> "tlo" .
iana('Filomena Mata-Coahuitlán Totonac') --> "tlp" .
iana('Tai Loi') --> "tlq" .
iana('Talise') --> "tlr" .
iana('Tambotalo') --> "tls" .
iana('Teluti') --> "tlt" .
iana('Tulehu') --> "tlu" .
iana('Taliabu') --> "tlv" .
iana('South Wemale') --> "tlw" .
iana('Khehek') --> "tlx" .
iana('Talysh') --> "tly" .
iana('Tama (Chad)') --> "tma" .
iana('Katbol') --> "tmb" .
iana('Tumak') --> "tmc" .
iana('Haruai') --> "tmd" .
iana('Tremembé') --> "tme" .
iana('Toba-Maskoy') --> "tmf" .
iana('Ternateño') --> "tmg" .
iana('Tamashek') --> "tmh" .
iana('Tutuba') --> "tmi" .
iana('Samarokena') --> "tmj" .
iana('Northwestern Tamang') --> "tmk" .
iana('Tamnim Citak') --> "tml" .
iana('Tai Thanh') --> "tmm" .
iana('Taman (Indonesia)') --> "tmn" .
iana('Temoq') --> "tmo" .
iana('Tai Mène') --> "tmp" .
iana('Tumleo') --> "tmq" .
iana('Jewish Babylonian Aramaic (ca. 200-1200 CE)') --> "tmr" .
iana('Tima') --> "tms" .
iana('Tasmate') --> "tmt" .
iana('Iau') --> "tmu" .
iana('Tembo (Motembo)') --> "tmv" .
iana('Temuan') --> "tmw" .
iana('Tami') --> "tmy" .
iana('Tamanaku') --> "tmz" .
iana('Tacana') --> "tna" .
iana('Western Tunebo') --> "tnb" .
iana('Tanimuca-Retuarã') --> "tnc" .
iana('Angosturas Tunebo') --> "tnd" .
iana('Tinoc Kallahan') --> "tne" .
iana('Tangshewi') --> "tnf" .
iana('Tobanga') --> "tng" .
iana('Maiani') --> "tnh" .
iana('Tandia') --> "tni" .
iana('Kwamera') --> "tnk" .
iana('Lenakel') --> "tnl" .
iana('Tabla') --> "tnm" .
iana('North Tanna') --> "tnn" .
iana('Toromono') --> "tno" .
iana('Whitesands') --> "tnp" .
iana('Taino') --> "tnq" .
iana('Ménik') --> "tnr" .
iana('Tenis') --> "tns" .
iana('Tontemboan') --> "tnt" .
iana('Tay Khang') --> "tnu" .
iana('Tangchangya') --> "tnv" .
iana('Tonsawang') --> "tnw" .
iana('Tanema') --> "tnx" .
iana('Tongwe') --> "tny" .
iana('Tonga (Thailand)') --> "tnz" .
iana('Toba') --> "tob" .
iana('Coyutla Totonac') --> "toc" .
iana('Toma') --> "tod" .
iana('Tomedes') --> "toe" .
iana('Gizrra') --> "tof" .
iana('Tonga (Nyasa)') --> "tog" .
iana('Gitonga') --> "toh" .
iana('Tonga (Zambia)') --> "toi" .
iana('Tojolabal') --> "toj" .
iana('Tolowa') --> "tol" .
iana('Tombulu') --> "tom" .
iana('Xicotepec De Juárez Totonac') --> "too" .
iana('Papantla Totonac') --> "top" .
iana('Toposa') --> "toq" .
iana('Togbo-Vara Banda') --> "tor" .
iana('Highland Totonac') --> "tos" .
iana('Tho') --> "tou" .
iana('Upper Taromi') --> "tov" .
iana('Jemez') --> "tow" .
iana('Tobian') --> "tox" .
iana('Topoiyo') --> "toy" .
iana('To') --> "toz" .
iana('Taupota') --> "tpa" .
iana('Azoyú Me\'phaa') --> "tpc" .
iana('Tippera') --> "tpe" .
iana('Tarpia') --> "tpf" .
iana('Kula') --> "tpg" .
iana('Tok Pisin') --> "tpi" .
iana('Tapieté') --> "tpj" .
iana('Tupinikin') --> "tpk" .
iana('Tlacoapa Me\'phaa') --> "tpl" .
iana('Tampulma') --> "tpm" .
iana('Tupinambá') --> "tpn" .
iana('Tai Pao') --> "tpo" .
iana('Pisaflores Tepehua') --> "tpp" .
iana('Tukpa') --> "tpq" .
iana('Tuparí') --> "tpr" .
iana('Tlachichilco Tepehua') --> "tpt" .
iana('Tampuan') --> "tpu" .
iana('Tanapag') --> "tpv" .
iana('Tupí') --> "tpw" .
iana('Acatepec Me\'phaa') --> "tpx" .
iana('Trumai') --> "tpy" .
iana('Tinputz') --> "tpz" .
iana('Tembé') --> "tqb" .
iana('Lehali') --> "tql" .
iana('Turumsa') --> "tqm" .
iana('Tenino') --> "tqn" .
iana('Toaripi') --> "tqo" .
iana('Tomoip') --> "tqp" .
iana('Tunni') --> "tqq" .
iana('Torona') --> "tqr" .
iana('Western Totonac') --> "tqt" .
iana('Touo') --> "tqu" .
iana('Tonkawa') --> "tqw" .
iana('Tirahi') --> "tra" .
iana('Terebu') --> "trb" .
iana('Copala Triqui') --> "trc" .
iana('Turi') --> "trd" .
iana('East Tarangan') --> "tre" .
iana('Trinidadian Creole English') --> "trf" .
iana('Lishán Didán') --> "trg" .
iana('Turaka') --> "trh" .
iana('Trió') --> "tri" .
iana('Toram') --> "trj" .
iana('Turkic languages') --> "trk" .
iana('Traveller Scottish') --> "trl" .
iana('Tregami') --> "trm" .
iana('Trinitario') --> "trn" .
iana('Tarao Naga') --> "tro" .
iana('Kok Borok') --> "trp" .
iana('San Martín Itunyoso Triqui') --> "trq" .
iana('Taushiro') --> "trr" .
iana('Chicahuaxtla Triqui') --> "trs" .
iana('Tunggare') --> "trt" .
iana('Turoyo') --> "tru" .
iana('Taroko') --> "trv" .
iana('Torwali') --> "trw" .
iana('Tringgus-Sembaan Bidayuh') --> "trx" .
iana('Turung') --> "try" .
iana('Torá') --> "trz" .
iana('Tsaangi') --> "tsa" .
iana('Tsamai') --> "tsb" .
iana('Tswa') --> "tsc" .
iana('Tsakonian') --> "tsd" .
iana('Tunisian Sign Language') --> "tse" .
iana('Southwestern Tamang') --> "tsf" .
iana('Tausug') --> "tsg" .
iana('Tsuvan') --> "tsh" .
iana('Tsimshian') --> "tsi" .
iana('Tshangla') --> "tsj" .
iana('Tseku') --> "tsk" .
iana('Ts\'ün-Lao') --> "tsl" .
iana('Turkish Sign Language') --> "tsm" .
iana('Northern Toussian') --> "tsp" .
iana('Thai Sign Language') --> "tsq" .
iana('Akei') --> "tsr" .
iana('Taiwan Sign Language') --> "tss" .
iana('Tondi Songway Kiini') --> "tst" .
iana('Tsou') --> "tsu" .
iana('Tsogo') --> "tsv" .
iana('Tsishingini') --> "tsw" .
iana('Mubami') --> "tsx" .
iana('Tebul Sign Language') --> "tsy" .
iana('Purepecha') --> "tsz" .
iana('Tutelo') --> "tta" .
iana('Gaa') --> "ttb" .
iana('Tektiteko') --> "ttc" .
iana('Tauade') --> "ttd" .
iana('Bwanabwana') --> "tte" .
iana('Tuotomb') --> "ttf" .
iana('Tutong') --> "ttg" .
iana('Upper Ta\'oih') --> "tth" .
iana('Tobati') --> "tti" .
iana('Tooro') --> "ttj" .
iana('Totoro') --> "ttk" .
iana('Totela') --> "ttl" .
iana('Northern Tutchone') --> "ttm" .
iana('Towei') --> "ttn" .
iana('Lower Ta\'oih') --> "tto" .
iana('Tombelala') --> "ttp" .
iana('Tawallammat Tamajaq') --> "ttq" .
iana('Tera') --> "ttr" .
iana('Northeastern Thai') --> "tts" .
iana('Muslim Tat') --> "ttt" .
iana('Torau') --> "ttu" .
iana('Titan') --> "ttv" .
iana('Long Wat') --> "ttw" .
iana('Sikaritai') --> "tty" .
iana('Tsum') --> "ttz" .
iana('Wiarumus') --> "tua" .
iana('Tübatulabal') --> "tub" .
iana('Mutu') --> "tuc" .
iana('Tuxá') --> "tud" .
iana('Tuyuca') --> "tue" .
iana('Central Tunebo') --> "tuf" .
iana('Tunia') --> "tug" .
iana('Taulil') --> "tuh" .
iana('Tupuri') --> "tui" .
iana('Tugutil') --> "tuj" .
iana('Tula') --> "tul" .
iana('Tumbuka') --> "tum" .
iana('Tunica') --> "tun" .
iana('Tucano') --> "tuo" .
iana('Tupi languages') --> "tup" .
iana('Tedaga') --> "tuq" .
iana('Tuscarora') --> "tus" .
iana('Altaic languages') --> "tut" .
iana('Tututni') --> "tuu" .
iana('Turkana') --> "tuv" .
iana('Tungus languages') --> "tuw" .
iana('Tuxináwa') --> "tux" .
iana('Tugen') --> "tuy" .
iana('Turka') --> "tuz" .
iana('Vaghua') --> "tva" .
iana('Tsuvadi') --> "tvd" .
iana('Te\'un') --> "tve" .
iana('Southeast Ambrym') --> "tvk" .
iana('Tuvalu') --> "tvl" .
iana('Tela-Masbuar') --> "tvm" .
iana('Tavoyan') --> "tvn" .
iana('Tidore') --> "tvo" .
iana('Taveta') --> "tvs" .
iana('Tutsa Naga') --> "tvt" .
iana('Tunen') --> "tvu" .
iana('Sedoa') --> "tvw" .
iana('Timor Pidgin') --> "tvy" .
iana('Twana') --> "twa" .
iana('Western Tawbuid') --> "twb" .
iana('Teshenawa') --> "twc" .
iana('Twents') --> "twd" .
iana('Tewa (Indonesia)') --> "twe" .
iana('Northern Tiwa') --> "twf" .
iana('Tereweng') --> "twg" .
iana('Tai Dón') --> "twh" .
iana('Tawara') --> "twl" .
iana('Tawang Monpa') --> "twm" .
iana('Twendi') --> "twn" .
iana('Tswapong') --> "two" .
iana('Ere') --> "twp" .
iana('Tasawaq') --> "twq" .
iana('Southwestern Tarahumara') --> "twr" .
iana('Turiwára') --> "twt" .
iana('Termanu') --> "twu" .
iana('Tuwari') --> "tww" .
iana('Tewe') --> "twx" .
iana('Tawoyan') --> "twy" .
iana('Tombonuo') --> "txa" .
iana('Tokharian B') --> "txb" .
iana('Tsetsaut') --> "txc" .
iana('Totoli') --> "txe" .
iana('Tangut') --> "txg" .
iana('Thracian') --> "txh" .
iana('Ikpeng') --> "txi" .
iana('Tarjumo') --> "txj" .
iana('Tomini') --> "txm" .
iana('West Tarangan') --> "txn" .
iana('Toto') --> "txo" .
iana('Tii') --> "txq" .
iana('Tartessian') --> "txr" .
iana('Tonsea') --> "txs" .
iana('Citak') --> "txt" .
iana('Kayapó') --> "txu" .
iana('Tatana') --> "txx" .
iana('Tanosy Malagasy') --> "txy" .
iana('Tauya') --> "tya" .
iana('Kyanga') --> "tye" .
iana('O\'du') --> "tyh" .
iana('Teke-Tsaayi') --> "tyi" .
iana('Tai Do') --> "tyj" .
iana('Thu Lao') --> "tyl" .
iana('Kombai') --> "tyn" .
iana('Thaypan') --> "typ" .
iana('Tai Daeng') --> "tyr" .
iana('Tày Sa Pa') --> "tys" .
iana('Tày Tac') --> "tyt" .
iana('Kua') --> "tyu" .
iana('Tuvinian') --> "tyv" .
iana('Teke-Tyee') --> "tyx" .
iana('Tày') --> "tyz" .
iana('Tanzanian Sign Language') --> "tza" .
iana('Tzeltal') --> "tzh" .
iana('Tz\'utujil') --> "tzj" .
iana('Talossan') --> "tzl" .
iana('Central Atlas Tamazight') --> "tzm" .
iana('Tugun') --> "tzn" .
iana('Tzotzil') --> "tzo" .
iana('Tabriak') --> "tzx" .
iana('Uamué') --> "uam" .
iana('Kuan') --> "uan" .
iana('Tairuma') --> "uar" .
iana('Ubang') --> "uba" .
iana('Ubi') --> "ubi" .
iana('Buhi\'non Bikol') --> "ubl" .
iana('Ubir') --> "ubr" .
iana('Umbu-Ungu') --> "ubu" .
iana('Ubykh') --> "uby" .
iana('Uda') --> "uda" .
iana('Udihe') --> "ude" .
iana('Muduga') --> "udg" .
iana('Udi') --> "udi" .
iana('Ujir') --> "udj" .
iana('Wuzlam') --> "udl" .
iana('Udmurt') --> "udm" .
iana('Uduk') --> "udu" .
iana('Kioko') --> "ues" .
iana('Ufim') --> "ufi" .
iana('Ugaritic') --> "uga" .
iana('Kuku-Ugbanh') --> "ugb" .
iana('Ughele') --> "uge" .
iana('Ugandan Sign Language') --> "ugn" .
iana('Ugong') --> "ugo" .
iana('Uruguayan Sign Language') --> "ugy" .
iana('Uhami') --> "uha" .
iana('Damal') --> "uhn" .
iana('Uisai') --> "uis" .
iana('Iyive') --> "uiv" .
iana('Tanjijili') --> "uji" .
iana('Kaburi') --> "uka" .
iana('Ukuriguma') --> "ukg" .
iana('Ukhwejo') --> "ukh" .
iana('Ukrainian Sign Language') --> "ukl" .
iana('Ukpe-Bayobiri') --> "ukp" .
iana('Ukwa') --> "ukq" .
iana('Urubú-Kaapor Sign Language') --> "uks" .
iana('Ukue') --> "uku" .
iana('Ukwuani-Aboh-Ndoni') --> "ukw" .
iana('Kuuk-Yak') --> "uky" .
iana('Fungwa') --> "ula" .
iana('Ulukwumi') --> "ulb" .
iana('Ulch') --> "ulc" .
iana('Lule') --> "ule" .
iana('Usku') --> "ulf" .
iana('Ulithian') --> "uli" .
iana('Meriam') --> "ulk" .
iana('Ullatan') --> "ull" .
iana('Ulumanda\'') --> "ulm" .
iana('Unserdeutsch') --> "uln" .
iana('Uma\' Lung') --> "ulu" .
iana('Ulwa') --> "ulw" .
iana('Umatilla') --> "uma" .
iana('Umbundu') --> "umb" .
iana('Marrucinian') --> "umc" .
iana('Umbindhamu') --> "umd" .
iana('Umbuygamu') --> "umg" .
iana('Ukit') --> "umi" .
iana('Umon') --> "umm" .
iana('Makyan Naga') --> "umn" .
iana('Umotína') --> "umo" .
iana('Umpila') --> "ump" .
iana('Umbugarla') --> "umr" .
iana('Pendau') --> "ums" .
iana('Munsee') --> "umu" .
iana('North Watut') --> "una" .
iana('Undetermined') --> "und" .
iana('Uneme') --> "une" .
iana('Ngarinyin') --> "ung" .
iana('Enawené-Nawé') --> "unk" .
iana('Unami') --> "unm" .
iana('Kurnai') --> "unn" .
iana('Worora') --> "unp" .
iana('Mundari') --> "unr" .
iana('Unubahe') --> "unu" .
iana('Munda') --> "unx" .
iana('Unde Kaili') --> "unz" .
iana('Uokha') --> "uok" .
iana('Umeda') --> "upi" .
iana('Uripiv-Wala-Rano-Atchin') --> "upv" .
iana('Urarina') --> "ura" .
iana('Urubú-Kaapor') --> "urb" .
iana('Urningangg') --> "urc" .
iana('Uru') --> "ure" .
iana('Uradhi') --> "urf" .
iana('Urigina') --> "urg" .
iana('Urhobo') --> "urh" .
iana('Urim') --> "uri" .
iana('Uralic languages') --> "urj" .
iana('Urak Lawoi\'') --> "urk" .
iana('Urali') --> "url" .
iana('Urapmin') --> "urm" .
iana('Uruangnirin') --> "urn" .
iana('Ura (Papua New Guinea)') --> "uro" .
iana('Uru-Pa-In') --> "urp" .
iana('Lehalurup') --> "urr" .
iana('Urat') --> "urt" .
iana('Urumi') --> "uru" .
iana('Uruava') --> "urv" .
iana('Sop') --> "urw" .
iana('Urimo') --> "urx" .
iana('Orya') --> "ury" .
iana('Uru-Eu-Wau-Wau') --> "urz" .
iana('Usarufa') --> "usa" .
iana('Ushojo') --> "ush" .
iana('Usui') --> "usi" .
iana('Usaghade') --> "usk" .
iana('Uspanteco') --> "usp" .
iana('Uya') --> "usu" .
iana('Otank') --> "uta" .
iana('Ute-Southern Paiute') --> "ute" .
iana('Amba (Solomon Islands)') --> "utp" .
iana('Etulo') --> "utr" .
iana('Utu') --> "utu" .
iana('Urum') --> "uum" .
iana('Kulon-Pazeh') --> "uun" .
iana('Ura (Vanuatu)') --> "uur" .
iana('U') --> "uuu" .
iana('West Uvean') --> "uve" .
iana('Uri') --> "uvh" .
iana('Lote') --> "uvl" .
iana('Kuku-Uwanh') --> "uwa" .
iana('Doko-Uyanga') --> "uya" .
iana('Northern Uzbek') --> "uzn" .
iana('Southern Uzbek') --> "uzs" .
iana('Vaagri Booli') --> "vaa" .
iana('Vale') --> "vae" .
iana('Vafsi') --> "vaf" .
iana('Vagla') --> "vag" .
iana('Varhadi-Nagpuri') --> "vah" .
iana('Vai') --> "vai" .
iana('Sekele') --> "vaj" .
iana('Vehes') --> "val" .
iana('Vanimo') --> "vam" .
iana('Valman') --> "van" .
iana('Vao') --> "vao" .
iana('Vaiphei') --> "vap" .
iana('Huarijio') --> "var" .
iana('Vasavi') --> "vas" .
iana('Vanuma') --> "vau" .
iana('Varli') --> "vav" .
iana('Wayu') --> "vay" .
iana('Southeast Babar') --> "vbb" .
iana('Southwestern Bontok') --> "vbk" .
iana('Venetian') --> "vec" .
iana('Veddah') --> "ved" .
iana('Veluws') --> "vel" .
iana('Vemgo-Mabas') --> "vem" .
iana('Ventureño') --> "veo" .
iana('Veps') --> "vep" .
iana('Mom Jango') --> "ver" .
iana('Vaghri') --> "vgr" .
iana('Vlaamse Gebarentaal') --> "vgt" .
iana('Virgin Islands Creole English') --> "vic" .
iana('Vidunda') --> "vid" .
iana('Vili') --> "vif" .
iana('Viemo') --> "vig" .
iana('Vilela') --> "vil" .
iana('Vinza') --> "vin" .
iana('Vishavan') --> "vis" .
iana('Viti') --> "vit" .
iana('Iduna') --> "viv" .
iana('Kariyarra') --> "vka" .
iana('Ija-Zuba') --> "vki" .
iana('Kujarge') --> "vkj" .
iana('Kaur') --> "vkk" .
iana('Kulisusu') --> "vkl" .
iana('Kamakan') --> "vkm" .
iana('Kodeoha') --> "vko" .
iana('Korlai Creole Portuguese') --> "vkp" .
iana('Tenggarong Kutai Malay') --> "vkt" .
iana('Kurrama') --> "vku" .
iana('Valpei') --> "vlp" .
iana('Vlaams') --> "vls" .
iana('Martuyhunira') --> "vma" .
iana('Barbaram') --> "vmb" .
iana('Juxtlahuaca Mixtec') --> "vmc" .
iana('Mudu Koraga') --> "vmd" .
iana('East Masela') --> "vme" .
iana('Mainfränkisch') --> "vmf" .
iana('Lungalunga') --> "vmg" .
iana('Maraghei') --> "vmh" .
iana('Miwa') --> "vmi" .
iana('Ixtayutla Mixtec') --> "vmj" .
iana('Makhuwa-Shirima') --> "vmk" .
iana('Malgana') --> "vml" .
iana('Mitlatongo Mixtec') --> "vmm" .
iana('Soyaltepec Mazatec') --> "vmp" .
iana('Soyaltepec Mixtec') --> "vmq" .
iana('Marenje') --> "vmr" .
iana('Moksela') --> "vms" .
iana('Muluridyi') --> "vmu" .
iana('Valley Maidu') --> "vmv" .
iana('Makhuwa') --> "vmw" .
iana('Tamazola Mixtec') --> "vmx" .
iana('Ayautla Mazatec') --> "vmy" .
iana('Mazatlán Mazatec') --> "vmz" .
iana('Vano') --> "vnk" .
iana('Vinmavis') --> "vnm" .
iana('Vunapu') --> "vnp" .
iana('Voro') --> "vor" .
iana('Votic') --> "vot" .
iana('Vera\'a') --> "vra" .
iana('Võro') --> "vro" .
iana('Varisi') --> "vrs" .
iana('Burmbar') --> "vrt" .
iana('Moldova Sign Language') --> "vsi" .
iana('Venezuelan Sign Language') --> "vsl" .
iana('Valencian Sign Language') --> "vsv" .
iana('Vitou') --> "vto" .
iana('Vumbu') --> "vum" .
iana('Vunjo') --> "vun" .
iana('Vute') --> "vut" .
iana('Awa (China)') --> "vwa" .
iana('Walla Walla') --> "waa" .
iana('Wab') --> "wab" .
iana('Wasco-Wishram') --> "wac" .
iana('Wandamen') --> "wad" .
iana('Walser') --> "wae" .
iana('Wakoná') --> "waf" .
iana('Wa\'ema') --> "wag" .
iana('Watubela') --> "wah" .
iana('Wares') --> "wai" .
iana('Waffa') --> "waj" .
iana('Wakashan languages') --> "wak" .
iana('Wolaytta') --> "wal" .
iana('Wampanoag') --> "wam" .
iana('Wan') --> "wan" .
iana('Wappo') --> "wao" .
iana('Wapishana') --> "wap" .
iana('Wageman') --> "waq" .
iana('Waray (Philippines)') --> "war" .
iana('Washo') --> "was" .
iana('Kaninuwa') --> "wat" .
iana('Waurá') --> "wau" .
iana('Waka') --> "wav" .
iana('Waiwai') --> "waw" .
iana('Watam') --> "wax" .
iana('Wayana') --> "way" .
iana('Wampur') --> "waz" .
iana('Warao') --> "wba" .
iana('Wabo') --> "wbb" .
iana('Waritai') --> "wbe" .
iana('Wara') --> "wbf" .
iana('Wanda') --> "wbh" .
iana('Vwanji') --> "wbi" .
iana('Alagwa') --> "wbj" .
iana('Waigali') --> "wbk" .
iana('Wakhi') --> "wbl" .
iana('Wa') --> "wbm" .
iana('Warlpiri') --> "wbp" .
iana('Waddar') --> "wbq" .
iana('Wagdi') --> "wbr" .
iana('Wanman') --> "wbt" .
iana('Wajarri') --> "wbv" .
iana('Woi') --> "wbw" .
iana('Yanomámi') --> "wca" .
iana('Waci Gbe') --> "wci" .
iana('Wandji') --> "wdd" .
iana('Wadaginam') --> "wdg" .
iana('Wadjiginy') --> "wdj" .
iana('Wadikali') --> "wdk" .
iana('Wadjigu') --> "wdu" .
iana('Wadjabangayi') --> "wdy" .
iana('Wewaw') --> "wea" .
iana('Wè Western') --> "wec" .
iana('Wedau') --> "wed" .
iana('Wergaia') --> "weg" .
iana('Weh') --> "weh" .
iana('Kiunum') --> "wei" .
iana('Weme Gbe') --> "wem" .
iana('Sorbian languages') --> "wen" .
iana('Wemale') --> "weo" .
iana('Westphalien') --> "wep" .
iana('Weri') --> "wer" .
iana('Cameroon Pidgin') --> "wes" .
iana('Perai') --> "wet" .
iana('Rawngtu Chin') --> "weu" .
iana('Wejewa') --> "wew" .
iana('Yafi') --> "wfg" .
iana('Wagaya') --> "wga" .
iana('Wagawaga') --> "wgb" .
iana('Wangganguru') --> "wgg" .
iana('Wahgi') --> "wgi" .
iana('Waigeo') --> "wgo" .
iana('Wirangu') --> "wgu" .
iana('Wagawaga') --> "wgw" .
iana('Warrgamay') --> "wgy" .
iana('Manusela') --> "wha" .
iana('North Wahgi') --> "whg" .
iana('Wahau Kenyah') --> "whk" .
iana('Wahau Kayan') --> "whu" .
iana('Southern Toussian') --> "wib" .
iana('Wichita') --> "wic" .
iana('Wik-Epa') --> "wie" .
iana('Wik-Keyangan') --> "wif" .
iana('Wik-Ngathana') --> "wig" .
iana('Wik-Me\'anha') --> "wih" .
iana('Minidien') --> "wii" .
iana('Wik-Iiyanh') --> "wij" .
iana('Wikalkan') --> "wik" .
iana('Wilawila') --> "wil" .
iana('Wik-Mungkan') --> "wim" .
iana('Ho-Chunk') --> "win" .
iana('Wiraféd') --> "wir" .
iana('Wintu') --> "wit" .
iana('Wiru') --> "wiu" .
iana('Vitu') --> "wiv" .
iana('Wirangu') --> "wiw" .
iana('Wiyot') --> "wiy" .
iana('Waja') --> "wja" .
iana('Warji') --> "wji" .
iana('Kw\'adza') --> "wka" .
iana('Kumbaran') --> "wkb" .
iana('Wakde') --> "wkd" .
iana('Kalanadi') --> "wkl" .
iana('Kunduvadi') --> "wku" .
iana('Wakawaka') --> "wkw" .
iana('Wangkayutyuru') --> "wky" .
iana('Walio') --> "wla" .
iana('Mwali Comorian') --> "wlc" .
iana('Wolane') --> "wle" .
iana('Kunbarlang') --> "wlg" .
iana('Waioli') --> "wli" .
iana('Wailaki') --> "wlk" .
iana('Wali (Sudan)') --> "wll" .
iana('Middle Welsh') --> "wlm" .
iana('Wolio') --> "wlo" .
iana('Wailapa') --> "wlr" .
iana('Wallisian') --> "wls" .
iana('Wuliwuli') --> "wlu" .
iana('Wichí Lhamtés Vejoz') --> "wlv" .
iana('Walak') --> "wlw" .
iana('Wali (Ghana)') --> "wlx" .
iana('Waling') --> "wly" .
iana('Mawa (Nigeria)') --> "wma" .
iana('Wambaya') --> "wmb" .
iana('Wamas') --> "wmc" .
iana('Mamaindé') --> "wmd" .
iana('Wambule') --> "wme" .
iana('Waima\'a') --> "wmh" .
iana('Wamin') --> "wmi" .
iana('Maiwa (Indonesia)') --> "wmm" .
iana('Waamwang') --> "wmn" .
iana('Wom (Papua New Guinea)') --> "wmo" .
iana('Wambon') --> "wms" .
iana('Walmajarri') --> "wmt" .
iana('Mwani') --> "wmw" .
iana('Womo') --> "wmx" .
iana('Wanambre') --> "wnb" .
iana('Wantoat') --> "wnc" .
iana('Wandarang') --> "wnd" .
iana('Waneci') --> "wne" .
iana('Wanggom') --> "wng" .
iana('Ndzwani Comorian') --> "wni" .
iana('Wanukaka') --> "wnk" .
iana('Wanggamala') --> "wnm" .
iana('Wunumara') --> "wnn" .
iana('Wano') --> "wno" .
iana('Wanap') --> "wnp" .
iana('Usan') --> "wnu" .
iana('Wintu') --> "wnw" .
iana('Wanyi') --> "wny" .
iana('Tyaraity') --> "woa" .
iana('Wè Northern') --> "wob" .
iana('Wogeo') --> "woc" .
iana('Wolani') --> "wod" .
iana('Woleaian') --> "woe" .
iana('Gambian Wolof') --> "wof" .
iana('Wogamusin') --> "wog" .
iana('Kamang') --> "woi" .
iana('Longto') --> "wok" .
iana('Wom (Nigeria)') --> "wom" .
iana('Wongo') --> "won" .
iana('Manombai') --> "woo" .
iana('Woria') --> "wor" .
iana('Hanga Hundi') --> "wos" .
iana('Wawonii') --> "wow" .
iana('Weyto') --> "woy" .
iana('Maco') --> "wpc" .
iana('Warapu') --> "wra" .
iana('Warluwara') --> "wrb" .
iana('Warduji') --> "wrd" .
iana('Warungu') --> "wrg" .
iana('Wiradhuri') --> "wrh" .
iana('Wariyangga') --> "wri" .
iana('Garrwa') --> "wrk" .
iana('Warlmanpa') --> "wrl" .
iana('Warumungu') --> "wrm" .
iana('Warnang') --> "wrn" .
iana('Worrorra') --> "wro" .
iana('Waropen') --> "wrp" .
iana('Wardaman') --> "wrr" .
iana('Waris') --> "wrs" .
iana('Waru') --> "wru" .
iana('Waruna') --> "wrv" .
iana('Gugu Warra') --> "wrw" .
iana('Wae Rana') --> "wrx" .
iana('Merwari') --> "wry" .
iana('Waray (Australia)') --> "wrz" .
iana('Warembori') --> "wsa" .
iana('Wusi') --> "wsi" .
iana('Waskia') --> "wsk" .
iana('Owenia') --> "wsr" .
iana('Wasa') --> "wss" .
iana('Wasu') --> "wsu" .
iana('Wotapuri-Katarqalai') --> "wsv" .
iana('Watiwa') --> "wtf" .
iana('Wathawurrung') --> "wth" .
iana('Berta') --> "wti" .
iana('Watakataui') --> "wtk" .
iana('Mewati') --> "wtm" .
iana('Wotu') --> "wtw" .
iana('Wikngenchera') --> "wua" .
iana('Wunambal') --> "wub" .
iana('Wudu') --> "wud" .
iana('Wutunhua') --> "wuh" .
iana('Silimo') --> "wul" .
iana('Wumbvu') --> "wum" .
iana('Bungu') --> "wun" .
iana('Wurrugu') --> "wur" .
iana('Wutung') --> "wut" .
iana('Wu Chinese') --> "wuu" .
iana('Wuvulu-Aua') --> "wuv" .
iana('Wulna') --> "wux" .
iana('Wauyai') --> "wuy" .
iana('Waama') --> "wwa" .
iana('Wakabunga') --> "wwb" .
iana('Wetamut') --> "wwo" .
iana('Warrwa') --> "wwr" .
iana('Wawa') --> "www" .
iana('Waxianghua') --> "wxa" .
iana('Wardandi') --> "wxw" .
iana('Wyandot') --> "wya" .
iana('Wangaaybuwan-Ngiyambaa') --> "wyb" .
iana('Woiwurrung') --> "wyi" .
iana('Wymysorys') --> "wym" .
iana('Wayoró') --> "wyr" .
iana('Western Fijian') --> "wyy" .
iana('Andalusian Arabic') --> "xaa" .
iana('Sambe') --> "xab" .
iana('Kachari') --> "xac" .
iana('Adai') --> "xad" .
iana('Aequian') --> "xae" .
iana('Aghwan') --> "xag" .
iana('Kaimbé') --> "xai" .
iana('Ararandewára') --> "xaj" .
iana('Kalmyk') --> "xal" .
iana('/Xam') --> "xam" .
iana('Xamtanga') --> "xan" .
iana('Khao') --> "xao" .
iana('Apalachee') --> "xap" .
iana('Aquitanian') --> "xaq" .
iana('Karami') --> "xar" .
iana('Kamas') --> "xas" .
iana('Katawixi') --> "xat" .
iana('Kauwera') --> "xau" .
iana('Xavánte') --> "xav" .
iana('Kawaiisu') --> "xaw" .
iana('Kayan Mahakam') --> "xay" .
iana('Kamba (Brazil)') --> "xba" .
iana('Lower Burdekin') --> "xbb" .
iana('Bactrian') --> "xbc" .
iana('Bindal') --> "xbd" .
iana('Bigambal') --> "xbe" .
iana('Bunganditj') --> "xbg" .
iana('Kombio') --> "xbi" .
iana('Birrpayi') --> "xbj" .
iana('Middle Breton') --> "xbm" .
iana('Kenaboi') --> "xbn" .
iana('Bolgarian') --> "xbo" .
iana('Bibbulman') --> "xbp" .
iana('Kambera') --> "xbr" .
iana('Kambiwá') --> "xbw" .
iana('Kabixí') --> "xbx" .
iana('Batyala') --> "xby" .
iana('Cumbric') --> "xcb" .
iana('Camunic') --> "xcc" .
iana('Celtiberian') --> "xce" .
iana('Cisalpine Gaulish') --> "xcg" .
iana('Chemakum') --> "xch" .
iana('Classical Armenian') --> "xcl" .
iana('Comecrudo') --> "xcm" .
iana('Cotoname') --> "xcn" .
iana('Chorasmian') --> "xco" .
iana('Carian') --> "xcr" .
iana('Classical Tibetan') --> "xct" .
iana('Curonian') --> "xcu" .
iana('Chuvantsy') --> "xcv" .
iana('Coahuilteco') --> "xcw" .
iana('Cayuse') --> "xcy" .
iana('Darkinyung') --> "xda" .
iana('Dacian') --> "xdc" .
iana('Dharuk') --> "xdk" .
iana('Edomite') --> "xdm" .
iana('Malayic Dayak') --> "xdy" .
iana('Eblan') --> "xeb" .
iana('Hdi') --> "xed" .
iana('//Xegwi') --> "xeg" .
iana('Kelo') --> "xel" .
iana('Kembayan') --> "xem" .
iana('Epi-Olmec') --> "xep" .
iana('Xerénte') --> "xer" .
iana('Kesawai') --> "xes" .
iana('Xetá') --> "xet" .
iana('Keoru-Ahia') --> "xeu" .
iana('Faliscan') --> "xfa" .
iana('Galatian') --> "xga" .
iana('Gbin') --> "xgb" .
iana('Gudang') --> "xgd" .
iana('Gabrielino-Fernandeño') --> "xgf" .
iana('Goreng') --> "xgg" .
iana('Garingbal') --> "xgi" .
iana('Galindan') --> "xgl" .
iana('Dharumbal') --> "xgm" .
iana('Mongolian languages') --> "xgn" .
iana('Garza') --> "xgr" .
iana('Unggumi') --> "xgu" .
iana('Guwa') --> "xgw" .
iana('Harami') --> "xha" .
iana('Hunnic') --> "xhc" .
iana('Hadrami') --> "xhd" .
iana('Khetrani') --> "xhe" .
iana('Hernican') --> "xhr" .
iana('Hattic') --> "xht" .
iana('Hurrian') --> "xhu" .
iana('Khua') --> "xhv" .
iana('Xiandao') --> "xia" .
iana('Iberian') --> "xib" .
iana('Xiri') --> "xii" .
iana('Illyrian') --> "xil" .
iana('Xinca') --> "xin" .
iana('Xipináwa') --> "xip" .
iana('Xiriâna') --> "xir" .
iana('Kisan') --> "xis" .
iana('Indus Valley Language') --> "xiv" .
iana('Xipaya') --> "xiy" .
iana('Minjungbal') --> "xjb" .
iana('Jaitmatang') --> "xjt" .
iana('Kalkoti') --> "xka" .
iana('Northern Nago') --> "xkb" .
iana('Kho\'ini') --> "xkc" .
iana('Mendalam Kayan') --> "xkd" .
iana('Kereho') --> "xke" .
iana('Khengkha') --> "xkf" .
iana('Kagoro') --> "xkg" .
iana('Karahawyana') --> "xkh" .
iana('Kenyan Sign Language') --> "xki" .
iana('Kajali') --> "xkj" .
iana('Kaco\'') --> "xkk" .
iana('Mainstream Kenyah') --> "xkl" .
iana('Kayan River Kayan') --> "xkn" .
iana('Kiorr') --> "xko" .
iana('Kabatei') --> "xkp" .
iana('Koroni') --> "xkq" .
iana('Xakriabá') --> "xkr" .
iana('Kumbewaha') --> "xks" .
iana('Kantosi') --> "xkt" .
iana('Kaamba') --> "xku" .
iana('Kgalagadi') --> "xkv" .
iana('Kembra') --> "xkw" .
iana('Karore') --> "xkx" .
iana('Uma\' Lasan') --> "xky" .
iana('Kurtokha') --> "xkz" .
iana('Kamula') --> "xla" .
iana('Loup B') --> "xlb" .
iana('Lycian') --> "xlc" .
iana('Lydian') --> "xld" .
iana('Lemnian') --> "xle" .
iana('Ligurian (Ancient)') --> "xlg" .
iana('Liburnian') --> "xli" .
iana('Alanic') --> "xln" .
iana('Loup A') --> "xlo" .
iana('Lepontic') --> "xlp" .
iana('Lusitanian') --> "xls" .
iana('Cuneiform Luwian') --> "xlu" .
iana('Elymian') --> "xly" .
iana('Mushungulu') --> "xma" .
iana('Mbonga') --> "xmb" .
iana('Makhuwa-Marrevone') --> "xmc" .
iana('Mbudum') --> "xmd" .
iana('Median') --> "xme" .
iana('Mingrelian') --> "xmf" .
iana('Mengaka') --> "xmg" .
iana('Kuku-Muminh') --> "xmh" .
iana('Majera') --> "xmj" .
iana('Ancient Macedonian') --> "xmk" .
iana('Malaysian Sign Language') --> "xml" .
iana('Manado Malay') --> "xmm" .
iana('Manichaean Middle Persian') --> "xmn" .
iana('Morerebi') --> "xmo" .
iana('Kuku-Mu\'inh') --> "xmp" .
iana('Kuku-Mangk') --> "xmq" .
iana('Meroitic') --> "xmr" .
iana('Moroccan Sign Language') --> "xms" .
iana('Matbat') --> "xmt" .
iana('Kamu') --> "xmu" .
iana('Antankarana Malagasy') --> "xmv" .
iana('Tsimihety Malagasy') --> "xmw" .
iana('Maden') --> "xmx" .
iana('Mayaguduna') --> "xmy" .
iana('Mori Bawah') --> "xmz" .
iana('Ancient North Arabian') --> "xna" .
iana('Kanakanabu') --> "xnb" .
iana('Na-Dene languages') --> "xnd" .
iana('Middle Mongolian') --> "xng" .
iana('Kuanhua') --> "xnh" .
iana('Ngarigu') --> "xni" .
iana('Nganakarti') --> "xnk" .
iana('Northern Kankanay') --> "xnn" .
iana('Anglo-Norman') --> "xno" .
iana('Kangri') --> "xnr" .
iana('Kanashi') --> "xns" .
iana('Narragansett') --> "xnt" .
iana('Nukunul') --> "xnu" .
iana('Nyiyaparli') --> "xny" .
iana('Kenzi') --> "xnz" .
iana('O\'chi\'chi\'') --> "xoc" .
iana('Kokoda') --> "xod" .
iana('Soga') --> "xog" .
iana('Kominimung') --> "xoi" .
iana('Xokleng') --> "xok" .
iana('Komo (Sudan)') --> "xom" .
iana('Konkomba') --> "xon" .
iana('Xukurú') --> "xoo" .
iana('Kopar') --> "xop" .
iana('Korubo') --> "xor" .
iana('Kowaki') --> "xow" .
iana('Pirriya') --> "xpa" .
iana('Pecheneg') --> "xpc" .
iana('Liberia Kpelle') --> "xpe" .
iana('Phrygian') --> "xpg" .
iana('Pictish') --> "xpi" .
iana('Mpalitjanh') --> "xpj" .
iana('Kulina Pano') --> "xpk" .
iana('Pumpokol') --> "xpm" .
iana('Kapinawá') --> "xpn" .
iana('Pochutec') --> "xpo" .
iana('Puyo-Paekche') --> "xpp" .
iana('Mohegan-Pequot') --> "xpq" .
iana('Parthian') --> "xpr" .
iana('Pisidian') --> "xps" .
iana('Punthamara') --> "xpt" .
iana('Punic') --> "xpu" .
iana('Puyo') --> "xpy" .
iana('Karakhanid') --> "xqa" .
iana('Qatabanian') --> "xqt" .
iana('Krahô') --> "xra" .
iana('Eastern Karaboro') --> "xrb" .
iana('Gundungurra') --> "xrd" .
iana('Kreye') --> "xre" .
iana('Minang') --> "xrg" .
iana('Krikati-Timbira') --> "xri" .
iana('Armazic') --> "xrm" .
iana('Arin') --> "xrn" .
iana('Karranga') --> "xrq" .
iana('Raetic') --> "xrr" .
iana('Aranama-Tamique') --> "xrt" .
iana('Marriammu') --> "xru" .
iana('Karawa') --> "xrw" .
iana('Sabaean') --> "xsa" .
iana('Sambal') --> "xsb" .
iana('Scythian') --> "xsc" .
iana('Sidetic') --> "xsd" .
iana('Sempan') --> "xse" .
iana('Shamang') --> "xsh" .
iana('Sio') --> "xsi" .
iana('Subi') --> "xsj" .
iana('South Slavey') --> "xsl" .
iana('Kasem') --> "xsm" .
iana('Sanga (Nigeria)') --> "xsn" .
iana('Solano') --> "xso" .
iana('Silopi') --> "xsp" .
iana('Makhuwa-Saka') --> "xsq" .
iana('Sherpa') --> "xsr" .
iana('Assan') --> "xss" .
iana('Sanumá') --> "xsu" .
iana('Sudovian') --> "xsv" .
iana('Saisiyat') --> "xsy" .
iana('Alcozauca Mixtec') --> "xta" .
iana('Chazumba Mixtec') --> "xtb" .
iana('Katcha-Kadugli-Miri') --> "xtc" .
iana('Diuxi-Tilantongo Mixtec') --> "xtd" .
iana('Ketengban') --> "xte" .
iana('Transalpine Gaulish') --> "xtg" .
iana('Yitha Yitha') --> "xth" .
iana('Sinicahua Mixtec') --> "xti" .
iana('San Juan Teita Mixtec') --> "xtj" .
iana('Tijaltepec Mixtec') --> "xtl" .
iana('Magdalena Peñasco Mixtec') --> "xtm" .
iana('Northern Tlaxiaco Mixtec') --> "xtn" .
iana('Tokharian A') --> "xto" .
iana('San Miguel Piedras Mixtec') --> "xtp" .
iana('Tumshuqese') --> "xtq" .
iana('Early Tripuri') --> "xtr" .
iana('Sindihui Mixtec') --> "xts" .
iana('Tacahua Mixtec') --> "xtt" .
iana('Cuyamecalco Mixtec') --> "xtu" .
iana('Thawa') --> "xtv" .
iana('Tawandê') --> "xtw" .
iana('Yoloxochitl Mixtec') --> "xty" .
iana('Tasmanian') --> "xtz" .
iana('Alu Kurumba') --> "xua" .
iana('Betta Kurumba') --> "xub" .
iana('Umiida') --> "xud" .
iana('Kunigami') --> "xug" .
iana('Jennu Kurumba') --> "xuj" .
iana('Ngunawal') --> "xul" .
iana('Umbrian') --> "xum" .
iana('Unggaranggu') --> "xun" .
iana('Kuo') --> "xuo" .
iana('Upper Umpqua') --> "xup" .
iana('Urartian') --> "xur" .
iana('Kuthant') --> "xut" .
iana('Kxoe') --> "xuu" .
iana('Venetic') --> "xve" .
iana('Kamviri') --> "xvi" .
iana('Vandalic') --> "xvn" .
iana('Volscian') --> "xvo" .
iana('Vestinian') --> "xvs" .
iana('Kwaza') --> "xwa" .
iana('Woccon') --> "xwc" .
iana('Wadi Wadi') --> "xwd" .
iana('Xwela Gbe') --> "xwe" .
iana('Kwegu') --> "xwg" .
iana('Wajuk') --> "xwj" .
iana('Wangkumara') --> "xwk" .
iana('Western Xwla Gbe') --> "xwl" .
iana('Written Oirat') --> "xwo" .
iana('Kwerba Mamberamo') --> "xwr" .
iana('Wotjobaluk') --> "xwt" .
iana('Wemba Wemba') --> "xww" .
iana('Boro (Ghana)') --> "xxb" .
iana('Ke\'o') --> "xxk" .
iana('Minkin') --> "xxm" .
iana('Koropó') --> "xxr" .
iana('Tambora') --> "xxt" .
iana('Yaygir') --> "xya" .
iana('Yandjibara') --> "xyb" .
iana('Mayi-Yapi') --> "xyj" .
iana('Mayi-Kulan') --> "xyk" .
iana('Yalakalore') --> "xyl" .
iana('Mayi-Thakurti') --> "xyt" .
iana('Yorta Yorta') --> "xyy" .
iana('Zhang-Zhung') --> "xzh" .
iana('Zemgalian') --> "xzm" .
iana('Ancient Zapotec') --> "xzp" .
iana('Yaminahua') --> "yaa" .
iana('Yuhup') --> "yab" .
iana('Pass Valley Yali') --> "yac" .
iana('Yagua') --> "yad" .
iana('Pumé') --> "yae" .
iana('Yaka (Democratic Republic of Congo)') --> "yaf" .
iana('Yámana') --> "yag" .
iana('Yazgulyam') --> "yah" .
iana('Yagnobi') --> "yai" .
iana('Banda-Yangere') --> "yaj" .
iana('Yakama') --> "yak" .
iana('Yalunka') --> "yal" .
iana('Yamba') --> "yam" .
iana('Mayangna') --> "yan" .
iana('Yao') --> "yao" .
iana('Yapese') --> "yap" .
iana('Yaqui') --> "yaq" .
iana('Yabarana') --> "yar" .
iana('Nugunu (Cameroon)') --> "yas" .
iana('Yambeta') --> "yat" .
iana('Yuwana') --> "yau" .
iana('Yangben') --> "yav" .
iana('Yawalapití') --> "yaw" .
iana('Yauma') --> "yax" .
iana('Agwagwune') --> "yay" .
iana('Lokaa') --> "yaz" .
iana('Yala') --> "yba" .
iana('Yemba') --> "ybb" .
iana('Yangbye') --> "ybd" .
iana('West Yugur') --> "ybe" .
iana('Yakha') --> "ybh" .
iana('Yamphu') --> "ybi" .
iana('Hasha') --> "ybj" .
iana('Bokha') --> "ybk" .
iana('Yukuben') --> "ybl" .
iana('Yaben') --> "ybm" .
iana('Yabaâna') --> "ybn" .
iana('Yabong') --> "ybo" .
iana('Yawiyo') --> "ybx" .
iana('Yaweyuha') --> "yby" .
iana('Chesu') --> "ych" .
iana('Lolopo') --> "ycl" .
iana('Yucuna') --> "ycn" .
iana('Chepya') --> "ycp" .
iana('Yanda') --> "yda" .
iana('Eastern Yiddish') --> "ydd" .
iana('Yangum Dey') --> "yde" .
iana('Yidgha') --> "ydg" .
iana('Yoidik') --> "ydk" .
iana('Yiddish Sign Language') --> "yds" .
iana('Ravula') --> "yea" .
iana('Yeniche') --> "yec" .
iana('Yimas') --> "yee" .
iana('Yeni') --> "yei" .
iana('Yevanic') --> "yej" .
iana('Yela') --> "yel" .
iana('Yendang') --> "yen" .
iana('Tarok') --> "yer" .
iana('Nyankpa') --> "yes" .
iana('Yetfa') --> "yet" .
iana('Yerukula') --> "yeu" .
iana('Yapunda') --> "yev" .
iana('Yeyi') --> "yey" .
iana('Malyangapa') --> "yga" .
iana('Yiningayi') --> "ygi" .
iana('Yangum Gel') --> "ygl" .
iana('Yagomi') --> "ygm" .
iana('Gepo') --> "ygp" .
iana('Yagaria') --> "ygr" .
iana('Yolŋu Sign Language') --> "ygs" .
iana('Yugul') --> "ygu" .
iana('Yagwoia') --> "ygw" .
iana('Baha Buyang') --> "yha" .
iana('Judeo-Iraqi Arabic') --> "yhd" .
iana('Hlepho Phowa') --> "yhl" .
iana('Yan-nhaŋu Sign Language') --> "yhs" .
iana('Yinggarda') --> "yia" .
iana('Ache') --> "yif" .
iana('Wusa Nasu') --> "yig" .
iana('Western Yiddish') --> "yih" .
iana('Yidiny') --> "yii" .
iana('Yindjibarndi') --> "yij" .
iana('Dongshanba Lalo') --> "yik" .
iana('Yindjilandji') --> "yil" .
iana('Yimchungru Naga') --> "yim" .
iana('Yinchia') --> "yin" .
iana('Pholo') --> "yip" .
iana('Miqie') --> "yiq" .
iana('North Awyu') --> "yir" .
iana('Yis') --> "yis" .
iana('Eastern Lalu') --> "yit" .
iana('Awu') --> "yiu" .
iana('Northern Nisu') --> "yiv" .
iana('Axi Yi') --> "yix" .
iana('Yir Yoront') --> "yiy" .
iana('Azhe') --> "yiz" .
iana('Yakan') --> "yka" .
iana('Northern Yukaghir') --> "ykg" .
iana('Yoke') --> "yki" .
iana('Yakaikeke') --> "ykk" .
iana('Khlula') --> "ykl" .
iana('Kap') --> "ykm" .
iana('Kua-nsi') --> "ykn" .
iana('Yasa') --> "yko" .
iana('Yekora') --> "ykr" .
iana('Kathu') --> "ykt" .
iana('Kuamasi') --> "yku" .
iana('Yakoma') --> "yky" .
iana('Yaul') --> "yla" .
iana('Yaleba') --> "ylb" .
iana('Yele') --> "yle" .
iana('Yelogu') --> "ylg" .
iana('Angguruk Yali') --> "yli" .
iana('Yil') --> "yll" .
iana('Limi') --> "ylm" .
iana('Langnian Buyang') --> "yln" .
iana('Naluo Yi') --> "ylo" .
iana('Yalarnnga') --> "ylr" .
iana('Aribwaung') --> "ylu" .
iana('Nyâlayu') --> "yly" .
iana('Yamphe') --> "yma" .
iana('Yambes') --> "ymb" .
iana('Southern Muji') --> "ymc" .
iana('Muda') --> "ymd" .
iana('Yameo') --> "yme" .
iana('Yamongeri') --> "ymg" .
iana('Mili') --> "ymh" .
iana('Moji') --> "ymi" .
iana('Makwe') --> "ymk" .
iana('Iamalele') --> "yml" .
iana('Maay') --> "ymm" .
iana('Yamna') --> "ymn" .
iana('Yangum Mon') --> "ymo" .
iana('Yamap') --> "ymp" .
iana('Qila Muji') --> "ymq" .
iana('Malasar') --> "ymr" .
iana('Mysian') --> "yms" .
iana('Mator-Taygi-Karagas') --> "ymt" .
iana('Northern Muji') --> "ymx" .
iana('Muzi') --> "ymz" .
iana('Aluo') --> "yna" .
iana('Yandruwandha') --> "ynd" .
iana('Lang\'e') --> "yne" .
iana('Yango') --> "yng" .
iana('Yangho') --> "ynh" .
iana('Naukan Yupik') --> "ynk" .
iana('Yangulam') --> "ynl" .
iana('Yana') --> "ynn" .
iana('Yong') --> "yno" .
iana('Yendang') --> "ynq" .
iana('Yansi') --> "yns" .
iana('Yahuna') --> "ynu" .
iana('Yoba') --> "yob" .
iana('Yogad') --> "yog" .
iana('Yonaguni') --> "yoi" .
iana('Yokuts') --> "yok" .
iana('Yola') --> "yol" .
iana('Yombe') --> "yom" .
iana('Yongkom') --> "yon" .
iana('Yos') --> "yos" .
iana('Yotti') --> "yot" .
iana('Yoron') --> "yox" .
iana('Yoy') --> "yoy" .
iana('Phala') --> "ypa" .
iana('Labo Phowa') --> "ypb" .
iana('Phola') --> "ypg" .
iana('Phupha') --> "yph" .
iana('Yupik languages') --> "ypk" .
iana('Phuma') --> "ypm" .
iana('Ani Phowa') --> "ypn" .
iana('Alo Phola') --> "ypo" .
iana('Phupa') --> "ypp" .
iana('Phuza') --> "ypz" .
iana('Yerakai') --> "yra" .
iana('Yareba') --> "yrb" .
iana('Yaouré') --> "yre" .
iana('Yarí') --> "yri" .
iana('Nenets') --> "yrk" .
iana('Nhengatu') --> "yrl" .
iana('Yirrk-Mel') --> "yrm" .
iana('Yerong') --> "yrn" .
iana('Yarsun') --> "yrs" .
iana('Yarawata') --> "yrw" .
iana('Yarluyandi') --> "yry" .
iana('Yassic') --> "ysc" .
iana('Samatao') --> "ysd" .
iana('Sonaga') --> "ysg" .
iana('Yugoslavian Sign Language') --> "ysl" .
iana('Sani') --> "ysn" .
iana('Nisi (China)') --> "yso" .
iana('Southern Lolopo') --> "ysp" .
iana('Sirenik Yupik') --> "ysr" .
iana('Yessan-Mayo') --> "yss" .
iana('Sanie') --> "ysy" .
iana('Talu') --> "yta" .
iana('Tanglang') --> "ytl" .
iana('Thopho') --> "ytp" .
iana('Yout Wam') --> "ytw" .
iana('Yatay') --> "yty" .
iana('Yucateco') --> "yua" .
iana('Yugambal') --> "yub" .
iana('Yuchi') --> "yuc" .
iana('Judeo-Tripolitanian Arabic') --> "yud" .
iana('Yue Chinese') --> "yue" .
iana('Havasupai-Walapai-Yavapai') --> "yuf" .
iana('Yug') --> "yug" .
iana('Yurutí') --> "yui" .
iana('Karkar-Yuri') --> "yuj" .
iana('Yuki') --> "yuk" .
iana('Yulu') --> "yul" .
iana('Quechan') --> "yum" .
iana('Bena (Nigeria)') --> "yun" .
iana('Yukpa') --> "yup" .
iana('Yuqui') --> "yuq" .
iana('Yurok') --> "yur" .
iana('Yopno') --> "yut" .
iana('Yugh') --> "yuu" .
iana('Yau (Morobe Province)') --> "yuw" .
iana('Southern Yukaghir') --> "yux" .
iana('East Yugur') --> "yuy" .
iana('Yuracare') --> "yuz" .
iana('Yawa') --> "yva" .
iana('Yavitero') --> "yvt" .
iana('Kalou') --> "ywa" .
iana('Yinhawangka') --> "ywg" .
iana('Western Lalu') --> "ywl" .
iana('Yawanawa') --> "ywn" .
iana('Wuding-Luquan Yi') --> "ywq" .
iana('Yawuru') --> "ywr" .
iana('Xishanba Lalo') --> "ywt" .
iana('Wumeng Nasu') --> "ywu" .
iana('Yawarawarga') --> "yww" .
iana('Mayawali') --> "yxa" .
iana('Yagara') --> "yxg" .
iana('Yardliyawarra') --> "yxl" .
iana('Yinwum') --> "yxm" .
iana('Yuyu') --> "yxu" .
iana('Yabula Yabula') --> "yxy" .
iana('Yir Yoront') --> "yyr" .
iana('Yau (Sandaun Province)') --> "yyu" .
iana('Ayizi') --> "yyz" .
iana('E\'ma Buyang') --> "yzg" .
iana('Zokhuo') --> "yzk" .
iana('Sierra de Juárez Zapotec') --> "zaa" .
iana('San Juan Guelavía Zapotec') --> "zab" .
iana('Ocotlán Zapotec') --> "zac" .
iana('Cajonos Zapotec') --> "zad" .
iana('Yareni Zapotec') --> "zae" .
iana('Ayoquesco Zapotec') --> "zaf" .
iana('Zaghawa') --> "zag" .
iana('Zangwal') --> "zah" .
iana('Isthmus Zapotec') --> "zai" .
iana('Zaramo') --> "zaj" .
iana('Zanaki') --> "zak" .
iana('Zauzou') --> "zal" .
iana('Miahuatlán Zapotec') --> "zam" .
iana('Ozolotepec Zapotec') --> "zao" .
iana('Zapotec') --> "zap" .
iana('Aloápam Zapotec') --> "zaq" .
iana('Rincón Zapotec') --> "zar" .
iana('Santo Domingo Albarradas Zapotec') --> "zas" .
iana('Tabaa Zapotec') --> "zat" .
iana('Zangskari') --> "zau" .
iana('Yatzachi Zapotec') --> "zav" .
iana('Mitla Zapotec') --> "zaw" .
iana('Xadani Zapotec') --> "zax" .
iana('Zayse-Zergulla') --> "zay" .
iana('Zari') --> "zaz" .
iana('Central Berawan') --> "zbc" .
iana('East Berawan') --> "zbe" .
iana('Blissymbols') --> "zbl" .
iana('Batui') --> "zbt" .
iana('West Berawan') --> "zbw" .
iana('Coatecas Altas Zapotec') --> "zca" .
iana('Central Hongshuihe Zhuang') --> "zch" .
iana('Ngazidja Comorian') --> "zdj" .
iana('Zeeuws') --> "zea" .
iana('Zenag') --> "zeg" .
iana('Eastern Hongshuihe Zhuang') --> "zeh" .
iana('Zenaga') --> "zen" .
iana('Kinga') --> "zga" .
iana('Guibei Zhuang') --> "zgb" .
iana('Standard Moroccan Tamazight') --> "zgh" .
iana('Minz Zhuang') --> "zgm" .
iana('Guibian Zhuang') --> "zgn" .
iana('Magori') --> "zgr" .
iana('Zhaba') --> "zhb" .
iana('Dai Zhuang') --> "zhd" .
iana('Zhire') --> "zhi" .
iana('Nong Zhuang') --> "zhn" .
iana('Zhoa') --> "zhw" .
iana('Chinese (family)') --> "zhx" .
iana('Zia') --> "zia" .
iana('Zimbabwe Sign Language') --> "zib" .
iana('Zimakani') --> "zik" .
iana('Zialo') --> "zil" .
iana('Mesme') --> "zim" .
iana('Zinza') --> "zin" .
iana('Ziriya') --> "zir" .
iana('Zigula') --> "ziw" .
iana('Zizilivakan') --> "ziz" .
iana('Kaimbulawa') --> "zka" .
iana('Koibal') --> "zkb" .
iana('Kadu') --> "zkd" .
iana('Koguryo') --> "zkg" .
iana('Khorezmian') --> "zkh" .
iana('Karankawa') --> "zkk" .
iana('Kanan') --> "zkn" .
iana('Kott') --> "zko" .
iana('São Paulo Kaingáng') --> "zkp" .
iana('Zakhring') --> "zkr" .
iana('Kitan') --> "zkt" .
iana('Kaurna') --> "zku" .
iana('Krevinian') --> "zkv" .
iana('Khazar') --> "zkz" .
iana('East Slavic languages') --> "zle" .
iana('Liujiang Zhuang') --> "zlj" .
iana('Malay (individual language)') --> "zlm" .
iana('Lianshan Zhuang') --> "zln" .
iana('Liuqian Zhuang') --> "zlq" .
iana('South Slavic languages') --> "zls" .
iana('West Slavic languages') --> "zlw" .
iana('Manda (Australia)') --> "zma" .
iana('Zimba') --> "zmb" .
iana('Margany') --> "zmc" .
iana('Maridan') --> "zmd" .
iana('Mangerr') --> "zme" .
iana('Mfinu') --> "zmf" .
iana('Marti Ke') --> "zmg" .
iana('Makolkol') --> "zmh" .
iana('Negeri Sembilan Malay') --> "zmi" .
iana('Maridjabin') --> "zmj" .
iana('Mandandanyi') --> "zmk" .
iana('Madngele') --> "zml" .
iana('Marimanindji') --> "zmm" .
iana('Mbangwe') --> "zmn" .
iana('Molo') --> "zmo" .
iana('Mpuono') --> "zmp" .
iana('Mituku') --> "zmq" .
iana('Maranunggu') --> "zmr" .
iana('Mbesa') --> "zms" .
iana('Maringarr') --> "zmt" .
iana('Muruwari') --> "zmu" .
iana('Mbariman-Gudhinma') --> "zmv" .
iana('Mbo (Democratic Republic of Congo)') --> "zmw" .
iana('Bomitaba') --> "zmx" .
iana('Mariyedi') --> "zmy" .
iana('Mbandja') --> "zmz" .
iana('Zan Gula') --> "zna" .
iana('Zande languages') --> "znd" .
iana('Zande (individual language)') --> "zne" .
iana('Mang') --> "zng" .
iana('Manangkari') --> "znk" .
iana('Mangas') --> "zns" .
iana('Copainalá Zoque') --> "zoc" .
iana('Chimalapa Zoque') --> "zoh" .
iana('Zou') --> "zom" .
iana('Asunción Mixtepec Zapotec') --> "zoo" .
iana('Tabasco Zoque') --> "zoq" .
iana('Rayón Zoque') --> "zor" .
iana('Francisco León Zoque') --> "zos" .
iana('Lachiguiri Zapotec') --> "zpa" .
iana('Yautepec Zapotec') --> "zpb" .
iana('Choapan Zapotec') --> "zpc" .
iana('Southeastern Ixtlán Zapotec') --> "zpd" .
iana('Petapa Zapotec') --> "zpe" .
iana('San Pedro Quiatoni Zapotec') --> "zpf" .
iana('Guevea De Humboldt Zapotec') --> "zpg" .
iana('Totomachapan Zapotec') --> "zph" .
iana('Santa María Quiegolani Zapotec') --> "zpi" .
iana('Quiavicuzas Zapotec') --> "zpj" .
iana('Tlacolulita Zapotec') --> "zpk" .
iana('Lachixío Zapotec') --> "zpl" .
iana('Mixtepec Zapotec') --> "zpm" .
iana('Santa Inés Yatzechi Zapotec') --> "zpn" .
iana('Amatlán Zapotec') --> "zpo" .
iana('El Alto Zapotec') --> "zpp" .
iana('Zoogocho Zapotec') --> "zpq" .
iana('Santiago Xanica Zapotec') --> "zpr" .
iana('Coatlán Zapotec') --> "zps" .
iana('San Vicente Coatlán Zapotec') --> "zpt" .
iana('Yalálag Zapotec') --> "zpu" .
iana('Chichicapan Zapotec') --> "zpv" .
iana('Zaniza Zapotec') --> "zpw" .
iana('San Baltazar Loxicha Zapotec') --> "zpx" .
iana('Mazaltepec Zapotec') --> "zpy" .
iana('Texmelucan Zapotec') --> "zpz" .
iana('Qiubei Zhuang') --> "zqe" .
iana('Kara (Korea)') --> "zra" .
iana('Mirgan') --> "zrg" .
iana('Zerenkel') --> "zrn" .
iana('Záparo') --> "zro" .
iana('Zarphatic') --> "zrp" .
iana('Mairasi') --> "zrs" .
iana('Sarasira') --> "zsa" .
iana('Kaskean') --> "zsk" .
iana('Zambian Sign Language') --> "zsl" .
iana('Standard Malay') --> "zsm" .
iana('Southern Rincon Zapotec') --> "zsr" .
iana('Sukurum') --> "zsu" .
iana('Elotepec Zapotec') --> "zte" .
iana('Xanaguía Zapotec') --> "ztg" .
iana('Lapaguía-Guivini Zapotec') --> "ztl" .
iana('San Agustín Mixtepec Zapotec') --> "ztm" .
iana('Santa Catarina Albarradas Zapotec') --> "ztn" .
iana('Loxicha Zapotec') --> "ztp" .
iana('Quioquitani-Quierí Zapotec') --> "ztq" .
iana('Tilquiapan Zapotec') --> "zts" .
iana('Tejalapan Zapotec') --> "ztt" .
iana('Güilá Zapotec') --> "ztu" .
iana('Zaachila Zapotec') --> "ztx" .
iana('Yatee Zapotec') --> "zty" .
iana('Zeem') --> "zua" .
iana('Tokano') --> "zuh" .
iana('Kumzari') --> "zum" .
iana('Zuni') --> "zun" .
iana('Zumaya') --> "zuy" .
iana('Zay') --> "zwa" .
iana('No linguistic content') --> "zxx" .
iana('Yongbei Zhuang') --> "zyb" .
iana('Yang Zhuang') --> "zyg" .
iana('Youjiang Zhuang') --> "zyj" .
iana('Yongnan Zhuang') --> "zyn" .
iana('Zyphe Chin') --> "zyp" .
iana('Zaza') --> "zza" .
iana('Zuojiang Zhuang') --> "zzj" .
iana('Algerian Saharan Arabic') --> "aao" .
iana('Tajiki Arabic') --> "abh" .
iana('Baharna Arabic') --> "abv" .
iana('Mesopotamian Arabic') --> "acm" .
iana('Ta\'izzi-Adeni Arabic') --> "acq" .
iana('Hijazi Arabic') --> "acw" .
iana('Omani Arabic') --> "acx" .
iana('Cypriot Arabic') --> "acy" .
iana('Dhofari Arabic') --> "adf" .
iana('Adamorobe Sign Language') --> "ads" .
iana('Tunisian Arabic') --> "aeb" .
iana('Saidi Arabic') --> "aec" .
iana('Argentine Sign Language') --> "aed" .
iana('Armenian Sign Language') --> "aen" .
iana('Gulf Arabic') --> "afb" .
iana('Afghan Sign Language') --> "afg" .
iana('South Levantine Arabic') --> "ajp" .
iana('North Levantine Arabic') --> "apc" .
iana('Sudanese Arabic') --> "apd" .
iana('Standard Arabic') --> "arb" .
iana('Algerian Arabic') --> "arq" .
iana('Najdi Arabic') --> "ars" .
iana('Moroccan Arabic') --> "ary" .
iana('Egyptian Arabic') --> "arz" .
iana('American Sign Language') --> "ase" .
iana('Australian Sign Language') --> "asf" .
iana('Algerian Sign Language') --> "asp" .
iana('Austrian Sign Language') --> "asq" .
iana('Australian Aborigines Sign Language') --> "asw" .
iana('Uzbeki Arabic') --> "auz" .
iana('Eastern Egyptian Bedawi Arabic') --> "avl" .
iana('Hadrami Arabic') --> "ayh" .
iana('Libyan Arabic') --> "ayl" .
iana('Sanaani Arabic') --> "ayn" .
iana('North Mesopotamian Arabic') --> "ayp" .
iana('Babalia Creole Arabic') --> "bbz" .
iana('British Sign Language') --> "bfi" .
iana('Ban Khor Sign Language') --> "bfk" .
iana('Banjar') --> "bjn" .
iana('Bamako Sign Language') --> "bog" .
iana('Bulgarian Sign Language') --> "bqn" .
iana('Bengkala Sign Language') --> "bqy" .
iana('Bacanese Malay') --> "btj" .
iana('Berau Malay') --> "bve" .
iana('Bolivian Sign Language') --> "bvl" .
iana('Bukit Malay') --> "bvu" .
iana('Brazilian Sign Language') --> "bzs" .
iana('Min Dong Chinese') --> "cdo" .
iana('Chadian Sign Language') --> "cds" .
iana('Jinyu Chinese') --> "cjy" .
iana('Mandarin Chinese') --> "cmn" .
iana('Cocos Islands Malay') --> "coa" .
iana('Pu-Xian Chinese') --> "cpx" .
iana('Catalan Sign Language') --> "csc" .
iana('Chiangmai Sign Language') --> "csd" .
iana('Czech Sign Language') --> "cse" .
iana('Cuba Sign Language') --> "csf" .
iana('Chilean Sign Language') --> "csg" .
iana('Chinese Sign Language') --> "csl" .
iana('Colombian Sign Language') --> "csn" .
iana('Croatia Sign Language') --> "csq" .
iana('Costa Rican Sign Language') --> "csr" .
iana('Huizhou Chinese') --> "czh" .
iana('Min Zhong Chinese') --> "czo" .
iana('Dominican Sign Language') --> "doq" .
iana('Dutch Sign Language') --> "dse" .
iana('Danish Sign Language') --> "dsl" .
iana('Duano') --> "dup" .
iana('Ecuadorian Sign Language') --> "ecs" .
iana('Egypt Sign Language') --> "esl" .
iana('Salvadoran Sign Language') --> "esn" .
iana('Estonian Sign Language') --> "eso" .
iana('Ethiopian Sign Language') --> "eth" .
iana('Quebec Sign Language') --> "fcs" .
iana('Finnish Sign Language') --> "fse" .
iana('French Sign Language') --> "fsl" .
iana('Finland-Swedish Sign Language') --> "fss" .
iana('Gan Chinese') --> "gan" .
iana('Ghandruk Sign Language') --> "gds" .
iana('Goan Konkani') --> "gom" .
iana('Ghanaian Sign Language') --> "gse" .
iana('German Sign Language') --> "gsg" .
iana('Guatemalan Sign Language') --> "gsm" .
iana('Greek Sign Language') --> "gss" .
iana('Guinean Sign Language') --> "gus" .
iana('Hanoi Sign Language') --> "hab" .
iana('Haiphong Sign Language') --> "haf" .
iana('Hakka Chinese') --> "hak" .
iana('Honduras Sign Language') --> "hds" .
iana('Haji') --> "hji" .
iana('Hong Kong Sign Language') --> "hks" .
iana('Ho Chi Minh City Sign Language') --> "hos" .
iana('Hawai\'i Sign Language (HSL)') --> "hps" .
iana('Hungarian Sign Language') --> "hsh" .
iana('Hausa Sign Language') --> "hsl" .
iana('Xiang Chinese') --> "hsn" .
iana('Icelandic Sign Language') --> "icl" .
iana('Inuit Sign Language') --> "iks" .
iana('International Sign') --> "ils" .
iana('Indonesian Sign Language') --> "inl" .
iana('Indian Sign Language') --> "ins" .
iana('Italian Sign Language') --> "ise" .
iana('Irish Sign Language') --> "isg" .
iana('Israeli Sign Language') --> "isr" .
iana('Jakun') --> "jak" .
iana('Jambi Malay') --> "jax" .
iana('Jamaican Country Sign Language') --> "jcs" .
iana('Jhankot Sign Language') --> "jhs" .
iana('Jamaican Sign Language') --> "jls" .
iana('Jordanian Sign Language') --> "jos" .
iana('Japanese Sign Language') --> "jsl" .
iana('Jumla Sign Language') --> "jus" .
iana('Selangor Sign Language') --> "kgi" .
iana('Konkani (individual language)') --> "knn" .
iana('Kubu') --> "kvb" .
iana('Korean Sign Language') --> "kvk" .
iana('Kerinci') --> "kvr" .
iana('Brunei') --> "kxd" .
iana('Libyan Sign Language') --> "lbs" .
iana('Loncong') --> "lce" .
iana('Lubu') --> "lcf" .
iana('Col') --> "liw" .
iana('Lithuanian Sign Language') --> "lls" .
iana('Lyons Sign Language') --> "lsg" .
iana('Latvian Sign Language') --> "lsl" .
iana('Laos Sign Language') --> "lso" .
iana('Panamanian Sign Language') --> "lsp" .
iana('Trinidad and Tobago Sign Language') --> "lst" .
iana('Mauritian Sign Language') --> "lsy" .
iana('Latgalian') --> "ltg" .
iana('Standard Latvian') --> "lvs" .
iana('Literary Chinese') --> "lzh" .
iana('North Moluccan Malay') --> "max" .
iana('Maltese Sign Language') --> "mdl" .
iana('Kedah Malay') --> "meo" .
iana('Pattani Malay') --> "mfa" .
iana('Bangka') --> "mfb" .
iana('Mexican Sign Language') --> "mfs" .
iana('Minangkabau') --> "min" .
iana('Min Bei Chinese') --> "mnp" .
iana('Kota Bangun Kutai Malay') --> "mqg" .
iana('Martha\'s Vineyard Sign Language') --> "mre" .
iana('Yucatec Maya Sign Language') --> "msd" .
iana('Sabah Malay') --> "msi" .
iana('Mongolian Sign Language') --> "msr" .
iana('Musi') --> "mui" .
iana('Madagascar Sign Language') --> "mzc" .
iana('Monastic Sign Language') --> "mzg" .
iana('Mozambican Sign Language') --> "mzy" .
iana('Min Nan Chinese') --> "nan" .
iana('Namibian Sign Language') --> "nbs" .
iana('Nicaraguan Sign Language') --> "ncs" .
iana('Nigerian Sign Language') --> "nsi" .
iana('Norwegian Sign Language') --> "nsl" .
iana('Nepalese Sign Language') --> "nsp" .
iana('Maritime Sign Language') --> "nsr" .
iana('New Zealand Sign Language') --> "nzs" .
iana('Old Kentish Sign Language') --> "okl" .
iana('Orang Kanaq') --> "orn" .
iana('Orang Seletar') --> "ors" .
iana('Pekal') --> "pel" .
iana('Sudanese Creole Arabic') --> "pga" .
iana('Pakistan Sign Language') --> "pks" .
iana('Peruvian Sign Language') --> "prl" .
iana('Providencia Sign Language') --> "prz" .
iana('Persian Sign Language') --> "psc" .
iana('Plains Indian Sign Language') --> "psd" .
iana('Central Malay') --> "pse" .
iana('Penang Sign Language') --> "psg" .
iana('Puerto Rican Sign Language') --> "psl" .
iana('Polish Sign Language') --> "pso" .
iana('Philippine Sign Language') --> "psp" .
iana('Portuguese Sign Language') --> "psr" .
iana('Paraguayan Sign Language') --> "pys" .
iana('Romanian Sign Language') --> "rms" .
iana('Rennellese Sign Language') --> "rsi" .
iana('Russian Sign Language') --> "rsl" .
iana('Saudi Arabian Sign Language') --> "sdl" .
iana('Langue des signes de Belgique Francophone') --> "sfb" .
iana('South African Sign Language') --> "sfs" .
iana('Swiss-German Sign Language') --> "sgg" .
iana('Sierra Leone Sign Language') --> "sgx" .
iana('Chadian Arabic') --> "shu" .
iana('Swiss-Italian Sign Language') --> "slf" .
iana('Singapore Sign Language') --> "sls" .
iana('Albanian Sign Language') --> "sqk" .
iana('Sri Lankan Sign Language') --> "sqs" .
iana('Shihhi Arabic') --> "ssh" .
iana('Spanish Sign Language') --> "ssp" .
iana('Swiss-French Sign Language') --> "ssr" .
iana('Slovakian Sign Language') --> "svk" .
iana('Congo Swahili') --> "swc" .
iana('Swahili (individual language)') --> "swh" .
iana('Swedish Sign Language') --> "swl" .
iana('Al-Sayyid Bedouin Sign Language') --> "syy" .
iana('Temuan') --> "tmw" .
iana('Tunisian Sign Language') --> "tse" .
iana('Turkish Sign Language') --> "tsm" .
iana('Thai Sign Language') --> "tsq" .
iana('Taiwan Sign Language') --> "tss" .
iana('Tebul Sign Language') --> "tsy" .
iana('Tanzanian Sign Language') --> "tza" .
iana('Ugandan Sign Language') --> "ugn" .
iana('Uruguayan Sign Language') --> "ugy" .
iana('Ukrainian Sign Language') --> "ukl" .
iana('Urubú-Kaapor Sign Language') --> "uks" .
iana('Urak Lawoi\'') --> "urk" .
iana('Northern Uzbek') --> "uzn" .
iana('Southern Uzbek') --> "uzs" .
iana('Vlaamse Gebarentaal') --> "vgt" .
iana('Kaur') --> "vkk" .
iana('Tenggarong Kutai Malay') --> "vkt" .
iana('Moldova Sign Language') --> "vsi" .
iana('Venezuelan Sign Language') --> "vsl" .
iana('Valencian Sign Language') --> "vsv" .
iana('Wu Chinese') --> "wuu" .
iana('Kenyan Sign Language') --> "xki" .
iana('Malaysian Sign Language') --> "xml" .
iana('Manado Malay') --> "xmm" .
iana('Moroccan Sign Language') --> "xms" .
iana('Yiddish Sign Language') --> "yds" .
iana('Yolŋu Sign Language') --> "ygs" .
iana('Yan-nhaŋu Sign Language') --> "yhs" .
iana('Yugoslavian Sign Language') --> "ysl" .
iana('Yue Chinese') --> "yue" .
iana('Zimbabwe Sign Language') --> "zib" .
iana('Malay (individual language)') --> "zlm" .
iana('Negeri Sembilan Malay') --> "zmi" .
iana('Zambian Sign Language') --> "zsl" .
iana('Standard Malay') --> "zsm" .
iana('Adlam') --> "Adlm" .
iana('Afaka') --> "Afak" .
iana('Caucasian Albanian') --> "Aghb" .
iana('Ahom') --> "Ahom" .
iana('Arabic') --> "Arab" .
iana('Arabic (Nastaliq variant)') --> "Aran" .
iana('Imperial Aramaic') --> "Armi" .
iana('Armenian') --> "Armn" .
iana('Avestan') --> "Avst" .
iana('Balinese') --> "Bali" .
iana('Bamum') --> "Bamu" .
iana('Bassa Vah') --> "Bass" .
iana('Batak') --> "Batk" .
iana('Bengali') --> "Beng" .
iana('Bhaiksuki') --> "Bhks" .
iana('Blissymbols') --> "Blis" .
iana('Bopomofo') --> "Bopo" .
iana('Brahmi') --> "Brah" .
iana('Braille') --> "Brai" .
iana('Buginese') --> "Bugi" .
iana('Buhid') --> "Buhd" .
iana('Chakma') --> "Cakm" .
iana('Unified Canadian Aboriginal Syllabics') --> "Cans" .
iana('Carian') --> "Cari" .
iana('Cham') --> "Cham" .
iana('Cherokee') --> "Cher" .
iana('Cirth') --> "Cirt" .
iana('Coptic') --> "Copt" .
iana('Cypriot') --> "Cprt" .
iana('Cyrillic') --> "Cyrl" .
iana('Cyrillic (Old Church Slavonic variant)') --> "Cyrs" .
iana('Devanagari') --> "Deva" .
iana('Deseret') --> "Dsrt" .
iana('Duployan shorthand') --> "Dupl" .
iana('Egyptian demotic') --> "Egyd" .
iana('Egyptian hieratic') --> "Egyh" .
iana('Egyptian hieroglyphs') --> "Egyp" .
iana('Elbasan') --> "Elba" .
iana('Ethiopic') --> "Ethi" .
iana('Khutsuri (Asomtavruli and Nuskhuri)') --> "Geok" .
iana('Georgian (Mkhedruli)') --> "Geor" .
iana('Glagolitic') --> "Glag" .
iana('Gothic') --> "Goth" .
iana('Grantha') --> "Gran" .
iana('Greek') --> "Grek" .
iana('Gujarati') --> "Gujr" .
iana('Gurmukhi') --> "Guru" .
iana('Hangul') --> "Hang" .
iana('Han') --> "Hani" .
iana('Hanunoo') --> "Hano" .
iana('Han (Simplified variant)') --> "Hans" .
iana('Han (Traditional variant)') --> "Hant" .
iana('Hatran') --> "Hatr" .
iana('Hebrew') --> "Hebr" .
iana('Hiragana') --> "Hira" .
iana('Anatolian Hieroglyphs') --> "Hluw" .
iana('Pahawh Hmong') --> "Hmng" .
iana('Japanese syllabaries (alias for Hiragana + Katakana)') --> "Hrkt" .
iana('Old Hungarian') --> "Hung" .
iana('Indus') --> "Inds" .
iana('Old Italic (Etruscan, Oscan, etc.)') --> "Ital" .
iana('Javanese') --> "Java" .
iana('Japanese (alias for Han + Hiragana + Katakana)') --> "Jpan" .
iana('Jurchen') --> "Jurc" .
iana('Kayah Li') --> "Kali" .
iana('Katakana') --> "Kana" .
iana('Kharoshthi') --> "Khar" .
iana('Khmer') --> "Khmr" .
iana('Khojki') --> "Khoj" .
iana('Khitan large script') --> "Kitl" .
iana('Khitan small script') --> "Kits" .
iana('Kannada') --> "Knda" .
iana('Korean (alias for Hangul + Han)') --> "Kore" .
iana('Kpelle') --> "Kpel" .
iana('Kaithi') --> "Kthi" .
iana('Tai Tham') --> "Lana" .
iana('Lao') --> "Laoo" .
iana('Latin (Fraktur variant)') --> "Latf" .
iana('Latin (Gaelic variant)') --> "Latg" .
iana('Latin') --> "Latn" .
iana('Leke') --> "Leke" .
iana('Lepcha') --> "Lepc" .
iana('Limbu') --> "Limb" .
iana('Linear A') --> "Lina" .
iana('Linear B') --> "Linb" .
iana('Lisu') --> "Lisu" .
iana('Loma') --> "Loma" .
iana('Lycian') --> "Lyci" .
iana('Lydian') --> "Lydi" .
iana('Mahajani') --> "Mahj" .
iana('Mandaic') --> "Mand" .
iana('Manichaean') --> "Mani" .
iana('Marchen') --> "Marc" .
iana('Mayan hieroglyphs') --> "Maya" .
iana('Mende Kikakui') --> "Mend" .
iana('Meroitic Cursive') --> "Merc" .
iana('Meroitic Hieroglyphs') --> "Mero" .
iana('Malayalam') --> "Mlym" .
iana('Modi') --> "Modi" .
iana('Mongolian') --> "Mong" .
iana('Moon') --> "Moon" .
iana('Mro') --> "Mroo" .
iana('Meitei Mayek') --> "Mtei" .
iana('Multani') --> "Mult" .
iana('Myanmar') --> "Mymr" .
iana('Old North Arabian') --> "Narb" .
iana('Nabataean') --> "Nbat" .
iana('Nakhi Geba') --> "Nkgb" .
iana('N’Ko') --> "Nkoo" .
iana('Nüshu') --> "Nshu" .
iana('Ogham') --> "Ogam" .
iana('Ol Chiki') --> "Olck" .
iana('Old Turkic') --> "Orkh" .
iana('Oriya') --> "Orya" .
iana('Osage') --> "Osge" .
iana('Osmanya') --> "Osma" .
iana('Palmyrene') --> "Palm" .
iana('Pau Cin Hau') --> "Pauc" .
iana('Old Permic') --> "Perm" .
iana('Phags-pa') --> "Phag" .
iana('Inscriptional Pahlavi') --> "Phli" .
iana('Psalter Pahlavi') --> "Phlp" .
iana('Book Pahlavi') --> "Phlv" .
iana('Phoenician') --> "Phnx" .
iana('Miao') --> "Plrd" .
iana('Inscriptional Parthian') --> "Prti" .
iana('Private use') --> "Qaaa..Qabx" .
iana('Rejang') --> "Rjng" .
iana('Rongorongo') --> "Roro" .
iana('Runic') --> "Runr" .
iana('Samaritan') --> "Samr" .
iana('Sarati') --> "Sara" .
iana('Old South Arabian') --> "Sarb" .
iana('Saurashtra') --> "Saur" .
iana('SignWriting') --> "Sgnw" .
iana('Shavian') --> "Shaw" .
iana('Sharada') --> "Shrd" .
iana('Siddham') --> "Sidd" .
iana('Khudawadi') --> "Sind" .
iana('Sinhala') --> "Sinh" .
iana('Sora Sompeng') --> "Sora" .
iana('Sundanese') --> "Sund" .
iana('Syloti Nagri') --> "Sylo" .
iana('Syriac') --> "Syrc" .
iana('Syriac (Estrangelo variant)') --> "Syre" .
iana('Syriac (Western variant)') --> "Syrj" .
iana('Syriac (Eastern variant)') --> "Syrn" .
iana('Tagbanwa') --> "Tagb" .
iana('Takri') --> "Takr" .
iana('Tai Le') --> "Tale" .
iana('New Tai Lue') --> "Talu" .
iana('Tamil') --> "Taml" .
iana('Tangut') --> "Tang" .
iana('Tai Viet') --> "Tavt" .
iana('Telugu') --> "Telu" .
iana('Tengwar') --> "Teng" .
iana('Tifinagh') --> "Tfng" .
iana('Tagalog') --> "Tglg" .
iana('Thaana') --> "Thaa" .
iana('Thai') --> "Thai" .
iana('Tibetan') --> "Tibt" .
iana('Tirhuta') --> "Tirh" .
iana('Ugaritic') --> "Ugar" .
iana('Vai') --> "Vaii" .
iana('Visible Speech') --> "Visp" .
iana('Warang Citi') --> "Wara" .
iana('Woleai') --> "Wole" .
iana('Old Persian') --> "Xpeo" .
iana('Sumero-Akkadian cuneiform') --> "Xsux" .
iana('Yi') --> "Yiii" .
iana('Code for inherited script') --> "Zinh" .
iana('Mathematical notation') --> "Zmth" .
iana('Symbols') --> "Zsym" .
iana('Code for unwritten documents') --> "Zxxx" .
iana('Code for undetermined script') --> "Zyyy" .
iana('Code for uncoded script') --> "Zzzz" .
iana('Private use') --> "AA" .
iana('Ascension Island') --> "AC" .
iana('Andorra') --> "AD" .
iana('United Arab Emirates') --> "AE" .
iana('Afghanistan') --> "AF" .
iana('Antigua and Barbuda') --> "AG" .
iana('Anguilla') --> "AI" .
iana('Albania') --> "AL" .
iana('Armenia') --> "AM" .
iana('Netherlands Antilles') --> "AN" .
iana('Angola') --> "AO" .
iana('Antarctica') --> "AQ" .
iana('Argentina') --> "AR" .
iana('American Samoa') --> "AS" .
iana('Austria') --> "AT" .
iana('Australia') --> "AU" .
iana('Aruba') --> "AW" .
iana('Åland Islands') --> "AX" .
iana('Azerbaijan') --> "AZ" .
iana('Bosnia and Herzegovina') --> "BA" .
iana('Barbados') --> "BB" .
iana('Bangladesh') --> "BD" .
iana('Belgium') --> "BE" .
iana('Burkina Faso') --> "BF" .
iana('Bulgaria') --> "BG" .
iana('Bahrain') --> "BH" .
iana('Burundi') --> "BI" .
iana('Benin') --> "BJ" .
iana('Saint Barthélemy') --> "BL" .
iana('Bermuda') --> "BM" .
iana('Brunei Darussalam') --> "BN" .
iana('Bolivia') --> "BO" .
iana('Bonaire, Sint Eustatius and Saba') --> "BQ" .
iana('Brazil') --> "BR" .
iana('Bahamas') --> "BS" .
iana('Bhutan') --> "BT" .
iana('Burma') --> "BU" .
iana('Bouvet Island') --> "BV" .
iana('Botswana') --> "BW" .
iana('Belarus') --> "BY" .
iana('Belize') --> "BZ" .
iana('Canada') --> "CA" .
iana('Cocos (Keeling) Islands') --> "CC" .
iana('The Democratic Republic of the Congo') --> "CD" .
iana('Central African Republic') --> "CF" .
iana('Congo') --> "CG" .
iana('Switzerland') --> "CH" .
iana('Côte d\'Ivoire') --> "CI" .
iana('Cook Islands') --> "CK" .
iana('Chile') --> "CL" .
iana('Cameroon') --> "CM" .
iana('China') --> "CN" .
iana('Colombia') --> "CO" .
iana('Clipperton Island') --> "CP" .
iana('Costa Rica') --> "CR" .
iana('Serbia and Montenegro') --> "CS" .
iana('Cuba') --> "CU" .
iana('Cabo Verde') --> "CV" .
iana('Curaçao') --> "CW" .
iana('Christmas Island') --> "CX" .
iana('Cyprus') --> "CY" .
iana('Czech Republic') --> "CZ" .
iana('German Democratic Republic') --> "DD" .
iana('Germany') --> "DE" .
iana('Diego Garcia') --> "DG" .
iana('Djibouti') --> "DJ" .
iana('Denmark') --> "DK" .
iana('Dominica') --> "DM" .
iana('Dominican Republic') --> "DO" .
iana('Algeria') --> "DZ" .
iana('Ceuta, Melilla') --> "EA" .
iana('Ecuador') --> "EC" .
iana('Estonia') --> "EE" .
iana('Egypt') --> "EG" .
iana('Western Sahara') --> "EH" .
iana('Eritrea') --> "ER" .
iana('Spain') --> "ES" .
iana('Ethiopia') --> "ET" .
iana('European Union') --> "EU" .
iana('Finland') --> "FI" .
iana('Fiji') --> "FJ" .
iana('Falkland Islands (Malvinas)') --> "FK" .
iana('Federated States of Micronesia') --> "FM" .
iana('Faroe Islands') --> "FO" .
iana('France') --> "FR" .
iana('Metropolitan France') --> "FX" .
iana('Gabon') --> "GA" .
iana('United Kingdom') --> "GB" .
iana('Grenada') --> "GD" .
iana('Georgia') --> "GE" .
iana('French Guiana') --> "GG" .
iana('Ghana') --> "GH" .
iana('Gibraltar') --> "GI" .
iana('Greenland') --> "GL" .
iana('Gambia') --> "GM" .
iana('Guinea') --> "GN" .
iana('Guadeloupe') --> "GP" .
iana('Equatorial Guinea') --> "GQ" .
iana('Greece') --> "GR" .
iana('South Georgia and the South Sandwich Islands') --> "GS" .
iana('Guatemala') --> "GT" .
iana('Guam') --> "GU" .
iana('Guinea-Bissau') --> "GW" .
iana('Guyana') --> "GY" .
iana('Hong Kong') --> "HK" .
iana('Heard Island and McDonald Islands') --> "HM" .
iana('Honduras') --> "HN" .
iana('Croatia') --> "HR" .
iana('Haiti') --> "HT" .
iana('Hungary') --> "HU" .
iana('Canary Islands') --> "IC" .
iana('Indonesia') --> "ID" .
iana('Ireland') --> "IE" .
iana('Israel') --> "IL" .
iana('Isle of Man') --> "IM" .
iana('India') --> "IN" .
iana('British Indian Ocean Territory') --> "IO" .
iana('Iraq') --> "IQ" .
iana('Islamic Republic of Iran') --> "IR" .
iana('Iceland') --> "IS" .
iana('Italy') --> "IT" .
iana('Jersey') --> "JE" .
iana('Jamaica') --> "JM" .
iana('Jordan') --> "JO" .
iana('Japan') --> "JP" .
iana('Kenya') --> "KE" .
iana('Kyrgyzstan') --> "KG" .
iana('Cambodia') --> "KH" .
iana('Kiribati') --> "KI" .
iana('Comoros') --> "KM" .
iana('Saint Kitts and Nevis') --> "KN" .
iana('Democratic People\'s Republic of Korea') --> "KP" .
iana('Republic of Korea') --> "KR" .
iana('Kuwait') --> "KW" .
iana('Cayman Islands') --> "KY" .
iana('Kazakhstan') --> "KZ" .
iana('Lao People\'s Democratic Republic') --> "LA" .
iana('Lebanon') --> "LB" .
iana('Saint Lucia') --> "LC" .
iana('Liechtenstein') --> "LI" .
iana('Sri Lanka') --> "LK" .
iana('Liberia') --> "LR" .
iana('Lesotho') --> "LS" .
iana('Lithuania') --> "LT" .
iana('Luxembourg') --> "LU" .
iana('Latvia') --> "LV" .
iana('Libya') --> "LY" .
iana('Morocco') --> "MA" .
iana('Monaco') --> "MC" .
iana('Moldova') --> "MD" .
iana('Montenegro') --> "ME" .
iana('Saint Martin (French part)') --> "MF" .
iana('Madagascar') --> "MG" .
iana('Marshall Islands') --> "MH" .
iana('The Former Yugoslav Republic of Macedonia') --> "MK" .
iana('Mali') --> "ML" .
iana('Myanmar') --> "MM" .
iana('Mongolia') --> "MN" .
iana('Macao') --> "MO" .
iana('Northern Mariana Islands') --> "MQ" .
iana('Mauritania') --> "MR" .
iana('Montserrat') --> "MS" .
iana('Malta') --> "MT" .
iana('Mauritius') --> "MU" .
iana('Maldives') --> "MV" .
iana('Malawi') --> "MW" .
iana('Mexico') --> "MX" .
iana('Malaysia') --> "MY" .
iana('Mozambique') --> "MZ" .
iana('Namibia') --> "NA" .
iana('New Caledonia') --> "NC" .
iana('Niger') --> "NE" .
iana('Norfolk Island') --> "NF" .
iana('Nigeria') --> "NG" .
iana('Nicaragua') --> "NI" .
iana('Netherlands') --> "NL" .
iana('Norway') --> "NO" .
iana('Nepal') --> "NP" .
iana('Nauru') --> "NR" .
iana('Neutral Zone') --> "NT" .
iana('Niue') --> "NU" .
iana('New Zealand') --> "NZ" .
iana('Oman') --> "OM" .
iana('Panama') --> "PA" .
iana('Peru') --> "PE" .
iana('French Polynesia') --> "PF" .
iana('Papua New Guinea') --> "PG" .
iana('Philippines') --> "PH" .
iana('Pakistan') --> "PK" .
iana('Poland') --> "PL" .
iana('Saint Pierre and Miquelon') --> "PM" .
iana('Pitcairn') --> "PN" .
iana('Puerto Rico') --> "PR" .
iana('State of Palestine') --> "PS" .
iana('Portugal') --> "PT" .
iana('Palau') --> "PW" .
iana('Paraguay') --> "PY" .
iana('Qatar') --> "QA" .
iana('Private use') --> "QM..QZ" .
iana('Réunion') --> "RE" .
iana('Romania') --> "RO" .
iana('Serbia') --> "RS" .
iana('Russian Federation') --> "RU" .
iana('Rwanda') --> "RW" .
iana('Saudi Arabia') --> "SA" .
iana('Solomon Islands') --> "SB" .
iana('Seychelles') --> "SC" .
iana('Sudan') --> "SD" .
iana('Sweden') --> "SE" .
iana('Singapore') --> "SG" .
iana('Saint Helena, Ascension and Tristan da Cunha') --> "SH" .
iana('Slovenia') --> "SI" .
iana('Svalbard and Jan Mayen') --> "SJ" .
iana('Slovakia') --> "SK" .
iana('Sierra Leone') --> "SL" .
iana('San Marino') --> "SM" .
iana('Senegal') --> "SN" .
iana('Somalia') --> "SO" .
iana('Suriname') --> "SR" .
iana('South Sudan') --> "SS" .
iana('Sao Tome and Principe') --> "ST" .
iana('Union of Soviet Socialist Republics') --> "SU" .
iana('El Salvador') --> "SV" .
iana('Sint Maarten (Dutch part)') --> "SX" .
iana('Syrian Arab Republic') --> "SY" .
iana('Swaziland') --> "SZ" .
iana('Tristan da Cunha') --> "TA" .
iana('Turks and Caicos Islands') --> "TC" .
iana('Chad') --> "TD" .
iana('French Southern Territories') --> "TF" .
iana('Togo') --> "TG" .
iana('Thailand') --> "TH" .
iana('Tajikistan') --> "TJ" .
iana('Tokelau') --> "TK" .
iana('Timor-Leste') --> "TL" .
iana('Turkmenistan') --> "TM" .
iana('Tunisia') --> "TN" .
iana('Tonga') --> "TO" .
iana('East Timor') --> "TP" .
iana('Turkey') --> "TR" .
iana('Trinidad and Tobago') --> "TT" .
iana('Tuvalu') --> "TV" .
iana('Taiwan, Province of China') --> "TW" .
iana('United Republic of Tanzania') --> "TZ" .
iana('Ukraine') --> "UA" .
iana('Uganda') --> "UG" .
iana('United States Minor Outlying Islands') --> "UM" .
iana('United States') --> "US" .
iana('Uruguay') --> "UY" .
iana('Uzbekistan') --> "UZ" .
iana('Holy See (Vatican City State)') --> "VA" .
iana('Saint Vincent and the Grenadines') --> "VC" .
iana('Venezuela') --> "VE" .
iana('British Virgin Islands') --> "VG" .
iana('U.S. Virgin Islands') --> "VI" .
iana('Viet Nam') --> "VN" .
iana('Vanuatu') --> "VU" .
iana('Wallis and Futuna') --> "WF" .
iana('Samoa') --> "WS" .
iana('Private use') --> "XA..XZ" .
iana('Democratic Yemen') --> "YD" .
iana('Yemen') --> "YE" .
iana('Mayotte') --> "YT" .
iana('Yugoslavia') --> "YU" .
iana('South Africa') --> "ZA" .
iana('Zambia') --> "ZM" .
iana('Zaire') --> "ZR" .
iana('Zimbabwe') --> "ZW" .
iana('Private use') --> "ZZ" .
iana('World') --> "001" .
iana('Africa') --> "002" .
iana('North America') --> "003" .
iana('South America') --> "005" .
iana('Oceania') --> "009" .
iana('Western Africa') --> "011" .
iana('Central America') --> "013" .
iana('Eastern Africa') --> "014" .
iana('Northern Africa') --> "015" .
iana('Middle Africa') --> "017" .
iana('Southern Africa') --> "018" .
iana('Americas') --> "019" .
iana('Northern America') --> "021" .
iana('Caribbean') --> "029" .
iana('Eastern Asia') --> "030" .
iana('Southern Asia') --> "034" .
iana('South-Eastern Asia') --> "035" .
iana('Southern Europe') --> "039" .
iana('Australia and New Zealand') --> "053" .
iana('Melanesia') --> "054" .
iana('Micronesia') --> "057" .
iana('Polynesia') --> "061" .
iana('Asia') --> "142" .
iana('Central Asia') --> "143" .
iana('Western Asia') --> "145" .
iana('Europe') --> "150" .
iana('Eastern Europe') --> "151" .
iana('Northern Europe') --> "154" .
iana('Western Europe') --> "155" .
iana('Latin America and the Caribbean') --> "419" .
iana('Late Middle French (to 1606)') --> "1606nict" .
iana('Early Modern French') --> "1694acad" .
iana('Traditional German orthography') --> "1901" .
iana('"Academic" ("governmental") variant of Belarusian as') --> "1959acad" .
iana('Standardized Resian orthography') --> "1994" .
iana('German orthography of 1996') --> "1996" .
iana('Orthographic formulation of 1943 - Official in Brazil') --> "abl1943" .
iana('ALA-LC Romanization, 1997 edition') --> "alalc97" .
iana('Aluku dialect') --> "aluku" .
iana('Portuguese Language Orthographic Agreement of 1990 (Acordo') --> "ao1990" .
iana('Eastern Armenian') --> "arevela" .
iana('Western Armenian') --> "arevmda" .
iana('Unified Turkic Latin Alphabet (Historical)') --> "baku1926" .
iana('The Balanka dialect of Anii') --> "balanka" .
iana('The Barlavento dialect group of Kabuverdianu') --> "barla" .
iana('Buddhist Hybrid Sanskrit') --> "bauddha" .
iana('Biscayan dialect of Basque') --> "biscayan" .
iana('The San Giorgio dialect of Resian') --> "biske" .
iana('Slovene in Bohorič alphabet') --> "bohoric" .
iana('Boontling') --> "boont" .
iana('Portuguese-Brazilian Orthographic Convention of 1945') --> "colb1945" .
iana('Slovene in Dajnko alphabet') --> "dajnko" .
iana('Serbian with Ekavian pronunciation') --> "ekavsk" .
iana('Early Modern English (1500-1700)') --> "emodeng" .
iana('International Phonetic Alphabet') --> "fonipa" .
iana('Uralic Phonetic Alphabet') --> "fonupa" .
iana('X-SAMPA transcription') --> "fonxsamp" .
iana('Hepburn romanization') --> "hepburn" .
iana('Hepburn romanization, Library of Congress method') --> "heploc" .
iana('Norwegian in Høgnorsk (High Norwegian) orthography') --> "hognorsk" .
iana('Serbian with Ijekavian pronunciation') --> "ijekavsk" .
iana('Epic Sanskrit') --> "itihasa" .
iana('Jauer dialect of Romansh') --> "jauer" .
iana('Jyutping Cantonese Romanization') --> "jyutping" .
iana('Common Cornish orthography of Revived Cornish') --> "kkcor" .
iana('The Kociewie dialect of Polish') --> "kociewie" .
iana('Standard Cornish orthography of Revived Cornish') --> "kscor" .
iana('Classical Sanskrit') --> "laukika" .
iana('The Lipovaz dialect of Resian') --> "lipaw" .
iana('Post-1917 Russian orthography') --> "luna1918" .
iana('Slovene in Metelko alphabet') --> "metelko" .
iana('Monotonic Greek') --> "monoton" .
iana('Ndyuka dialect') --> "ndyuka" .
iana('Natisone dialect') --> "nedis" .
iana('The Gniva dialect of Resian') --> "njiva" .
iana('Volapük nulik') --> "nulik" .
iana('The Oseacco dialect of Resian') --> "osojs" .
iana('Oxford English Dictionary spelling') --> "oxendict" .
iana('Pamaka dialect') --> "pamaka" .
iana('Petrine orthography') --> "petr1708" .
iana('Pinyin romanization') --> "pinyin" .
iana('Polytonic Greek') --> "polyton" .
iana('Puter idiom of Romansh') --> "puter" .
iana('Volapük rigik') --> "rigik" .
iana('Resian') --> "rozaj" .
iana('Rumantsch Grischun') --> "rumgr" .
iana('Scottish Standard English') --> "scotland" .
iana('Scouse') --> "scouse" .
iana('The Stolvizza dialect of Resian') --> "solba" .
iana('The Sotavento dialect group of Kabuverdianu') --> "sotav" .
iana('Surmiran idiom of Romansh') --> "surmiran" .
iana('Sursilvan idiom of Romansh') --> "sursilv" .
iana('Sutsilvan idiom of Romansh') --> "sutsilv" .
iana('Belarusian in Taraskievica orthography') --> "tarask" .
iana('Unified Cornish orthography of Revived Cornish') --> "uccor" .
iana('Unified Cornish Revised orthography of Revived Cornish') --> "ucrcor" .
iana('Ulster dialect of Scots') --> "ulster" .
iana('Unifon phonetic alphabet') --> "unifon" .
iana('Vedic Sanskrit') --> "vaidika" .
iana('Valencian') --> "valencia" .
iana('Vallader idiom of Romansh') --> "vallader" .
iana('Wade-Giles romanization') --> "wadegile" .
iana('Lojban') --> "art-lojban" .
iana('Gaulish') --> "cel-gaulish" .
iana('English, Oxford English Dictionary spelling') --> "en-GB-oed" .
iana('Amis') --> "i-ami" .
iana('Bunun') --> "i-bnn" .
iana('Default Language') --> "i-default" .
iana('Enochian') --> "i-enochian" .
iana('Hakka') --> "i-hak" .
iana('Klingon') --> "i-klingon" .
iana('Luxembourgish') --> "i-lux" .
iana('Mingo') --> "i-mingo" .
iana('Navajo') --> "i-navajo" .
iana('Paiwan') --> "i-pwn" .
iana('Tao') --> "i-tao" .
iana('Tayal') --> "i-tay" .
iana('Tsou') --> "i-tsu" .
iana('Norwegian Bokmal') --> "no-bok" .
iana('Norwegian Nynorsk') --> "no-nyn" .
iana('Belgian-French Sign Language') --> "sgn-BE-FR" .
iana('Belgian-Flemish Sign Language') --> "sgn-BE-NL" .
iana('Swiss German Sign Language') --> "sgn-CH-DE" .
iana('Mandarin or Standard Chinese') --> "zh-guoyu" .
iana('Hakka') --> "zh-hakka" .
iana('Min, Fuzhou, Hokkien, Amoy, or Taiwanese') --> "zh-min" .
iana('Minnan, Hokkien, Amoy, Taiwanese, Southern Min, Southern') --> "zh-min-nan" .
iana('Xiang or Hunanese') --> "zh-xiang" .
iana('Azerbaijani in Arabic script') --> "az-Arab" .
iana('Azerbaijani in Cyrillic script') --> "az-Cyrl" .
iana('Azerbaijani in Latin script') --> "az-Latn" .
iana('Belarusian in Latin script') --> "be-Latn" .
iana('Bosnian in Cyrillic script') --> "bs-Cyrl" .
iana('Bosnian in Latin script') --> "bs-Latn" .
iana('German, traditional orthography') --> "de-1901" .
iana('German, orthography of 1996') --> "de-1996" .
iana('German, Austrian variant, traditional orthography') --> "de-AT-1901" .
iana('German, Austrian variant, orthography of 1996') --> "de-AT-1996" .
iana('German, Swiss variant, traditional orthography') --> "de-CH-1901" .
iana('German, Swiss variant, orthography of 1996') --> "de-CH-1996" .
iana('German, German variant, traditional orthography') --> "de-DE-1901" .
iana('German, German variant, orthography of 1996') --> "de-DE-1996" .
iana('Boontling') --> "en-boont" .
iana('Scouse') --> "en-scouse" .
iana('Latin American Spanish') --> "es-419" .
iana('Inuktitut in Canadian Aboriginal Syllabic script') --> "iu-Cans" .
iana('Inuktitut in Latin script') --> "iu-Latn" .
iana('Mongolian in Cyrillic script') --> "mn-Cyrl" .
iana('Mongolian in Mongolian script') --> "mn-Mong" .
iana('Brazilian Sign Language') --> "sgn-BR" .
iana('Colombian Sign Language') --> "sgn-CO" .
iana('German Sign Language') --> "sgn-DE" .
iana('Danish Sign Language') --> "sgn-DK" .
iana('Spanish Sign Language') --> "sgn-ES" .
iana('French Sign Language') --> "sgn-FR" .
iana('British Sign Language') --> "sgn-GB" .
iana('Greek Sign Language') --> "sgn-GR" .
iana('Irish Sign Language') --> "sgn-IE" .
iana('Italian Sign Language') --> "sgn-IT" .
iana('Japanese Sign Language') --> "sgn-JP" .
iana('Mexican Sign Language') --> "sgn-MX" .
iana('Nicaraguan Sign Language') --> "sgn-NI" .
iana('Dutch Sign Language') --> "sgn-NL" .
iana('Norwegian Sign Language') --> "sgn-NO" .
iana('Portuguese Sign Language') --> "sgn-PT" .
iana('Swedish Sign Language') --> "sgn-SE" .
iana('American Sign Language') --> "sgn-US" .
iana('South African Sign Language') --> "sgn-ZA" .
iana('Natisone dialect, Nadiza dialect') --> "sl-nedis" .
iana('Resian, Resianic, Rezijan') --> "sl-rozaj" .
iana('Serbian in Cyrillic script') --> "sr-Cyrl" .
iana('Serbian in Latin script') --> "sr-Latn" .
iana('Tajik in Arabic script') --> "tg-Arab" .
iana('Tajik in Cyrillic script') --> "tg-Cyrl" .
iana('Uzbek in Cyrillic script') --> "uz-Cyrl" .
iana('Uzbek in Latin script') --> "uz-Latn" .
iana('Yiddish, in Latin script') --> "yi-Latn" .
iana('Mandarin Chinese') --> "zh-cmn" .
iana('Mandarin Chinese (Simplified)') --> "zh-cmn-Hans" .
iana('Mandarin Chinese (Traditional)') --> "zh-cmn-Hant" .
iana('Kan or Gan') --> "zh-gan" .
iana('simplified Chinese') --> "zh-Hans" .
iana('PRC Mainland Chinese in simplified script') --> "zh-Hans-CN" .
iana('Hong Kong Chinese in simplified script') --> "zh-Hans-HK" .
iana('Macao Chinese in simplified script') --> "zh-Hans-MO" .
iana('Singapore Chinese in simplified script') --> "zh-Hans-SG" .
iana('Taiwan Chinese in simplified script') --> "zh-Hans-TW" .
iana('traditional Chinese') --> "zh-Hant" .
iana('PRC Mainland Chinese in traditional script') --> "zh-Hant-CN" .
iana('Hong Kong Chinese in traditional script') --> "zh-Hant-HK" .
iana('Macao Chinese in traditional script') --> "zh-Hant-MO" .
iana('Singapore Chinese in traditional script') --> "zh-Hant-SG" .
iana('Taiwan Chinese in traditional script') --> "zh-Hant-TW" .
iana('Shanghaiese or Wu') --> "zh-wuu" .
iana('Cantonese') --> "zh-yue" .
